/*
 * Created on Nov 23, 2005
 *
 */
package gcr.mmm.ui;

import edu.berkeley.guir.prefuse.EdgeItem;
import edu.berkeley.guir.prefusex.layout.ForceDirectedLayout;

public class DynamicForceDirectedLayout extends ForceDirectedLayout {
    public static final String ATTR_SPRING = "spring";

    public DynamicForceDirectedLayout(boolean enforceBounds) {
        super(enforceBounds);
    }

    /**
     * Adjusts the spring coefficient based on a multiplier attribute ATTR_SPRING
     * 
     * @param e
     * @return scaled force value
     * @see edu.berkeley.guir.prefusex.layout.ForceDirectedLayout#getSpringCoefficient(edu.berkeley.guir.prefuse.EdgeItem)
     */
    protected float getSpringCoefficient(EdgeItem e) {
        float springMultiply = (e.getAttribute(ATTR_SPRING) != null) ? Float
                .parseFloat(e.getAttribute(ATTR_SPRING)) : 1f;
        return .00002f * springMultiply;
    }

}
