/*
 * Created on Nov 14, 2005
 *
 */
package gcr.mmm.ui;

import java.awt.GridLayout;
import java.util.Iterator;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeListener;

import edu.berkeley.guir.prefuse.graph.DefaultEdge;
import edu.berkeley.guir.prefuse.graph.Graph;
import gcr.mmm2.tag.TaggableMedia;

public class MediaSlider  {
    private int metadataType;

    private int maxValue = 0;
    
    private int cachedValue = 0;
    
    final private JPanel panel = new JPanel();

    private JSlider slider;
    
    public MediaSlider(int type, Graph graph, ChangeListener cl) {
        this.metadataType = type;

        // Get the max value for normalization
        Iterator edges = graph.getEdges();
        while (edges.hasNext()) {
            DefaultEdge edge = (DefaultEdge) edges.next();
            String overlap = edge.getAttribute("" + this.metadataType);
            if (overlap != null)
                this.maxValue = Math.max(this.maxValue, Integer.parseInt(overlap));
        }

        // Create the UI
        panel.setLayout(new GridLayout(0, 2));
        JLabel sliderLabel = new JLabel(TaggableMedia.getTagDescription(type), SwingConstants.RIGHT);
        this.slider = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 0);
        slider.addChangeListener(cl);
        
        if(this.maxValue==0)
            slider.setEnabled(false);
        
        // Turn on labels at major tick marks.
        //slider.setMajorTickSpacing(100);
        //slider.setMinorTickSpacing(25);
        //slider.setPaintTicks(true);
        //slider.setPaintLabels(true);
        //slider.setSnapToTicks(true);
        // slider.setBorder(BorderFactory.createEmptyBorder(0, 0, 10, 0));
        panel.setBorder(BorderFactory.createRaisedBevelBorder());
        panel.add(sliderLabel);
        panel.add(slider);
    }
    
    public JPanel getPanel() {
        return this.panel;
    }
   
    
    // TODO: Is this what was cauing it to freeze?  Is caching necessary?
    public int getValue() {
        if(!slider.getValueIsAdjusting()) {
            this.cachedValue = slider.getValue();
        }
        return this.cachedValue;
    }
    
    public int getType() {
        return this.metadataType;
    }
    
    public int getMaxValue() {
        return this.maxValue;
    }
    
 
}
