/*
 * Created on Sep 3, 2004
 *
 */
package gcr.mmm2.model;

import gcr.mmm2.rdb.RDBConnection;
import gcr.mmm2.rdb.ResultSetWrapper;
import gcr.mmm2.util.MMM2Properties;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URLEncoder;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import org.apache.xmlrpc.XmlRpcClient;
import org.apache.xmlrpc.XmlRpcException;

/**
 * @author jeff
 */

public class Blog {

    public static final int TYPE_BLOGGER = 0;

    public static final int TYPE_LJ = 1;

    public static final int TYPE_OTHER = 2;

    public static final String BLOGGER_API_KEY = "[PUT YOUR KEY HERE]";

    public static final String URL_BLOGGER = "http://plant.blogger.com/api/RPC2";

    public static final String URL_LJ = "http://www.livejournal.com/interface/xmlrpc"; // uses

    // LJ-specific
    // xmlrpc
    // api

    public static final String URL_LJ_BLOGGER_API = "http://www.livejournal.com/interface/blogger";

    private int m_id;

    private int m_creatorID;

    private String m_title;

    private String m_login;

    private String m_password;

    private String m_xmlrpc_url;

    private int m_blog_type;

    private String m_blog_id;

    protected Blog(int id) throws ObjectNotFoundException {
        this.m_id = id;
        String query = "select blog_title, blog_login, "
                + "blog_password, blog_id, blog_type, xmlrpc_url, user_id "
                + "from user_blog where id=" + this.m_id;
        ResultSetWrapper rsw = RDBConnection.executeQuery(query);
        ResultSet rs = rsw.getResultSet();
        try {
            if (rs.next()) {
                this.m_title = rs.getString("blog_title");
                this.m_login = rs.getString("blog_login");
                this.m_password = rs.getString("blog_password");
                this.m_blog_id = rs.getString("blog_id");
                this.m_blog_type = rs.getInt("blog_type");
                this.m_xmlrpc_url = rs.getString("xmlrpc_url");
                this.m_creatorID = rs.getInt("user_id");

                if (this.m_blog_type == TYPE_LJ)
                    this.m_xmlrpc_url = URL_LJ;
                else if (this.m_blog_type == TYPE_BLOGGER)
                    this.m_xmlrpc_url = URL_BLOGGER;

            } else {
                throw new ObjectNotFoundException("Unable to find blog(id)="
                        + id);
            }
        } catch (SQLException e) {
            e.printStackTrace();
            throw new ObjectNotFoundException("Unable to find blog(id)=" + id);
        } finally {
            rsw.closeAll();
        }

    }

    public boolean postEntry(String title, String message, HashSet photos,
            IUser poster) {

        StringBuffer entry = new StringBuffer();
        if (message != null)
            entry.append(message);

        //
        // Get all the photos and turn them into manageable objects
        //
        Iterator p_it = photos.iterator();
        while (p_it.hasNext()) {
            IPhoto cur_photo = (IPhoto) p_it.next();

            entry.append("<br><br><a href='"
                    + cur_photo.getURL(MMM2Properties.getProperty("MMM_URL"),
                            "blog", 0)
                    + "'><img src='"
                    + cur_photo.getURL(MMM2Properties.getProperty("MMM_URL"),
                            "blog_thumb", 300) + "'></a><br><em>"
                    + cur_photo.getCaption() + "</em><br>");
            // photos.add(cur_photo);//TODO: why is this here?

            IContext cur_context = cur_photo.getContext();
            if (cur_context != null) {
                ArrayList location_info = (ArrayList) cur_context
                        .getGpsLocationInfo();
                if (location_info != null) {
                    Iterator i = location_info.iterator();
                    String gps_lat = (String) i.next();
                    String gps_long = (String) i.next();
                    String city = (String) i.next();
                    String state = (String) i.next();
                    String zip = (String) i.next();

                    String map_url = "<a href='http://www.randmcnally.com/rmc/directions/dirGetMap.jsp?val=large&z=small&T="
                            + gps_lat
                            + "&N="
                            + gps_long
                            + "&h=false&CT="
                            + gps_lat
                            + "&CN="
                            + gps_long
                            + "&l=10' target='_'>Street Map</a>";
                    String img_url = "<a href='http://mapper.acme.com/?lat="
                            + gps_lat
                            + "&long="
                            + gps_long
                            + "&scale=10&theme=ColorImage&width=4&height=3&dot=Yes' target='_'>Image Map</a>";

                    if ((gps_lat != null && gps_long != null)
                            && (!gps_lat.equals("0.0") && !gps_long
                                    .equals("0.0"))) {
                        entry.append(city + ", " + state + " " + zip + "<br>");
                        entry.append("GPS: " + gps_lat + ", " + gps_long
                                + "<br>");
                        entry.append(map_url + " / " + img_url + "<br>");
                    }
                }
            }
            entry
                    .append("<hr>Posted via MMM@<a href='http://garage.sims.berkeley.edu'>Garage Cinema Research</a><br>");
        }

        XmlRpcClient xmlrpc = null;
        try {
            xmlrpc = new XmlRpcClient(this.m_xmlrpc_url);
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }

        Vector params = new Vector();
        StringBuffer resultBuffer = new StringBuffer();

        if (this.m_xmlrpc_url.equals(URL_LJ)) {

            Hashtable ljVars = new Hashtable();
            ljVars.put("username", this.m_login);
            ljVars.put("password", this.m_password);
            ljVars.put("event", entry.toString());
            ljVars.put("subject", title);

            Calendar calendar = new GregorianCalendar();
            Date date = new Date(System.currentTimeMillis());
            calendar.setTime(date);

            ljVars.put("year", calendar.get(Calendar.YEAR) + "");
            ljVars.put("mon", (calendar.get(Calendar.MONTH) + 1) + "");
            ljVars.put("day", calendar.get(Calendar.DAY_OF_MONTH) + "");
            ljVars.put("hour", calendar.get(Calendar.HOUR_OF_DAY) + "");
            ljVars.put("min", calendar.get(Calendar.MINUTE) + "");
            params.addElement(ljVars);

            try {
                Hashtable struct_result = (Hashtable) xmlrpc.execute(
                        "LJ.XMLRPC.postevent", params);

                // PARSE the result hashtable
                System.out.println("result size:" + struct_result.size());
                System.out.println("anum: " + struct_result.get("anum"));
                int anum = ((Integer) struct_result.get("anum")).intValue();
                System.out.println("itemid: " + struct_result.get("itemid"));
                int itemid = ((Integer) struct_result.get("itemid")).intValue();

                // Compute the Blog Entry URL
                // http://www.livejournal.com/users/<login>/(itemid * 256) +
                // anum +.html = url
                int urlID = (itemid * 256) + anum;
                String lj_url = "http://www.livejournal.com/users/"
                        + this.m_login + "/" + urlID + ".html";

                // add comments to affected photos
                p_it = photos.iterator();
                while (p_it.hasNext()) {
                    IPhoto cur_photo = (IPhoto) p_it.next();
                    String comment = "Blogged at <a href='" + lj_url + "'>"
                            + this.m_login + "'s</a> LiveJournal!!";
                    cur_photo.addComment(URLEncoder.encode(comment), poster);
                }
                return true;

            } catch (XmlRpcException e) {
                e.printStackTrace();
                return false;
            } catch (IOException e) {
                e.printStackTrace();
                return false;
            } catch (PermissionException e) {
                e.printStackTrace();
                return false;
            }

        }
        params.addElement(BLOGGER_API_KEY);
        params.addElement(this.m_blog_id);
        params.addElement(this.m_login);
        params.addElement(this.m_password);
        params.addElement(entry.toString());
        params.addElement(new Boolean(true));// publish

        try {
            xmlrpc.execute("blogger.newPost", params);
            // execute returns a string that we should probably read... TODO:
            // read this string
        } catch (XmlRpcException e) {
            e.printStackTrace();
            return false;
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        }
        System.out.println("result='" + resultBuffer.toString() + "'");
        return true;
    }

    public int getID() {
        return this.m_id;
    }

    public String getTitle() {
        return this.m_title;
    }

    public int getOwnerID() {
        return this.m_creatorID;
    }
}
