/*
 * Created on Oct 19, 2004
 *
 */
package gcr.mmm2.model;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

/**
 * Makes guesses for share recipients
 * 
 * @author jeff
 * 
 */
public class ClairvoyanceManager {

    /**
     * @param photo
     * @param user
     * @param max
     * @return
     */
    public static List shareGuesser(IPhoto photo, IUser user, int max) {
        // TODO: Fancy guessing

        ArrayList guesses = new ArrayList();

        // Include bluetooth rangers
        IContext context = photo.getContext();
        if (context != null) {
            guesses.addAll(context.listNearbyBluetoothPeople());
        }

        // Include previous sharers
        Iterator prevShares = ShareManager.listFrequentShareRecipients(user)
                .iterator();
        while (prevShares.hasNext()) {
            Object p = prevShares.next();
            if (!guesses.contains(p))
                guesses.add(p);
        }

        // Include contacts
        /*
         * Iterator contacts = ContactManager.listContacts(user).iterator();
         * while(contacts.hasNext()){ Object c = contacts.next();
         * if(!guesses.contains(c)) guesses.add(c); }
         */

        // Remove people already shared with
        List existingRecips = ShareManager.getPhotoRecipients(photo, user);
        guesses.removeAll(existingRecips);

        if (guesses.size() >= max)
            guesses = new ArrayList(guesses.subList(0, max));
        return guesses;
    }

    public static List shareGuesser(Collection photos, IUser user, int max) {
        // TODO: Fancy aggregate guessing
        // Takes in a collection of photos and generates aggregate guesses based
        // on weights
        return new ArrayList();
    }
}
