/*
 * Created on Aug 23, 2004
 *
 */
package gcr.mmm2.model;

import gcr.mmm2.rdb.RDBConnection;
import gcr.mmm2.rdb.ResultSetWrapper;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author jeff
 * 
 */
public class ContextManager {

    public static IContext createContext(Date timestamp) {
        int id = RDBConnection.getNextVal("context_id_seq");
        try {
            String query = "insert into context (id, sample_time) "
                    + "values (" + id + ", now())";
            RDBConnection.execute(query);
            return new ContextImpl(id);
        } catch (ObjectNotFoundException e) {
            e.printStackTrace();
            return null;
        }
    }

    public static IContext getContextByID(int id) {
        try {
            return new ContextImpl(id);
        } catch (ObjectNotFoundException e) {
            e.printStackTrace();
            return null;
        }
    }

    public static List listLocationLabels(String network, String lac,
            String cellId) {
        String query = "select distinct(location_label) from context where " +
        // "network='"+network+"' and cell_id="+cellId+" and lac="+lac;
                "cell_id=" + cellId + " and lac=" + lac;

        ResultSetWrapper rsw = RDBConnection.executeQuery(query);
        ResultSet rs = rsw.getResultSet();
        ArrayList l = new ArrayList();
        String location_label = null;
        try {
            while (rs.next()) {
                location_label = rs.getString("location_label");
                if (location_label != null)
                    l.add(rs.getString("location_label"));
            }
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            rsw.closeAll();
        }
        return l;
    }
}
