/*
 * Created on Aug 10, 2004
 *
 */
package gcr.mmm2.model;

import java.util.Date;
import java.util.List;

/**
 * This is an interface for an album object.
 * 
 * @author Simon King
 *
 */
public interface IAlbum {
	public int getID();
	public IUser getOwner();
	public int getVisibility();
	public void setVisibility(int visibility, IUser owner) throws PermissionException;
	public Date getCreateTime();
	public String getCaption();
	public void setCaption(String caption, IUser owner) throws PermissionException;
	public String getTitle();
	public void setTitle(String title, IUser owner) throws PermissionException;
	public List listPhotos();
	public void addPhoto(IPhoto photo, int sortRank, IUser owner) throws PermissionException;
	public void removePhoto(IPhoto photo, IUser owner) throws PermissionException;
	public void movePhoto(IPhoto photo, int newSortRank, IUser owner) throws PermissionException;
	public boolean containsPhoto(IPhoto photo);
	public List listComments();
	public void addComment(String comment, IUser u);
	public void removeComment(int id, IUser owner) throws PermissionException;
	public void delete(IUser owner) throws PermissionException;
	public String getURI();
	
}
