/*
 * This is an interface for a contact object.
 * Created on Aug 10, 2004
 *
 */
package gcr.mmm2.model;

import java.util.List;

/**
 * This is an interface for a contact object.
 * @author Simon King
 *
 */
public interface IContact extends IPerson {
	public IUser getOwner();
	public String getAlias();
	public void setAlias(String alias, IUser owner) throws PermissionException;
	public List listEmails();
	public EmailAddress getPrimaryEmail();
	public void addEmail(String email, IUser owner) throws PermissionException, StringFormatException;
	public void setPrimaryEmail(int id, IUser owner) throws PermissionException;
	public void removeEmail(int id, IUser owner) throws PermissionException;
	public String getPhoneNumber();
	public void setPhoneNumber(String phoneNumber, IUser owner) throws PermissionException, StringFormatException;
	public List listBluetoothDevices();
	public void removeBluetoothMAC(String BTMAC, IUser owner) throws PermissionException;
	public void addBluetoothMAC(String BTMAC, IUser owner) throws PermissionException;
	public void delete(IUser owner) throws PermissionException;
	public int getContactID(); // return the internal DB ID of contact -- get ID returns ID of person contact is based on
}
