/*
 * Created on Aug 23, 2004
 *
 */
package gcr.mmm2.model;

import java.util.List;

/**
 * This is an interface for a context object. Context includes location information and nearby bluetooth devices.
 * @author jeff
 *
 */
public interface IContext {

	/**
	 * @param cellId
	 * @param lac
	 * @param network
	 */
	public void setCellLocation(String cellId, String lac, String network);

	public String getNetwork();
	public String getCellId();
	public String getLac();
	
	/**
	 * @param gps_lat
	 * @param gps_long
	 * @param gps_speed
	 * @param gps_direction
	 */
	public void setGpsLocation(String gps_lat, String gps_long, String gps_speed, String gps_direction);
	
	/**
	 * @param btMac
	 * @param btName
	 */
	public void addBluetoothDevice(String btMac, String btName);

	/**
	 * @return
	 */
	public int getID();
	public void setLocationLabel(String locName);
	public List listLocationLabelGuesses(int numGuesses);
	public List listNearbyBluetoothPeople();
	public List listNearbyBluetoothPeopleWithMac();
	public List listUnknownBluetoothDevices();
	public String getLocationLabel();
	public List getGpsLocationInfo();
	public String getGpsLatitude();
	public String getGpsLongitude();
	
}
