/*
 * Created on Aug 10, 2004
 *
 */
package gcr.mmm2.model;

import java.util.Date;
import java.util.List;

/**
 * This is an interface for a photo object.
 * 
 * @author Simon King
 * 
 */
public interface IPhoto {
    static final int PRIVATE_VISIBILITY = 0;

    static final int SHARE_VISIBILITY = 1;

    static final int PUBLIC_VISIBILITY = 2;

    // Privacy Levels
    public static final int UNRESTRICTED_PRIVACY = 0;

    public static final int RESTRICTED_PRIVACY = 1;

    public static final int PUBLIC_PRIVACY = 2;

    public int getID();

    public String getJPEGFilename();

    public String getJPEGThumbFilename();

    public void setJPEGThumbFilename(String filename, IUser owner)
            throws PermissionException;

    public String getBMPFilename();

    public void setBMPFilename(String filename, IUser owner)
            throws PermissionException;

    public IUser getOwner();

    public IPerson getPhotographer();

    public void setPhotographer(IPerson phtographer, IUser owner)
            throws PermissionException;

    public int getVisibility();

    public void setVisibility(int visibility, IUser owner)
            throws PermissionException;

    // public IContext getContext();
    public String getCaption();

    public void setCaption(String caption, IUser owner)
            throws PermissionException;

    public String getTitle();

    public void setTitle(String title, IUser owner) throws PermissionException;

    public List listComments();

    public void addComment(String comment, IUser u) throws PermissionException;

    public void removeComment(int id, IUser owner) throws PermissionException;

    public Date getCaptureDate();

    public Date getUploadDate();

    public List listAlbums();

    public void delete(IUser owner) throws PermissionException;

    public String getTag();

    public void setTag(String tag, IUser owner) throws PermissionException;

    // place is temporary
    public String getPlace();

    public void setPlace(String place, IUser owner) throws PermissionException;

    public String getURL(String base, String code, int size);

    public String getURL(String base, String code, int width, int height);
    
    public String getURL(String base, String code, int width, int height, boolean crop);

    public String getURI();

    public void unshare(IUser user);

    public void clearCachedImages();

    // Restrictions
    public int getPrivacyLevel(IUser owner) throws PermissionException;

    public void setPrivacyLevel(int level, IUser owner)
            throws PermissionException;

    public boolean isPublic();

    // TODO: annotations, contexts, events
    /**
     * @param context
     */
    public void setContext(IContext context, IUser owner)
            throws PermissionException;

    public IContext getContext();
   
}
