/*
 * Created on Aug 10, 2004
 *
 */
package gcr.mmm2.model;

import java.io.IOException;
import java.util.List;

/**
 * This in an interface for a User object. A user would be a person who actually
 * takes pictures and has an account.
 * 
 * @author Simon King
 */
public interface IUser extends IPerson { // TODO: should this extend contact?
    public void addBlog(String name, String username, String password,
            String xmlrpc_url, String blogNumber, int blogType, IUser owner)
            throws PermissionException;

    public void addBluetoothMAC(String BTMAC, IUser owner)
            throws PermissionException;

    public void addEmail(String email, IUser owner) throws PermissionException,
            StringFormatException;

    public boolean changePassword(String oldPass, String newPass, IUser owner)
            throws PermissionException;

    public boolean checkPassword(String testPassword);

    public boolean getEmailNotify();

    public String getHeadshotImagePath();

    public String getMobileCarrier();

    public String getPhoneID();

    public String getPhoneNumber();

    public EmailAddress getPrimaryEmail();

    public String getRDFNameSpace();

    public int getRDFNameSpaceID();

    public EmailAddress getSmsEmail();

    public boolean getSmsNotify();

    public String getUploadDirectory() throws IOException;

    public String getUsername();

    public List listAlbums();

    public List listBlogs();

    public List listBluetoothDevices();

    public List listEmails();

    public void removeBlog(int id, IUser owner) throws PermissionException;

    public void removeBluetoothMAC(String BTMAC, IUser owner)
            throws PermissionException;

    public void removeEmail(int id, IUser owner) throws PermissionException;

    public void resetPassword(IUser owner) throws PermissionException;

    public void setEmailNotify(boolean setting);

    public void setHeadshotImagePath(String imageFilename, IUser owner)
            throws PermissionException;

    public void setMobileCarrier(String mobileCarrier, IUser owner)
            throws PermissionException, StringFormatException;

    public void setPhoneID(String phoneID, IUser owner)
            throws PermissionException;

    public void setPhoneNumber(String phoneNumber, IUser owner)
            throws PermissionException, StringFormatException;

    public void setPrimaryEmail(int id, IUser owner) throws PermissionException;

    public void setRDFNameSpaceID(int namespace_id, IUser owner)
            throws PermissionException;

    public void setSmsNotify(boolean setting);
}
