/*
 * Created on Aug 25, 2004
 *
 */
/**
 * This object creates a filter from a directory that filters out all files that do not have the same
 * ending as a given ending string.
 */
package gcr.mmm2.model;

import java.io.File;
import java.io.FilenameFilter;

public class ImageFileFilter implements FilenameFilter {
	private String m_endsWith;
	private File m_dir;
	protected ImageFileFilter (File dir, String endsWith) {
		m_endsWith=endsWith;
		m_dir=dir;
	}
	
	public boolean accept(File dir, String name) {
		if (m_endsWith.length()<8) { // to be extra safe
			return false;
		}
		return (m_dir.equals(dir) && name.endsWith(m_endsWith));
	}
}