package gcr.mmm2.model;

/**
 * Represents an EXIF or other metadata tag of a JPEG image.
 * Each tag has a directory ("Exif," "Jpeg," etc.), name ("Date/Time"), and description (the value)
 * 
 * @author Mike Wooldridge
 * 
 */
public class JpegMetadataTag {

	private String m_directory;
	private String m_name;
	private String m_description;
	
	public JpegMetadataTag (String directory, String name, String description) {
		m_directory = directory;
		m_name = name;
		m_description = description;
	}
	
	public JpegMetadataTag (String directory, String name) {
		m_directory = directory;
		m_name = name;
		m_description = "";
	}
	
	public String getDirectory() {
		return m_directory;
	}
	
	public String getName() {
		return m_name;
	}
	
	public String getDescription() {
		return m_description;
	}
	
	public String getTagInfo() {
		// For debugging
		return "dir: " + getDirectory() + " name: " + getName() + " desc: " + getDescription();
	}	
}
