/*
 * Created on Aug 10, 2004
 *
 */
package gcr.mmm2.model;

import gcr.mmm2.rdb.RDBConnection;
import gcr.mmm2.rdb.ResultSetWrapper;
import gcr.rdf.MMMModelFactory;
import gcr.mmm2.util.StringUtils;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Implementation of code to keep track of person.
 * @author Simon King
 * 
 */
public class PersonImpl implements IPerson {
    private String m_firstName;

    private String m_lastName;

    private int m_id;

    protected PersonImpl(int id) throws ObjectNotFoundException {
        m_id = id;
        String query = "select first, last from person where id=" + m_id;
        ResultSetWrapper rsw = RDBConnection.executeQuery(query);
        ResultSet rs = rsw.getResultSet();
        try {
            if (rs.next()) {
                m_firstName = rs.getString("first");
                m_lastName = rs.getString("last");
            } else {
                throw new ObjectNotFoundException("Unable to find person(id)="
                        + m_id);
            }
        } catch (SQLException e) {
            e.printStackTrace();
            throw new ObjectNotFoundException("Unable to find person(id)="
                    + m_id);
        } finally {
            rsw.closeAll();
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see gcr.mmm2.model.IPerson#getID()
     */
    public int getID() {
        return m_id;
    }

    /*
     * (non-Javadoc)
     * 
     * @see gcr.mmm2.model.IPerson#getFirstName()
     */
    public String getFirstName() {
        return StringUtils.URLDecode(m_firstName);
    }

    /*
     * (non-Javadoc)
     * 
     * @see gcr.mmm2.model.IPerson#getLastName()
     */
    public String getLastName() {
        return StringUtils.URLDecode(m_lastName);
    }

    public String getURI() {
        return MMMModelFactory.BASE_URI + "person/" + m_id;
    }

    public String toString() {
        return StringUtils.URLDecode(getFirstName() + " " + getLastName());
    }

    /*
     * (non-Javadoc)
     * 
     * @see gcr.mmm2.model.IPerson#setFirstName()
     */
    public void setFirstName(String firstName) {
        PersonManager.setFirstName(this, firstName);
        m_firstName = StringUtils.URLEncode(firstName);
    }

    /*
     * (non-Javadoc)
     * 
     * @see gcr.mmm2.model.IPerson#setLastName()
     */
    public void setLastName(String lastName) {
        PersonManager.setLastName(this, lastName);
        m_lastName = StringUtils.URLEncode(lastName);
    }
}
