/*
 * Created on Aug 15, 2005
 *
 */

package gcr.mmm2.model;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * Class that generates an RSS file
 * @author Mike Wooldridge
 * 
 */
public class RSS {
	
	private String title;
	private String description;
	private String link;
	private String language;
	private ArrayList items = new ArrayList();
	
	private String result;

	public RSS(String title, String description, String link) {
		   
  	    	  setTitle(title);
  	    	  setDescription(description);
  	    	  setLink(link);
  	    	  setLanguage("en-us");
  	    	  
	}
	  
	public String getResult() {
		   
    	  result = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
    	  result = result + "<rss version=\"0.93\">\n";
    	  result = result + "<channel>\n";
    	  result = result + "<title>" + getTitle() + "</title>\n";
    	  result = result + "<description>" + getDescription() + "</description>\n";
    	  result = result + "<link>" + getLink() + "</link>\n";
    	  result = result + "<language>" + getLanguage() + "</language>\n";
    	  
    	  Iterator itemsIter = items.iterator();
    	  while(itemsIter.hasNext()) {
    		  RSSItem item = (RSSItem) itemsIter.next();
    		  result = result + item.getResult();
    	  }
    	  
    	  result = result + "</channel>\n";
    	  result = result + "</rss>\n";

		  return result;
	  }

	  public void setTitle(String title) {
		  this.title = title;
	  }

	  public String getTitle() {
		  return title;
	  }

	  public void setDescription(String description) {
		  this.description = description;
	  }

	  public String getDescription() {
		  return description;
	  }

	  public void setLink(String link) {
		  this.link = link;
	  }

	  public String getLink() {
		  return link;
	  }

	  public void setLanguage(String language) {
		  this.language = language;
	  }

	  public String getLanguage() {
		  return language;
	  }

	  public void addItem(String title, String link) {
		 RSSItem item = new RSSItem(title, link);
		 items.add(item);
	  }

	  public void addItem(String title, String link, String description) {
			 RSSItem item = new RSSItem(title, link, description);
			 items.add(item);
	  }

}
