/*
 * Created on Aug 18, 2005
 *
 */
package gcr.mmm2.model;

import gcr.mmm2.rdb.RDBConnection;
import gcr.mmm2.rdb.ResultSetWrapper;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.*;

/**
 * Methods for generating stats about MMM.
 * 
 * @author Mike Wooldridge
 * 
 */
public class StatsFactory {

    public static ArrayList getResult(String query, int cols) {
        ResultSetWrapper rsw = RDBConnection.executeQuery(query);
        ResultSet rs = rsw.getResultSet();
        ArrayList result = new ArrayList();
        
        /* testing code to get row count  
        try{
            rs.last();
            System.out.println("This resultset count is " + rs.getRow());
            rs.beforeFirst();
        }catch(SQLException se)
        {}
        */
        
        try {
            while (rs.next()) {
            	ArrayList row = new ArrayList();
            	for (int i=1;i<=cols;i++) { // cols start at 1
            		row.add(rs.getString(i));
            	}
                result.add(row);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            rsw.closeAll();
        }
        return result;
    }
    
    public static String getResultAsHTMLTable(ArrayList result, String style) {
    	String table = "";
    	Iterator resultIter = result.iterator();
    	table = "<table border=1 class=\"" + style + "\">";
    	while(resultIter.hasNext()) {
    		ArrayList row = (ArrayList) resultIter.next();
    		Iterator rowIter = row.iterator();
    		table = table + "<tr>";
        	while(rowIter.hasNext()) {
        		String item = (String) rowIter.next();
        		table = table + "<td>" + item + "</td>";
        	}
    		table = table + "</tr>";
    	}
    	table = table + "</table>";
    	return table;
    }
}
