package gcr.mmm2.server;

import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;
import gcr.mmm2.model.*;
import java.io.*;

public class SessionStartListener implements HttpSessionListener
{

    public void sessionCreated(HttpSessionEvent arg0)
    {
        System.out.println("Started user session");
        // TODO Auto-generated method stub
        arg0.getSession().setAttribute("uiState",new UIState() );
    }

    public void sessionDestroyed(HttpSessionEvent arg0)
    {
        // since the session is being serialized on changes
        // probably doesn't need to be serialized on exit
        // serializeSession(arg0);
        System.out.println("Stopped user session");
        // TODO Auto-generated method stub
        arg0.getSession().removeAttribute("uiState");

    }
    
    public static void serializeSession(HttpSessionEvent arg0)
    {
        System.out.println("Serialized Session Settings");
        UIState state = (UIState)arg0.getSession().getAttribute("uiState");
        
        String fileToSave = MediaManager.ORIG_IMAGE_DIR + "/" + 
            state.getUserID() + "/settings.ser";
        
        if(state==null)
        {
            System.out.println("the state is null");
        }else{
            ObjectOutputStream oos = null;
            // Create output stream.
            try{
                oos = new ObjectOutputStream(
                        new FileOutputStream(fileToSave));
    
            }catch(FileNotFoundException fnf)
            {
                System.out.println("FileNotFound Exceception");
            }catch(IOException ioe){
                System.out.println("IOExecption");
            }
    
            try{
                oos.writeObject(state);
                oos.close();
            }catch(IOException ioe)
            {
                System.out.println("Couldn't flush or close files!");
            }        
        }
    }

}
