/*
 * Created on Sep 16, 2004
 *
 */
package gcr.mmm2.server.mail;

import java.io.UnsupportedEncodingException;
import java.util.Properties;

import javax.mail.Address;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

/**
 * @author jeff
 * 
 */
public class NotificationMailer {

	// TODO: Set from config file
	private static final String SMTP_HOST = "[YOUR HOST]";

	public static void sendTextMsg(String senderAddress, String recipAddress, String subject, String messageText){
	    
		MimeMultipart mmp = new MimeMultipart();

	    try {
		    MimeBodyPart textPart = new MimeBodyPart();
	    		textPart.setContent(messageText, "text/plain");
		    mmp.addBodyPart(textPart);
		} catch (MessagingException e) {
			e.printStackTrace();
		}
	    sendMsg(senderAddress, recipAddress, subject, mmp);
	}
	
	public static void sendHtmlMsg(String senderAddress, String recipAddress, String subject, String messageText, String messageHTML){
	    
		MimeMultipart mmp = new MimeMultipart("alternative");

	    try {
		    MimeBodyPart textPart = new MimeBodyPart();
		    textPart.setContent(messageText, "text/plain");
			mmp.addBodyPart(textPart);
		} catch (MessagingException e) {
			e.printStackTrace();
		}
		
	    try {
		    MimeBodyPart htmlPart = new MimeBodyPart();
		    htmlPart.setContent(messageHTML, "text/html");
		    htmlPart.setHeader("Content-Transfer-Encoding", "quoted-printable");
			mmp.addBodyPart(htmlPart);
		} catch (MessagingException e) {
			e.printStackTrace();
		}
		
		sendMsg(senderAddress, recipAddress, subject, mmp);
	}
	
	public static void sendMsg(String senderAddress, String recipAddress, String subject, MimeMultipart msgContent){

	    // Get system properties
	    Properties props = System.getProperties();

	    // Setup mail server
	    props.put("mail.smtp.host", SMTP_HOST);
	    try {
	    	
		    Address replyToList[] = { new InternetAddress(senderAddress) };
	
		    // Get session
		    Session session = Session.getDefaultInstance(props, null);
	
		    // Define message
		    MimeMessage message = new MimeMessage(session);

			// Set the from address
			message.setFrom(new InternetAddress(senderAddress, senderAddress));
			
			// Set the reply-to
			message.setReplyTo(replyToList);
			
		    // Set the to address
		    message.addRecipient(Message.RecipientType.TO, new InternetAddress(recipAddress));

		    // Set the subject
		    message.setSubject(subject);

		    // Set the content
		    //message.setText(messageText);
		    message.setContent(msgContent);

		    // Send message
		    Transport.send(message);
		    
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (MessagingException e) {
			e.printStackTrace();
		}
	}
}