package gcr.mmm2.util;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

public class MMM2Properties{
	
	private static Properties properties;
	
	//Mac OSX
	//private final static String CONF_FILE = "~/dev/resin/webapps/ROOT/WEB-INF/mmm2.conf";
	
	//Linux
	//private final static String CONF_FILE = "/usr/local/resin/webapps/ROOT/WEB-INF/mmm2.conf";
	
	//Windows
	private final static String CONF_FILE = "/resin/webapps/ROOT/WEB-INF/mmm2-windows.conf";
	
	public MMM2Properties(){
		//constructor
		//do nothing
	}
	
	public static String getProperty(String props) {
		
		if(properties==null){
			
			properties = new Properties();
			
			String confFile = System.getProperty("gcr.mmm.conf");
			if(confFile == null)
				confFile = CONF_FILE;
			try {
				FileInputStream fis = 
					new FileInputStream(confFile);
				properties.load(fis);
			} 
			catch (IOException e) {
				System.out.println("ERROR Loading Properties File: " + e.getLocalizedMessage());
			}
		}

		return properties.getProperty(props); 		
	}
	
	public static void flushProperties(){
		properties = null;
	}
}	
