/*
 * Created on Jul 12, 2004
 *
 */
package gcr.mmm2.util;

import com.hp.hpl.jena.db.DBConnection;
import com.hp.hpl.jena.db.IDBConnection;
import com.hp.hpl.jena.ontology.OntDocumentManager;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntModelSpec;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.ModelMaker;

/**
 * @author jeff
 *
 */
public class ResetJenaDB {
   	static String FILE_PATH_HACK = "/gcr-projects/resin-ee-3.0.8/webapps/mmm2v1/WEB-INF"; //props.getProperty("FILE_PATH_HACK");
   
	//static String FILE_PATH_HACK = "/eclipse/workspace/mmm2v1/"; //props.getProperty("FILE_PATH_HACK"); 
	static String DB_URL= "jdbc:postgresql://red.sims.berkeley.edu/jena1"; //props.getProperty("DB_URL"); 
	static String DB_USER = "simonpk"; //props.getProperty("DB_USER"); 
	static String DB_PASSWD = "PASSWORD"; //props.getProperty("DB_PASSWD"); 
	static String DB = "PostgreSQL"; //props.getProperty("DB"); 
	static String className = "org.postgresql.Driver"; //props.getProperty("className"); 
	
//   static String DB_URL= props.getProperty("DB_URL"); 
//   static String DB_USER = props.getProperty("DB_USER"); 
//   static String DB_PASSWD = props.getProperty("DB_PASSWD"); 
//   static String DB = props.getProperty("DB"); 
//   static String className = props.getProperty("className"); 
//	public static final String DB_URL = "jdbc:postgresql://localhost/mmm2";// URL of database server
//	public static final String DB_USER = "test";// database user id
//	public static final String DB_PASSWD = "";// database password
//	public static final String DB = "PostgreSQL"; // database type

//	public static final String ONT_MASTER = "http://garage.sims.berkeley.edu/mmm-2/ontology/master";
//	public static final String ONT_MMM2 = "http://garage.sims.berkeley.edu/mmm-2/ontology";
//	public final static String FOAF = "http://xmlns.com/foaf/0.1/";
	public static final String ONT_MASTER = "http://garage.sims.berkeley.edu/mmm-2/ontology/master";
	public static final String ONT_MMM2 = "http://garage.sims.berkeley.edu/mmm-2/ontology";
	public static final String ONT_EXTENSION1 = "http://garage.sims.berkeley.edu/mmm-2/ontology/extension1";
	
	public final static String BASE_URI = "http://garage.sims.berkeley.edu/mmm-2/ontology#";
	public final static String FOAF = "http://xmlns.com/foaf/0.1/";
	
	//public final static String BASE_URI = "http://garage.sims.berkeley.edu/mmm-2/ontology#";

	public static void main(String[] args) {
		ModelMaker maker = getMaker();

		// clear out the old
		if (maker.hasModel(ONT_MASTER))
			maker.removeModel(ONT_MASTER);
//		if (maker.hasModel(ONT_MMM2))
//			maker.removeModel(ONT_MMM2);

		// create a spec for the new ont model
		OntModelSpec spec = new OntModelSpec(OntModelSpec.OWL_MEM_RULE_INF);
		spec.setModelMaker(maker);

		// create the base model as a persistent model
		Model base = maker.createModel(ONT_MASTER);
		//Model base = maker.createModel(ONT_MMM2);
		OntModel m = ModelFactory.createOntologyModel(spec, base);
		OntDocumentManager dm = m.getDocumentManager();

		// tell m where to find the content for ont2
		//dm.addAltEntry(ONT_MMM2, "file:ontologies/mmm2.owl");
		dm.addAltEntry(ONT_MASTER, "file:ontologies/master.owl");
		dm.addAltEntry(FOAF, "file:ontologies/foaf.rdf");
		dm.addAltEntry(ONT_EXTENSION1, "file:ontologies/mmm2extension1.owl");
		dm.addAltEntry(ONT_MMM2, "file:ontologies/mmm2base2.owl");
		// now load the document for test1, which will import ONT2
		m.read(ONT_MASTER);
		//m.read(ONT_MMM2);
	}
	
	protected static ModelMaker getMaker() {
		try {
			// Load the Driver
			//String className = "org.postgresql.Driver";
			Class.forName(className);

			// Create database connection
			IDBConnection conn =
				new DBConnection(DB_URL, DB_USER, DB_PASSWD, DB);

			// Create a model maker object
			return ModelFactory.createModelRDBMaker(conn);
			//return ModelFactory.
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}

		return null;
	}
}
