/*
 * Created on Jun 23, 2005
 *
 */
package gcr.mmm2.util;

/**
 * @author sbfisher
 *
 */
public class TwoSideBox
{
	private int width;
	private int height;
	
	/**
	 * @param width
	 * @param height
	 */
	public TwoSideBox(int width, int height) {
		super();
		this.width = width;
		this.height = height;
	}
	
	
	/**
	 * @return Returns the height.
	 */
	public int getHeight() {
		return height;
	}
	/**
	 * @param height The height to set.
	 */
	public void setHeight(int height) {
		this.height = height;
	}
	/**
	 * @return Returns the width.
	 */
	public int getWidth() {
		return width;
	}
	
	/**
	 * @param width The width to set.
	 */
	public void setWidth(int w) {
		this.width = w;
	}
	
	public TwoSideBox getSizeForFittingInsideMe(TwoSideBox otherBox)
	{
		// width of Big (otherbox) to Small (me)
		double widthRatio = (double)otherBox.width/(double)this.width;
		double heightRatio = (double)otherBox.height/(double)this.height;
		
		int targetWidth = otherBox.width;
		int targetHeight = otherBox.height;
		if(widthRatio>heightRatio)
		{
			widthRatio = 1/widthRatio;
			targetWidth = (int)(otherBox.width * widthRatio);
			targetHeight = (int)(otherBox.height * widthRatio);
		}else{
			heightRatio = 1/heightRatio;
			targetWidth = (int)(otherBox.width * heightRatio);
			targetHeight = (int)(otherBox.height * heightRatio);
		}
		
		return new TwoSideBox(targetWidth,targetHeight);
	}
    
    public TwoSideBox getSizeForFittingOutsideMe(TwoSideBox otherBox)
    {
        // width of Big (otherbox) to Small (me)
        double widthRatio = (double)otherBox.width/(double)this.width;
        double heightRatio = (double)otherBox.height/(double)this.height;
        
        int targetWidth = otherBox.width;
        int targetHeight = otherBox.height;
        if(widthRatio<heightRatio)
        {
            widthRatio = 1/widthRatio;
            targetWidth = (int)(otherBox.width * widthRatio);
            targetHeight = (int)(otherBox.height * widthRatio);
        }else{
            heightRatio = 1/heightRatio;
            targetWidth = (int)(otherBox.width * heightRatio);
            targetHeight = (int)(otherBox.height * heightRatio);
        }
        
        return new TwoSideBox(targetWidth,targetHeight);
    }
}
