/*
 * Created on Sep 20, 2004
 *
 */
package gcr.rdf;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Iterator;

/**
 * @author Simon King
 *
 */
public class LoadRelationalEntities {
	// TODO -- fix bad hardcoded things
	static String DB_URL= "jdbc:postgresql://red.sims.berkeley.edu/test4"; //props.getProperty("DB_URL"); 
	static String DB_USER = "simonpk"; //props.getProperty("DB_USER"); 
	static String DB_PASSWD = "PASSWORD"; //props.getProperty("DB_PASSWD"); 
	static String DB = "PostgreSQL"; //props.getProperty("DB"); 
	static String className = "org.postgresql.Driver";

	public static void main(String[] args) {
		// connect  to DB
		Connection dbConnection=null;
		try {
			Class.forName(className);   
			dbConnection=DriverManager.getConnection(DB_URL, DB_USER, DB_PASSWD);
			DatabaseMetaData dbMetaData=dbConnection.getMetaData();
			System.out.println("Database: "+dbMetaData.getDatabaseProductName());
			System.out.println("Version: "+dbMetaData.getDatabaseProductVersion());
		}
		catch (ClassNotFoundException e) {
			System.err.println("Error loading driver: "+e);
		}
		catch (SQLException e) {
			System.err.println("Error in connection: "+e.getMessage());
		}
		
		System.out.println("Adding person IDs from relational DB:");
		String query="select id from person";
		Statement stmt = null;
		ResultSet rs=null;
		try {
			stmt = dbConnection.createStatement();
			rs = stmt.executeQuery(query);
			while (rs.next()) {
				int id=rs.getInt("id");
				String newURI=MMMModelFactory.BASE_URI+"person/"+id;
				if (ResourceManipulator.createIndividual(newURI, ResourceManipulator.PERSON_ID_CLASS_URI)!=null){
					System.out.println("\tadded "+id);
				} else {
					System.out.println("\t! "+id+" was skipped!");
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e1) {
					e1.printStackTrace();
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e1) {
					e1.printStackTrace();
				}
			}
		}
		
		// photos
		System.out.println("Adding photo IDs from relational DB:");
		query="select id from photo";
		try {
			stmt = dbConnection.createStatement();
			rs = stmt.executeQuery(query);
			while (rs.next()) {
				int id=rs.getInt("id");
				String newURI=MMMModelFactory.BASE_URI+"photo/"+id;
				if (ResourceManipulator.createIndividual(newURI, ResourceManipulator.PHOTO_ID_CLASS_URI)!=null){
					System.out.println("\tadded "+id);
				} else {
					System.out.println("\t! "+id+" was skipped!");
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e1) {
					e1.printStackTrace();
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e1) {
					e1.printStackTrace();
				}
			}
		}
		
//		 albums
		System.out.println("Adding album IDs from relational DB:");
		query="select id from album";
		try {
			stmt = dbConnection.createStatement();
			rs = stmt.executeQuery(query);
			while (rs.next()) {
				int id=rs.getInt("id");
				String newURI=MMMModelFactory.BASE_URI+"album/"+id;
				if (ResourceManipulator.createIndividual(newURI, ResourceManipulator.ALBUM_ID_CLASS_URI)!=null){
					System.out.println("\tadded "+id);
				} else {
					System.out.println("\t! "+id+" was skipped!");
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e1) {
					e1.printStackTrace();
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e1) {
					e1.printStackTrace();
				}
			}
		}
		
		if (dbConnection != null) {
			try {
				dbConnection.close();
			} catch (Exception ignored) {}
		}
		
		System.out.println("Person IDs:");
		printIterator(ResourceManipulator.listClassMembers(ResourceManipulator.PERSON_ID_CLASS_URI));
		System.out.println("Photo IDs:");
		printIterator(ResourceManipulator.listClassMembers(ResourceManipulator.PHOTO_ID_CLASS_URI));
		System.out.println("Album IDs:");
		printIterator(ResourceManipulator.listClassMembers(ResourceManipulator.ALBUM_ID_CLASS_URI));
		
	}
	
	public static void printIterator(Iterator i){
		
		if(i == null){return;}

		while(i.hasNext()){
			System.out.println("\t" + i.next());	
		}
	}
}
