/*
 * Created on Jun 15, 2004
 */
package gcr.rdf;
import gcr.mmm2.model.ObjectSorter;
import gcr.mmm2.util.MMM2Properties;
import gcr.mmm2.rdb.RDBConnection;
import gcr.mmm2.rdb.ResultSetWrapper;

import java.sql.ResultSet;
import java.sql.SQLException;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.hp.hpl.jena.db.DBConnection;
import com.hp.hpl.jena.db.ModelRDB;
import com.hp.hpl.jena.ontology.OntDocumentManager;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntModelSpec;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Selector;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.reasoner.rulesys.GenericRuleReasoner;
import com.hp.hpl.jena.reasoner.rulesys.GenericRuleReasonerFactory;
import com.hp.hpl.jena.vocabulary.ReasonerVocabulary;

/**
 * @author Simon King
 *
 */
    //static MMM2Properties props = new MMM2Properties(); 
public class MMMModelFactory {
	//necessary for Resin?  TODO: try to remove this bs
    // TODO -- BAD! FILE_PATH_HACK -- and bad hard-coded DB connection stuff
    //static String FILE_PATH_HACK = "/gcr-projects/resin-ee-3.0.8/webapps/mmm2v1/WEB-INF"; //props.getProperty("FILE_PATH_HACK");
    static String DB_URL= "jdbc:postgresql://red.sims.berkeley.edu/jena1"; //props.getProperty("DB_URL"); 
	static String DB_USER = "simonpk"; //props.getProperty("DB_USER"); 
	static String DB_PASSWD = "PASSWORD"; //props.getProperty("DB_PASSWD"); 
	
	static String ONTOLOGY_DIR = MMM2Properties.getProperty("ONTOLOGY_DIR");
	
	static String DB = "PostgreSQL"; //props.getProperty("DB"); 
    static String className = "org.postgresql.Driver"; //props.getProperty("className"); 
	
	public static final String ONT_MASTER = "http://garage.sims.berkeley.edu/mmm-2/ontology/master";
	public static final String ONT_MMM2 = "http://garage.sims.berkeley.edu/mmm-2/ontology";
	public static final String ONT_EXTENSION1 = "http://garage.sims.berkeley.edu/mmm-2/ontology/extension1";
	public static final String ONT_EXTENSION0 = "http://garage.sims.berkeley.edu/mmm-2/ontology/extension0";
	public static final String ONT_RDFS = "http://www.w3.org/2000/01/rdf-schema";
				
	public final static String BASE_URI = "http://garage.sims.berkeley.edu/mmm-2/ontology#";
	public final static String BASE_URI2 = ""; // TODO -- fix this hack
	public final static String FOAF = "http://xmlns.com/foaf/0.1/";
	
	public final static String NS_RDFS="http://www.w3.org/2000/01/rdf-schema#";
	public final static String NS_RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#";
	public final static String NS_MMM_BASE="http://garage.sims.berkeley.edu/mmm-2/ontology#";
	public final static String RDFS_PROP_SUBCLASS="subClassOf";
	public final static String RDFS_PROP_DOMAIN="domain";
	public final static String RDFS_PROP_RANGE="range";
	public final static String RDFS_PROP_LABEL="label";
	public final static String RDF_PROP_TYPE="type";
	public final static String MMM_PROP_SORTORDER="sortOrder";
	public final static String MMM_PROP_SUBJECT_URI="subject";
	public final static String MMM_PROP_INCLUDECONCISE="includeInConciseView";
	public final static String MMM_PROP_CREATOR_URI="creator";
	public final static String MMM_PROP_EDIT_SUBJECT_URI="editSubject";
	public final static String MMM_PROP_HIDDEN_URI="hidden";
	public final static String MMM_PROP_TIMESTAMP_URI="timestamp";
	
	public final static String TYPE_MMM_PHOTO="http://garage.sims.berkeley.edu/mmm-2/ontology#photoID";
	public final static String TYPE_MMM_PERSON="http://garage.sims.berkeley.edu/mmm-2/ontology#mmmPersonID";
	public final static String TYPE_MMM_ALBUM="http://garage.sims.berkeley.edu/mmm-2/ontology#albumID";
	public final static String TYPE_MMM_TAXONOMY_ITEM="http://garage.sims.berkeley.edu/mmm-2/ontology#taxonomyItem";
	public final static String TYPE_MMM_ANNOTATION_BASE="http://garage.sims.berkeley.edu/mmm-2/ontology#annotationBase";
	public final static String TYPE_MMM_BASE="http://garage.sims.berkeley.edu/mmm-2/ontology#mmmBase";
	public final static String TYPE_OWL_CLASS="http://www.w3.org/2002/07/owl#Class";
	public final static String TYPE_OWL_DATATYPE_PROP="http://www.w3.org/2002/07/owl#DatatypeProperty";
	public final static String TYPE_RDFS_RESOURCE="http://www.w3.org/2000/01/rdf-schema#Resource";
	
	public final static String URI_ANNOTATION_BASE="http://garage.sims.berkeley.edu/mmm-2/ontology#annotationBase";
	
	private static MMMModelFactory m_mf;
	private OntModel m_model;
	private HashMap m_propMap, m_classMap, m_annotClassMap, m_labelMap, m_typeMap, 
					m_superclassMap, m_taxonomyMap, m_subclassMap, m_rangeMap, m_allTypesMap,
					m_ontMap;
	private TaxonomyNode m_taxRoot;
	//TODO -- are there syncronization issues in building the maps?
	//TODO -- can get properties by URI, don't need to split namespace and localName
	private Logger logger;
	// m_propMap has PropertyDescriptor objects keyed on prop URI
	// m_classMap has List of sorted PropertyDescriptors for UI-visble props keyed on classURI
	
	public static MMMModelFactory getInstance(){
		if(m_mf == null){
			m_mf = new MMMModelFactory();	
		}	
		
		return m_mf;
	}
	
	private MMMModelFactory() {
		logger=Logger.getLogger("gcr.rdf.MMMModelFactory");
		try {
			FileHandler handler=new FileHandler("/modelfactory.log");
			handler.setLevel(Level.INFO);
			logger.addHandler(handler);
		} catch (IOException ignored) {}
	}
	
	
	// return a map of lists, indexed by namespace.  lists contain uris of annotation classes in that namespace
	public Map getAnnotClassMap() {
		if (m_annotClassMap != null) {
			return m_annotClassMap;
		}
		m_annotClassMap=new HashMap();
		Property pSubClass=getOntModel().createProperty(NS_RDFS, RDFS_PROP_SUBCLASS);
		Resource rAnnotationBase= getOntModel().createResource(URI_ANNOTATION_BASE);
		//logger.info("prop="+pSubClass.toString()+", annotBaseURI="+rAnnotationBase.toString());
		StmtIterator i = getOntModel().listStatements((Resource)null, pSubClass, rAnnotationBase);
		//StmtIterator i = getOntModel().listStatements((Resource)null, (Property)null, rAnnotationBase);
		
		while (i.hasNext()){
			Statement s=(Statement)i.next();
			//logger.info("Statement="+s.toString());
			Resource r=s.getSubject();
			if (r!=null && !r.equals(rAnnotationBase)) {
				String ns=r.getNameSpace();
				String uri=r.getURI();
				List l=null;
				if (m_annotClassMap.containsKey(ns)) {
					l=(List)m_annotClassMap.get(ns);
				} else {
					l=new ArrayList();
				}
				l.add(uri);
				m_annotClassMap.put(ns, l);
				//logger.info(ns+" - "+ uri);
			}
		}
		return m_annotClassMap;
	}
	
	private Set getSuperClasses(Set c) {
		Set rtnSet=new HashSet();
		Property pSubClass=getOntModel().createProperty(NS_RDFS, RDFS_PROP_SUBCLASS);
		Iterator i=c.iterator();
		while (i.hasNext()) {
			String uri=(String)i.next();
			Resource r= getOntModel().createResource(uri);
			////logger.info("prop="+pSubClass.toString()+", annotBaseURI="+rAnnotationBase.toString());
			StmtIterator si = getOntModel().listStatements(r, pSubClass, (RDFNode)null);
			while (si.hasNext()){
				Statement s=(Statement)si.next();
				////logger.info("Statement="+s.toString());
				RDFNode obj=s.getObject();
				if (obj!=null) {
					rtnSet.add(obj.toString());		
				}
			}
		}
		rtnSet.removeAll(c);
		return rtnSet;
	}
	
	private Set getSubClasses(Set c) {
		Set rtnSet=new HashSet();
		Property pSubClass=getOntModel().createProperty(NS_RDFS, RDFS_PROP_SUBCLASS);
		Iterator i=c.iterator();
		while (i.hasNext()) {
			String uri=(String)i.next();
			Resource r= getOntModel().createResource(uri);
			////logger.info("prop="+pSubClass.toString()+", annotBaseURI="+rAnnotationBase.toString());
			StmtIterator si = getOntModel().listStatements((Resource)null, pSubClass, r);
			while (si.hasNext()){
				Statement s=(Statement)si.next();
				////logger.info("Statement="+s.toString());
				RDFNode subj=s.getSubject();
				if (subj!=null) {
					rtnSet.add(subj.toString());		
				}
			}
		}
		rtnSet.removeAll(c);
		return rtnSet;
	}
	
	public Map getTaxonomyMap() {
		if (m_taxonomyMap != null) {
			return m_taxonomyMap;
		}
		m_taxonomyMap=new HashMap();
		m_taxRoot=new TaxonomyNode(TYPE_MMM_TAXONOMY_ITEM, null, getDirectSubClasses(TYPE_MMM_TAXONOMY_ITEM));
		return m_taxonomyMap;
	}
	
	// returns a map indexed by uri, values=Set of all superclassURIs (including uri) of uri 
	public Map getSuperclassMap() {
		if (m_superclassMap != null) {
			return m_superclassMap;
		}
		m_superclassMap=new HashMap();
		Property pType=getOntModel().createProperty(NS_RDF, RDF_PROP_TYPE);
		Resource oc=getOntModel().createResource(TYPE_OWL_CLASS);
		StmtIterator i = getOntModel().listStatements((Resource)null, pType, oc);
		while (i.hasNext()){
			Statement s=(Statement)i.next();
			Resource subj=s.getSubject();
	//System.out.println(s+" "+subj);
			if (subj.getNameSpace() != null && subj.getNameSpace().startsWith("http://garage.sims") && //) { // TODO fix this hack (maybe a list of namespaces we're interested in?
					(!getTaxonomyMap().containsKey(subj.getURI())) ) {
				//logger.info(subj.getURI()+", "+getTaxonomyMap().containsKey(subj.getURI()));
				Set sc=new HashSet();
				sc.add(subj.getURI());
				Set dsc=getSuperClasses(sc);
				while (!dsc.isEmpty()) {
					sc.addAll(dsc);
					dsc=getSuperClasses(dsc);
				}
				m_superclassMap.put(subj.getURI(),sc);
			}
		}
		return m_superclassMap;
	}
	
//	 returns a map indexed by uri, values=Set of all sublassURIs (including uri) of uri 
	public Map getSubclassMap() {
		if (m_subclassMap != null) {
			return m_subclassMap;
		}
		m_subclassMap=new HashMap();
		Property pType=getOntModel().createProperty(NS_RDF, RDF_PROP_TYPE);
		Resource oc=getOntModel().createResource(TYPE_OWL_CLASS);
		StmtIterator i = getOntModel().listStatements((Resource)null, pType, oc);
		while (i.hasNext()){
			Statement s=(Statement)i.next();
			Resource subj=s.getSubject();
	//System.out.println(s+" "+subj);
			if (subj.getNameSpace() != null && subj.getNameSpace().startsWith("http://garage.sims") ) { // TODO fix this hack (maybe a list of namespaces we're interested in?
				////logger.info(subj.getURI()+", "+getTaxonomyMap().containsKey(subj.getURI()));
				Set sc=new HashSet();
				sc.add(subj.getURI());
				Set dsc=getSubClasses(sc);
				while (!dsc.isEmpty()) {
					sc.addAll(dsc);
					dsc=getSubClasses(dsc);
				}
				m_subclassMap.put(subj.getURI(),sc);
			}
		}
		return m_subclassMap;
	}
	
	public Map getAllTypesMap() {
		if (m_allTypesMap==null) {
			getTypeMap();
		}
		return m_allTypesMap;
	}
	
	//TODO -- work on this, especially for DataType properties
	// might need to do map of all types...
	// return a map of types (class URIs for direct superclass) indexed by individual URI
	public Map getTypeMap() {
		if (m_typeMap != null) {
			return m_typeMap;
		}
		m_allTypesMap=new HashMap();
		Property pType=getOntModel().createProperty(NS_RDF, RDF_PROP_TYPE);
		StmtIterator si = getOntModel().listStatements((Resource)null, pType, (RDFNode)null);
		while (si.hasNext()){
			Statement stmt=(Statement)si.next();
			//logger.info("Statement="+stmt.toString());
			Resource subj=stmt.getSubject();
			RDFNode obj=stmt.getObject();
			if (subj!=null && obj!=null) {
				String subjURI=subj.getURI();
				String classURI=obj.toString();
				if (!(TYPE_OWL_CLASS.equals(classURI) || TYPE_MMM_PERSON.equals(classURI) 
						|| TYPE_MMM_PHOTO.equals(classURI) || TYPE_MMM_ALBUM.equals(classURI)
						)) { //|| TYPE_RDFS_RESOURCE.equals(classURI) )) { // filter out some types we don't need
					Set s=null;
					if (m_allTypesMap.containsKey(subjURI)) {
						s=(Set)m_allTypesMap.get(subjURI);
					} else {
						s=new HashSet();
					}
					s.add(classURI);
					m_allTypesMap.put(subjURI, s);
					//m_typeMap.put(subjURI, classURI);
					//logger.info(subjURI+" - "+ classURI);
				}
			}
		}
		// now m_allTypesMap has Sets of types.  want to reduce it to only direct type
		m_typeMap=new HashMap();
		Iterator i=m_allTypesMap.keySet().iterator();
		String mostSupertypedClass=null;
		int mostSupertypedNum=-1;
		while (i.hasNext()) {
			String key=(String)i.next();
			Set s=(Set)m_allTypesMap.get(key);
			Iterator i2=s.iterator();
			while (i2.hasNext()) {
				String type=(String)i2.next();
				Set s2=(Set)m_allTypesMap.get(type);
				int count=0;
				if (s2!=null) {
					count=s2.size();
				} 
				if (count>mostSupertypedNum) {
					mostSupertypedClass=type;
				}
			}
			m_typeMap.put(key, mostSupertypedClass);
		}
		return m_typeMap;
	}
	
	public void addType(String indURI, String classURI) {
		if (m_typeMap == null) {
			getTypeMap();
		}
		if (!m_typeMap.containsKey(indURI)) {
			m_typeMap.put(indURI, classURI);
		}
	}
	
	// return a map of labels indexed by URI
	public Map getLabelMap() {
		if (m_labelMap != null) {
			return m_labelMap;
		}
		m_labelMap=new HashMap();
		Property pSubClass=getOntModel().createProperty(NS_RDFS, RDFS_PROP_LABEL);
		StmtIterator i = getOntModel().listStatements((Resource)null, pSubClass, (RDFNode)null);
		//StmtIterator i = getOntModel().listStatements((Resource)null, (Property)null, rAnnotationBase);
		while (i.hasNext()){
			Statement s=(Statement)i.next();
			Resource r=s.getSubject();
			if (r!=null) {
				String uri=r.toString();
				String label;
				try {
					label=s.getObject().toString();
				} catch (NullPointerException e) {
					logger.warning("null label for "+uri);
					label="";
				}
				m_labelMap.put(uri, label);
			}
		}
		return m_labelMap;
	}
	
//	 return a map of (set of ranges) indexed by property URI
	public Map getRangeMap() {
		if (m_rangeMap != null) {
			return m_rangeMap;
		}
		m_rangeMap=new HashMap();
		Property pRange=getOntModel().createProperty(NS_RDFS, RDFS_PROP_RANGE);
		StmtIterator si = getOntModel().listStatements((Resource)null, pRange, (RDFNode)null);
		//	StmtIterator i = getOntModel().listStatements((Resource)null, (Property)null, rAnnotationBase);
		while (si.hasNext()){
			Statement stmt=(Statement)si.next();
			RDFNode r=stmt.getObject();
			Resource p=stmt.getSubject();
			if (r!=null && p!=null) {
				String propURI=p.getURI();
				String rangeURI=r.toString();
				Set s=null;
				if (m_rangeMap.containsKey(propURI)) {
					s=(Set)m_rangeMap.get(propURI);
				} else {
					s=new HashSet();
				}
				s.add(rangeURI);
				m_rangeMap.put(propURI, s);
			}
		}
		return m_rangeMap;
	}
	
	
	
	private Set getDirectSubClasses(String uri) {
		Set rtnSet=new HashSet();
		Property pSubClass=getOntModel().createProperty(NS_RDFS, RDFS_PROP_SUBCLASS);
		Resource r= getOntModel().createResource(uri);
		////logger.info("prop="+pSubClass.toString()+", annotBaseURI="+rAnnotationBase.toString());
		StmtIterator i = getOntModel().listStatements((Resource)null, pSubClass, r);
		//StmtIterator i = getOntModel().listStatements(r, pSubClass, (RDFNode)null);
		while (i.hasNext()){
			Statement s=(Statement)i.next();
			//logger.info("Statement="+s.toString());
			Resource subj=s.getSubject();
			if (subj!=null && !subj.getURI().equals(uri)) { //!subj.equals(r)) {
				rtnSet.add(subj.getURI());		
				//logger.info(subj.getURI()+" : "+r.getURI());
			}
		}
		//logger.info("size="+rtnSet.size());
		return rtnSet;
	}
	
	private Set getDirectSuperClasses(String uri) {
		Set rtnSet=new HashSet();
		Property pSubClass=getOntModel().createProperty(NS_RDFS, RDFS_PROP_SUBCLASS);
		Resource r= getOntModel().createResource(uri);
		////logger.info("prop="+pSubClass.toString()+", annotBaseURI="+rAnnotationBase.toString());
		//StmtIterator i = getOntModel().listStatements((Resource)null, pSubClass, r);
		StmtIterator i = getOntModel().listStatements(r, pSubClass, (RDFNode)null);
		
		while (i.hasNext()){
			Statement s=(Statement)i.next();
			//logger.info("Statement="+s.toString());
			Resource subj=s.getSubject();
			if (subj!=null && !subj.getURI().equals(uri)) { //!subj.equals(r)) {
				rtnSet.add(r.getURI());		
				//logger.info(subj.getURI()+" : "+r.getURI());
			}
		}
		//logger.info("size="+rtnSet.size());
		return rtnSet;
	}
	
	private Set addAllSuperClasses(Set s, Collection c) {
		Iterator i=c.iterator();
		if (i.hasNext()) {
			String uri=(String)i.next();
			s.add(uri);
			s=addAllSuperClasses(s,getDirectSuperClasses(uri));
		}
		return s;
	}
	
	private Set addAllSubClasses(Set s, Collection c) {
		Iterator i=c.iterator();
		if (i.hasNext()) {
			String uri=(String)i.next();
			s.add(uri);
			s=addAllSubClasses(s,getDirectSubClasses(uri));
		}
		return s;
	}
	
	public Map getClassMap() {
		if (m_classMap != null) {
			return m_classMap;
		}
		Property pDomain=getOntModel().createProperty(NS_RDFS, RDFS_PROP_DOMAIN);
		m_classMap=new HashMap();
//		List temp=new ArrayList();
//		Iterator i=getAnnotClassMap().values().iterator();
//		while (i.hasNext()) {
//			List l=(List)i.next();
//			temp.addAll(l);
//		}
		List temp=new ArrayList();
		temp.add(TYPE_MMM_BASE);
		//Set s=addAllSubClasses(new HashSet(), temp);
		Set s=(Set)getSubclassMap().get(TYPE_MMM_BASE);
		Iterator i=s.iterator();
		while (i.hasNext()) {
			String uri=(String)i.next();
			//logger.info("uri="+uri);
			Resource r= getOntModel().createResource(uri);
			Selector stmtSelector=new DomainSelector(uri);
			StmtIterator si=getOntModel().listStatements(stmtSelector);
			//StmtIterator si = getOntModel().listStatements((Resource)null, pDomain, r); // TODO -- need a statement filter here to examine superclasses
			ArrayList l=new ArrayList();
			while (si.hasNext()) {
				Statement stmt=(Statement)si.next();
				//logger.info("statement "+stmt);
				
				Resource p=stmt.getSubject();
				if (!(RDFManipulator.PROPERTY_SUBJECT_URI.equals(p.getURI())
						// TODO -- think about putting label back in
						|| RDFManipulator.PROPERTY_HAS_LABEL.equals(p.getURI())
						|| RDFManipulator.PROPERTY_EDIT_SUBJECT_URI.equals(p.getURI())
						|| RDFManipulator.PROPERTY_HIDDEN_URI.equals(p.getURI())
						|| RDFManipulator.PROPERTY_CREATOR_URI.equals(p.getURI()) 
						|| RDFManipulator.PROPERTY_TIMESTAMP_URI.equals(p.getURI()) 
						|| RDFManipulator.PROPERTY_HAS_ASSOC_OBJ_URI.equals(p.getURI()))) {
					PropertyDescriptor pd=getPropertyDescriptor(p.getURI());
					if (pd!=null) {
						l.add(pd);
					}
				}
			}
			Object[] a=l.toArray();
			//Arrays.sort(a, new PDComparator());
			Arrays.sort(a, ObjectSorter.propertyDescriptor() );
			m_classMap.put(uri, Arrays.asList(a));
		}
		return m_classMap;
	}
	
//	public Map getClassMap() {
//		if (m_classMap != null) {
//			return m_classMap;
//		}
//		
//		m_classMap=new HashMap();
//		ExtendedIterator ei=getOntModel().listNamedClasses();
//		while (ei.hasNext()) {
//			OntClass c=(OntClass)ei.next();
//			ArrayList l=new ArrayList();
//			ExtendedIterator i=c.listDeclaredProperties();
//			while (i.hasNext()) {
//				OntProperty p=(OntProperty)i.next();
//				//if (true) {
//				if (!(RDFManipulator.PROPERTY_SUBJECT_URI.equals(p.getURI())
//						// TODO -- think about putting label back in
//						//|| RDFManipulator.PROPERTY_HAS_LABEL.equals(p.getURI())
//						|| RDFManipulator.PROPERTY_EDIT_SUBJECT_URI.equals(p.getURI())
//						|| RDFManipulator.PROPERTY_HIDDEN_URI.equals(p.getURI())
//						|| RDFManipulator.PROPERTY_CREATOR_URI.equals(p.getURI()) 
//						|| RDFManipulator.PROPERTY_TIMESTAMP_URI.equals(p.getURI()) 
//						|| RDFManipulator.PROPERTY_HAS_ASSOC_OBJ_URI.equals(p.getURI()))) {
//					PropertyDescriptor pd=(PropertyDescriptor)getPropMap().get(p.getURI());
//					if (pd!=null) {
//						l.add(pd);
//					}
//				}
//			}
//			Object[] a=l.toArray();
//			//Arrays.sort(a, new PDComparator());
//			Arrays.sort(a, ObjectSorter.propertyDescriptor() );
//			m_classMap.put(c.getURI(), Arrays.asList(a));
//		}
//		return m_classMap;
//	}
	
	// never really want the child to be included
	public List getTaxonomyPath(String ancestorURI, String childURI) {
		List l=new ArrayList();
		TaxonomyNode n=(TaxonomyNode)getTaxonomyMap().get(childURI);
		if (childURI.equals(ancestorURI)) {
			return l;
		}
		if (n!=null) {
			n=n.getParent();
		}
		//while (n != null && !n.getURI().equals(ancestorURI)) {
		//System.out.println("\nTAXONOMY PATH");
		while (n!=null) {
			l.add(0,n.getURI());
			//System.out.print(" - "+n.getURI());
			if (n.getURI().equals(ancestorURI)) {
				n=null;
			} else {
				n=n.getParent();
			}
		}
		//System.out.println("\n");
		return l;
	}
	
	public List getTaxonomyChildren(String nodeURI) {
		List l=new ArrayList();
		TaxonomyNode n=(TaxonomyNode)getTaxonomyMap().get(nodeURI);
		if (n!=null) {
			Iterator i=n.getChildren().iterator();
			while (i.hasNext()) {
				n=(TaxonomyNode)i.next();
				l.add(n.getURI());
			}
		}
		return l;
	}
	
	private PropertyDescriptor getPropertyDescriptor(String uri) {
		Property pLabel=getOntModel().createProperty(NS_RDFS, RDFS_PROP_LABEL);
		Property pConcise=getOntModel().createProperty(NS_MMM_BASE, MMM_PROP_INCLUDECONCISE);
		Property pSort=getOntModel().createProperty(NS_MMM_BASE, MMM_PROP_SORTORDER);
		Resource p=getOntModel().createResource(uri);
		String label=null;
		String sort=null;
		String concise=null;
		StmtIterator si=getOntModel().listStatements(p, pLabel, (RDFNode)null);
		while (si.hasNext()) {
			Statement s=(Statement)si.next();
			label=s.getObject().toString();
		}
		si=getOntModel().listStatements(p, pConcise, (RDFNode)null);
		while (si.hasNext()) {
			Statement s=(Statement)si.next();
			concise=s.getObject().toString();
		}
		si=getOntModel().listStatements(p, pSort, (RDFNode)null);
		while (si.hasNext()) {
			Statement s=(Statement)si.next();
			sort=s.getObject().toString();
		}
		return new PropertyDescriptor(p.getURI(), RDFManipulator.getAnnotationPropertyType(p.getURI()),
									label, sort, concise);
	}
	
	
//	public Map getPropMap() {
//		if (m_propMap != null) {
//			return m_propMap;
//		}
//		
//		Property pLabel=getOntModel().getOntProperty(RDFManipulator.PROPERTY_RDFS_LABEL_URI);
//		Property pConcise=getOntModel().getOntProperty(RDFManipulator.PROPERTY_INCLUDE_CONCISE_URI);
//		Property pSort=getOntModel().getOntProperty(RDFManipulator.PROPERTY_SORT_ORDER_URI);
//		
//		m_propMap=new HashMap();
//		ExtendedIterator ei=getOntModel().listOntProperties();
//		while (ei.hasNext()) {
//			OntProperty p=(OntProperty)ei.next();
//			PropertyDescriptor pd=null;
//			String label=null;
//			String sort=null;
//			String concise=null;
//			try {
//				label=p.getPropertyValue(pLabel).toString();
//			} catch (NullPointerException ignored) {}
//			try {
//				sort=p.getPropertyValue(pSort).toString();
//			} catch (NullPointerException ignored) {}
//			try {
//				concise=p.getPropertyValue(pConcise).toString();
//			} catch (NullPointerException ignored) {}
//			pd=new PropertyDescriptor(p.getURI(), RDFManipulator.getAnnotationPropertyType(p.getURI()),
//										label, sort, concise);
//										
//			if (pd!=null) {
//				m_propMap.put(p.getURI(), pd);
//			}
//		}
//		return m_propMap;
//	}
	
//	 return a map of (set of ranges) indexed by property URI
	public Map getOntologyMap() {
		if (m_ontMap != null) {
			return m_ontMap;
		}
		m_ontMap=new HashMap();
		
		String query = "select id, rdf_namespace, file_name from rdf_namespaces;";
		ResultSetWrapper rsw = RDBConnection.executeQuery(query);
		ResultSet rs = rsw.getResultSet();
		try {
			while (rs.next()) {
				String id = String.valueOf(rs.getInt("id"));
				String rdf_namespace = rs.getString("rdf_namespace");
				String file_name = rs.getString("file_name");
				String[] s = {rdf_namespace, file_name};
				m_ontMap.put(id, s);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			rsw.closeAll();
		}

		return m_ontMap;
	}
	
	
	public OntModel getOntModel() {
		
		if(m_model != null){
			return m_model;	
		}
		
		
		//		String rules="[(?share " + BASE_URI + "initiatedBy ?user), (?share " + BASE_URI + "grantedTo ?person)"+
		//			" -> (?user " + BASE_URI + "hasShareBuddy ?person)]";
		//	
		//		OntModelSpec spec = new OntModelSpec(OntModelSpec.OWL_MEM_RULE_INF);
		//		//OntModelSpec spec = new OntModelSpec(OntModelSpec.RDFS_MEM);
		//		List myRules=Rule.parseRules(rules);
		//
		//		myRules.addAll(RDFSFBRuleReasoner.loadRules());
		//		//myRules.addAll(OWLFBRuleReasoner.loadRules());
		//
		//		GenericRuleReasoner grr = new GenericRuleReasoner(myRules);
		//		spec.setReasoner(grr);


		OntModelSpec spec = new OntModelSpec(OntModelSpec.OWL_LITE_MEM);//OWL_MEM_RULE_INF
		
		//Create an (RDF) specification of a hybrid reasoner which
		//loads its data from an external file.
		Model dummy = ModelFactory.createDefaultModel();
		Resource configuration =  dummy.createResource();
		configuration.addProperty(ReasonerVocabulary.PROPruleMode, "hybrid");
		//configuration.addProperty(ReasonerVocabulary.PROPruleSet,  ONTOLOGY_DIR+"/mmm2.rules");
		
		//Create an instance of such a reasoner
		GenericRuleReasoner reasoner = (GenericRuleReasoner) GenericRuleReasonerFactory.theInstance().create(configuration);
		//GenericRuleReasoner reasoner=(GenericRuleReasoner) GenericRuleReasonerFactory.theInstance().create((Resource)null);
		//spec.setReasoner(reasoner);

		try {
			//Class.forName("org.postgresql.Driver");
			Class.forName(className); 
		} catch (ClassNotFoundException e1) {
			e1.printStackTrace();
		}
		// create a database connection
		DBConnection conn = new DBConnection(DB_URL, DB_USER, DB_PASSWD, DB);

		//ModelRDB dbmodel = ModelRDB.open(conn, ONT_MMM2); 
		ModelRDB dbmodel = ModelRDB.open(conn, ONT_MASTER);
		
        OntModel m = ModelFactory.createOntologyModel(spec, null);
		//OntModel m=ModelFactory.createOntologyModel();
		OntDocumentManager dm = m.getDocumentManager();

		dm.clearCache();
		dm.addAltEntry(ONT_MASTER, "file:"+ONTOLOGY_DIR+"/master.owl");
		dm.addAltEntry(ONT_MMM2, "file:"+ONTOLOGY_DIR+"/mmm2base2.owl");
		//read below entries from db (namespace, filename)
		HashMap h = (HashMap)this.getOntologyMap();
		Iterator i = h.keySet().iterator();
		while(i.hasNext()) {
			String[] s = (String[])h.get(i.next());
			dm.addAltEntry(s[0], "file:"+ONTOLOGY_DIR+"/"+s[1]);
		}
		//dm.addAltEntry(ONT_EXTENSION1, "file:"+ONTOLOGY_DIR+"/mmm2extension1.owl");
		//dm.addAltEntry(ONT_EXTENSION0, "file:"+ONTOLOGY_DIR+"/mmm2extension0.owl");
		
		//dm.addAltEntry(ONT_RDFS, "file:"+FILE_PATH_HACK+"/ontologies/rdf-schema.rdf");
		
		//dm.addAltEntry(ONT_MMM2, "file:"+FILE_PATH_HACK+"/ontologies/mmm2.owl");
		//dm.addAltEntry(ONT_MMM2, "file:"+FILE_PATH_HACK+"/ontologies/mmm2examples.owl");
		//dm.addAltEntry(ONT_MASTER, "file:"+FILE_PATH_HACK+"/ontologies/master.owl");
		//dm.addAltEntry(FOAF, "file:"+FILE_PATH_HACK+"/ontologies/foaf.rdf");
//		dm.addAltEntry(ONT_MMM2, "file:"+FILE_PATH_HACK+"/ontologies/mmm2.owl");
//		dm.addAltEntry(ONT_MASTER, "file:"+FILE_PATH_HACK+"/ontologies/master.owl");
//		dm.addAltEntry(FOAF, "file:"+FILE_PATH_HACK+"/ontologies/foaf.rdf");

		m.read(ONT_MASTER);
		//m.read(ONT_MMM2);

		m.add(dbmodel.listStatements());

		ModelSynchronizer.Synchronize(m, dbmodel);
		m_model = m;
		
		return m_model;	
	}
	
	class PDComparator implements Comparator {
		public PDComparator() {
		}
		
		public int compare(Object o1, Object o2) throws ClassCastException {
			PropertyDescriptor pd1=(PropertyDescriptor)o1;
			PropertyDescriptor pd2=(PropertyDescriptor)o2;
			if (pd1.getSortOrder()==pd2.getSortOrder()) {
				return 0;
			}
			if (pd1.getSortOrder()<pd2.getSortOrder()) {
				return -1;
			}
			return 1;
		}
	}

	class TaxonomyNode {
		private Set m_children; // list of TaxonomyNodes
		private String m_uri, m_label;
		private TaxonomyNode m_parent; // try this with only single parents for now
		
		// this constructor basically created a full subtree
		public TaxonomyNode(String uri, TaxonomyNode parent, Set children) { // children is se of URIs
			m_uri=uri;
			m_label=(String)MMMModelFactory.getInstance().getLabelMap().get(uri);
			m_parent=parent;
			m_children=new HashSet();
			Iterator i=children.iterator();
			while (i.hasNext()) {
				String childURI=(String)i.next();
				m_children.add(new TaxonomyNode(childURI, this, MMMModelFactory.getInstance().getDirectSubClasses(childURI) ));
			}
			m_taxonomyMap.put(m_uri, this);
			//logger.info(m_uri+", children size="+children.size());
		}
		
		public TaxonomyNode getParent() {
			return m_parent;
		}
		
		public Set getChildren() {
			return m_children;
		}
		
		public String getURI() {
			return m_uri;
		}
		
		public String getLabel() {
			return m_label;
		}
		
	}
	
	// this needs to accept anything matching (null, pDomain, (uri or any supercalss of uri)
	class DomainSelector implements Selector {
		private Set m_acceptSet; // should be a set of Resources
		private Property m_domainProp;
		public DomainSelector(String uri) {
			m_acceptSet=new HashSet();
			Set uriSet=(Set)getSuperclassMap().get(uri);
			uriSet.add(uri);
			Iterator i=uriSet.iterator();
			while (i.hasNext()) {
				String u=(String)i.next();
				Resource r= getOntModel().createResource(u);
				if (r!=null) {
					m_acceptSet.add(r);
				}
			}
			m_domainProp=getOntModel().createProperty(NS_RDFS, RDFS_PROP_DOMAIN);
		}

		public boolean test(Statement s) {
			return (m_domainProp.equals(s.getPredicate()) && (m_acceptSet.contains(s.getObject())));
		}
		
		public boolean isSimple() {
			return false;
		}
		 
		public Resource getSubject() {
			return null;
		}
		 
		public Property getPredicate() {
			return m_domainProp;
		}

		public RDFNode getObject() {
			return null;
		}
	}

}
