/*
 * Created on Oct 1, 2004
 *
 */
package gcr.rdf;

/**
 * @author Simon King
 *
 */
public class PropertyDescriptor {
	private int m_sort, m_type;
	private String m_URI, m_label;
	private boolean m_concise;
	
	public PropertyDescriptor(String URI, int type, String label, String sort, String concise) {
		m_label=label;
		m_sort=Integer.MAX_VALUE;
		if (sort!=null) {
			try {
				// gotta do the : thing because Protoge stores values as <value>:<datatype>
				sort=sort.substring(0,sort.indexOf(":"));
				//System.out.println(sort);
				m_sort=Integer.parseInt(sort);
			} catch (NumberFormatException ignored) {}
		}
		m_concise=true; // we include it unless told otherwise
		if (concise!=null) {
			m_concise=!(concise.startsWith("false"));
		}
		m_type=type;
		m_URI=URI;
		//System.out.println("PDConstructor - "+m_type+", "+m_URI+", "+m_label+", "+m_sort+", "+concise);
	}
	
	public int getSortOrder() {
		return m_sort;
	}
	
	public int getType() {
		return m_type;
	}
	
	public String getURI() {
		return m_URI;
	}
	
	public String getLabel() {
		return m_label;
	}
	
	public boolean isInConcise() {
		return m_concise;
	}
}
