/*
 * Created on Jun 29, 2004
 *
 */
package gcr.rdf.query;

import gcr.mmm2.rdf.Person;
import gcr.rdf.MMMModelFactory;

import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.SimpleSelector;
import com.hp.hpl.jena.rdf.model.Statement;

/**
 * @author jeff
 *
 */
public class PersonSelector extends SimpleSelector {

	public String firstName;

	/**
	 * 
	 */
	public PersonSelector() {
		super();
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PersonSelector(Resource arg0, Property arg1, RDFNode arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PersonSelector(Resource arg0, Property arg1, boolean arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PersonSelector(Resource arg0, Property arg1, long arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PersonSelector(Resource arg0, Property arg1, char arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PersonSelector(Resource arg0, Property arg1, float arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PersonSelector(Resource arg0, Property arg1, double arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PersonSelector(Resource arg0, Property arg1, String arg2) {
		super(arg0, arg1, arg2);
	}
	
	public PersonSelector(String firstName){
		super((Resource)null, MMMModelFactory.getInstance().getOntModel().getOntProperty(Person.PROPERTY_FIRST_NAME), (String)null);
		setFirstname(firstName);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 * @param arg3
	 */
	public PersonSelector(
		Resource arg0,
		Property arg1,
		String arg2,
		String arg3) {
		super(arg0, arg1, arg2, arg3);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PersonSelector(Resource arg0, Property arg1, Object arg2) {
		super(arg0, arg1, arg2);
	}
	
	/* (non-Javadoc)
	 * @see com.hp.hpl.jena.rdf.model.Selector#isSimple()
	 */
	public boolean isSimple(){
		return false;
	}
	
	/* (non-Javadoc)
	 * @see com.hp.hpl.jena.rdf.model.SimpleSelector#selects(com.hp.hpl.jena.rdf.model.Statement)
	 */
	public boolean selects(Statement s){
		if(firstName == null){
			return true;
		}
		
		String statementString = s.getString();
		return statementString.toLowerCase().startsWith(firstName);
	}
	
	public void setFirstname(String firstName){
		this.firstName = firstName.toLowerCase();
	}

}
