/*
 * Created on Jun 29, 2004
 *
 */
package gcr.rdf.query;

import gcr.mmm2.rdf.Picture;
import gcr.mmm2.rdf.User;
import gcr.rdf.MMMModelFactory;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Selector;

/**
 * @author jeff
 * 
 */
public class PictureQuery {

    private User m_user;

    private Set m_userPhotos;

    public PictureQuery(User user) {
        m_user = user;

        RDFNode userNode = m_user.getOntResource();
        Property prop = MMMModelFactory.getInstance().getOntModel()
                .getProperty(Picture.PROPERTY_UPLOADED_BY);

        m_userPhotos = QueryUtil.getSubjects(MMMModelFactory.getInstance()
                .getOntModel().listStatements((Resource) null, prop, userNode));
    }

    public Set returnNodeResults() {
        return m_userPhotos;
    }

    public Set returnPictureResults() {
        HashSet hs = new HashSet();

        Iterator i = m_userPhotos.iterator();
        while (i.hasNext()) {
            Node n = (Node) i.next();
            hs.add(Picture.getObjectByURI(n.getURI()));
        }

        return hs;
    }

    public void setDepictedIn(String firstName) {

        Selector personSelector = new PersonSelector(firstName);
        Set subjects = QueryUtil.getSubjects(MMMModelFactory.getInstance()
                .getOntModel().listStatements(personSelector));

        Selector pictureSelector = new PictureSelector(subjects);
        Set pictures = QueryUtil.getSubjects(MMMModelFactory.getInstance()
                .getOntModel().listStatements(pictureSelector));

        m_userPhotos.retainAll(pictures);
    }

}
