/*
 * Created on Jun 29, 2004
 *
 */
package gcr.rdf.query;

import gcr.mmm2.rdf.Picture;
import gcr.rdf.MMMModelFactory;

import java.util.Set;

import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.SimpleSelector;
import com.hp.hpl.jena.rdf.model.Statement;

/**
 * @author jeff
 *
 */
public class PictureSelector extends SimpleSelector {

	public Set people;
	public Resource user;

	/**
	 * 
	 */
	public PictureSelector() {
		super();
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PictureSelector(Resource arg0, Property arg1, RDFNode arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PictureSelector(Resource arg0, Property arg1, boolean arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PictureSelector(Resource arg0, Property arg1, long arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PictureSelector(Resource arg0, Property arg1, char arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PictureSelector(Resource arg0, Property arg1, float arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PictureSelector(Resource arg0, Property arg1, double arg2) {
		super(arg0, arg1, arg2);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PictureSelector(Resource arg0, Property arg1, String arg2) {
		super(arg0, arg1, arg2);
	}
	
	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 * @param arg3
	 */
	public PictureSelector(
		Resource arg0,
		Property arg1,
		String arg2,
		String arg3) {
		super(arg0, arg1, arg2, arg3);
	}

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 */
	public PictureSelector(Resource arg0, Property arg1, Object arg2) {
		super(arg0, arg1, arg2);
	}
	
	public PictureSelector(Set depictedBy){
		super((Resource)null, MMMModelFactory.getInstance().getOntModel().getOntProperty(Picture.PROPERTY_DEPICTS_PERSON), (RDFNode)null);
		this.setDepictsPerson(depictedBy);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.hp.hpl.jena.rdf.model.Selector#isSimple()
	 */
	public boolean isSimple(){
		return false;
	}
	
	/* (non-Javadoc)
	 * @see com.hp.hpl.jena.rdf.model.SimpleSelector#selects(com.hp.hpl.jena.rdf.model.Statement)
	 */
	public boolean selects(Statement s){
		if(this.people == null)
			return true;
			
		RDFNode personNode = s.getObject();
		return people.contains(personNode.asNode());
	}
	
	public void setDepictsPerson(Set people){
		this.people = people;
	}

}
