<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.util.logging.*" %>

<%
	String username = request.getRemoteUser();
	IUser u = UserManager.getByUsername(username);
	final Logger log = Logger.getLogger("contactActivity");
	
	//
	// Get all the photos and turn them into manageable objects
	//
	ArrayList photos = new ArrayList();
	String[] photoIDs = request.getParameterValues("photoID");
	if(photoIDs == null){
		return;
	}
	
	for(int i = 0; i < photoIDs.length; i++){
		try{
			int photoID = Integer.parseInt(photoIDs[i]);
			IPhoto current = PhotoFactory.getPhotoByID(photoID);
			photos.add(current);
		}catch(NumberFormatException nfe){
			log.info("Add to Album: format exception.");
			return;
		}
	}

	//
	// Add the photos to an album, then redirect to another page.
	//
	String[] addToIDs = request.getParameterValues("addto");
	if(addToIDs != null){
	
		for(int i = 0; i < addToIDs.length; i++){
			try{
				int albumID = Integer.parseInt(addToIDs[i]);
				
				//handle new albums
				if(albumID == -1){
					String newAlbumName = request.getParameter("new_title");
					String newAlbumCaption = request.getParameter("new_caption");
					if(newAlbumName != null){
						IAlbum newAlbum = AlbumFactory.createAlbum(newAlbumName, u);
						newAlbum.setCaption(newAlbumCaption, u);
						albumID = newAlbum.getID();
					}else{
						continue;
					}
				}
				
				//kind of inefficient to recreate the IAlbum object (for a *new* album), but oh well
				IAlbum current = AlbumFactory.getAlbumByID(albumID);
				
				Iterator photo_it = photos.iterator();
				while(photo_it.hasNext()){
					IPhoto cur_photo = (IPhoto)photo_it.next();
					current.addPhoto(cur_photo, 0, u);
				}
				
			}catch(NumberFormatException nfe){
				log.info("Add to Album: format exception.");
				return;
			}
		}//end for
		
		//eventually handle this as a parameter so you don't go back home every time
		if(session.getAttribute("actionRedirect") != null){
	    	response.sendRedirect((String)session.getAttribute("actionRedirect"));
	    }
		
	}//end addTo procedure
%>


<html>
<head>
<title>Add Media to Album</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
</head>

<body>
<%@ include file="header.jsp" %>
<div style="clear:both;">
<table width="100%" border="0">
  <tr>
    <td width="50%" height="275" valign="top"> 

        <table width="45%" border="0" cellspacing="5" cellpadding="5">
        <tr>
		<%
		int i_max_columns = 2;
		int i_cur_column = 0;
		Iterator photo_it = photos.iterator();
		
		while (photo_it.hasNext()) {
		        IPhoto p = (IPhoto)photo_it.next();
		        if(p == null){continue;}
		
		        if(i_cur_column == 0){
		            out.write("<tr>");
		        }
		%>
		    <td valign="top" align="left">
		    <img class="photo" src="<%=p.getURL(null,null,200)%>"><br>
		    <%=p.getCaption()%><br>
		    </td>
		    <%
		    if(i_cur_column == i_max_columns-1){
		        i_cur_column=0;
		        out.write("</tr>");
		    }
		    else{
		        i_cur_column++;
		    }
		} // end while
		%>
		</tr>
		</table>
      </td>
    <td width="50%" valign="top"> 
      <form name="albums" method="GET" action="add_to_album.jsp">
    <%
		for(int i = 0; i < photoIDs.length; i++){
			out.write("<input type='hidden' name='photoID' value='"+photoIDs[i]+"'>");
		}
	%>
      
        <table width="100%" border="0">
          <tr> 
            <td colspan="2">Add to Album</td>
          </tr>
          <%
	          Iterator allAlbums = AlbumFactory.listAlbums(u).iterator();
	          while(allAlbums.hasNext()){
	          		IAlbum cur_album = (IAlbum)allAlbums.next();
	 
	       %>
          
          <tr> 
            <td width="7%"><input type="checkbox" name="addto" value="<%=cur_album.getID()%>"></td>
            <td width="93%"><%=cur_album.getTitle()%></td>
          </tr>

			<%
				}//end while
			%>
          <tr> 
            <td><input type="checkbox" name="addto" value="-1"></td>
            <td>New Album:</td>
          </tr>
          <tr> 
            <td>&nbsp;</td>
            <td><input name="new_title" type="text" value="New Album" size="40" maxlength="40"></td>
          </tr>
          <tr> 
            <td>&nbsp;</td>
            <td><input name="new_caption" type="text" value="Description" size="40" maxlength="40"></td>
          </tr>
          <tr>
          <td>&nbsp;</td>
          <td><input name="add_to_album" type="submit" value="Add to Album"></td>
          </tr>
        </table>
      </form>
      <p>&nbsp;</p></td>
  </tr>
</table>
</div>
</body>
</html>
