<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.util.logging.*" %>

<%

	String username = request.getRemoteUser();
	IUser u = UserManager.getByUsername(username);
	final Logger log = Logger.getLogger("contactActivity");
		
	// If user is not part of Research group, send them away
	if (!UserManager.isResearchUser(u)) { 
	   	response.sendRedirect("index.jsp");
	}
	    
	List photos = new ArrayList();
		
	//
	// Add the photos to an album, then redirect to another page.
	//
	String[] addToIDs = request.getParameterValues("addto");
	int albumID = 0;

	if(addToIDs != null){
		
		// Set parameters for random photos
		int m_numPhotos = Integer.parseInt(request.getParameter("numPhotos"));
		int m_range = Integer.parseInt(request.getParameter("range"));
		int m_unique = Integer.parseInt(request.getParameter("unique"));
		
		photos = PhotoFactory.listRandomPhotosByTime(m_range, m_numPhotos, m_unique, u);	

		for(int i = 0; i < addToIDs.length; i++){
			try{
				albumID = Integer.parseInt(addToIDs[i]);
				
				//handle new albums
				if(albumID == -1){
					String newAlbumName = request.getParameter("new_title");
					String newAlbumCaption = request.getParameter("new_caption");
					if(newAlbumName != null){
						IAlbum newAlbum = AlbumFactory.createAlbum(newAlbumName, u);
						newAlbum.setCaption(newAlbumCaption, u);
						albumID = newAlbum.getID();
					}else{
						continue;
					}
				}
				
				//kind of inefficient to recreate the IAlbum object (for a *new* album), but oh well
				IAlbum current = AlbumFactory.getAlbumByID(albumID);
				
				Iterator photo_it = photos.iterator();
				while(photo_it.hasNext()){
					IPhoto cur_photo = (IPhoto)photo_it.next();
					current.addPhoto(cur_photo, 0, u);
				}
				
			}catch(NumberFormatException nfe){
				log.info("Add to Album random: format exception.");
				return;
			}
		}//end for
		
		//eventually handle this as a parameter so you don't go back home every time
		if(session.getAttribute("actionRedirect") != null){
	    	response.sendRedirect((String)session.getAttribute("actionRedirect"));
	    }
		
	}//end addTo procedure
%>


<html>
<head>
<title>Add Random Photos to Album</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
</head>

<body>
<%@ include file="header.jsp" %>
<div style="clear:both;">
      <% if(request.getParameter("add_to_album") == null) { %>
      <form name="albums" method="GET" action="add_to_album_random.jsp">
    <%
		for(int i = 0; i < photos.size(); i++){
			IPhoto currentPhoto = (IPhoto) photos.get(i);
			out.write("<input type='hidden' name='photoID' value='"+currentPhoto.getID()+"'>");
		}
	%>
      
        <table border="0">
          <tr> 
            <td colspan="2"><h3>Add Random Photos to New Album</h3><input type="hidden" name="addto" value="-1"></td>
          </tr>
          <tr> 
            <td>Album Name:</td>
            <td><input name="new_title" type="text" value="" size="40" maxlength="40"></td>
          </tr>
          <tr> 
            <td>Album Description:</td>
            <td><input name="new_caption" type="text" value="" size="40" maxlength="40"></td>
          </tr>
          <tr> 
            <td>Number of Photos:</td>
            <td><input name="numPhotos" type="text" value="10" size="4">
            	<!-- <select name="numPhotos">
    				<option value="1">1</option>
    				<option value="10" selected>10</option>
    				<option value="100">100</option>
    				<option value="500">500</option> -->
				</select></td>
          </tr>
          <tr> 
            <td>Date Range:</td>
            <td><select name="range">
   					<option value="1">Today</option>
  				  	<option value="2">Last 7</option>
   					<option value="3">Last 14</option>
    				<option value="4">Last Month</option>
    				<option value="6">Last Year</option>
    				<option value="8" selected>All</option>
  				</select></td>
          </tr>
           <tr> 
            <td>Unique Set:</td>
            <td><select name="unique">
   					<option value="0" selected>No</option>
  				  	<option value="1">Yes</option>
  				</select></td>
          </tr>         <tr>
          <td>&nbsp;</td>
          <td><input name="add_to_album" type="submit" value="Create New Album"></td>
          </tr>
        </table>
      </form>
      
      <% } else { %>
      <br>
      <p>Album <b><a href="album.jsp?albumID=<%=albumID%>"><%=request.getParameter("new_title")%></a></b> created with <%=photos.size()%> photo(s).</p>
      <% } %>
</div>
</body>
</html>
