<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.util.StringUtils" %>
<%@ page import="gcr.mmm2.server.servlets.JpegRotator" %>



<%
	UIState uiState = (UIState)session.getAttribute("uiState");
	int i_max_columns = 3;
	
	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);
	
	if(request.getParameter("albumID") != null) {
		
		try{
	    	uiState.setAlbumID(Integer.parseInt(request.getParameter("albumID")));
	    }catch(NumberFormatException nfe){return;} 
	}
	
	IAlbum m_album = AlbumFactory.getAlbumByID(uiState.getAlbumID());
	
	if(m_album == null)
		return;
	
	String pageTitle = m_album.getTitle();
	
	if( request.getParameter("removeAlbum") != null){
		m_album.delete(m_user);
		response.sendRedirect("index.jsp");
	}
	
	if( request.getParameter("new_comment") != null){
		m_album.addComment(request.getParameter("new_comment"), m_user);
	}

	//Comment Operations
	if( request.getParameter("removeComment") != null ){
		int cId = Integer.parseInt(request.getParameter("removeComment"));
		m_album.removeComment(cId, m_user);
		//there may be permission exception stuff here
		//that will need to be handled
	}
	
	//Photo Operations: remove from album, rotate L/R
	if( (request.getParameter("operation") != null ) 
		&& (request.getParameter("photoID") != null) )
	{
	    if(session.getAttribute("actionRedirect") != null)
	    {
	    	response.sendRedirect((String)session.getAttribute("actionRedirect"));
	    }
	}
	
	//get all the photos to display
	//get it *after* the operations, so that deletions are reflected
	List m_photos = m_album.listPhotos();
	List m_comments = m_album.listComments();
	
	//HACK!!!
	Iterator id_it = m_photos.iterator();
	ArrayList idArray = new ArrayList(m_photos.size());
	for(int i = 0; i < m_photos.size(); i++){
		IPhoto p = (IPhoto)m_photos.get(i);
		idArray.add(new Integer(p.getID()));
	}
	
	session.setAttribute("collection", idArray);
	session.setAttribute("actionRedirect", request.getRequestURL().toString()+"?"+request.getQueryString());
%>

<html>
<head>
<title>Album: <%=m_album.getTitle()%></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
<link href="resources/styles/my_pictures.css" rel="stylesheet" type="text/css">
<script language="JavaScript" src="resources/scripts/open_edit_window.js"></script>
<STYLE>
<!-- 
#pup {position:absolute; visibility:hidden; z-index:200; width:260; }
 --> 
</STYLE>
</head>

<body>
<table border="0" width="100%"><tr><td colspan="2" valign="top" align="center">
<%@ include file="header.jsp" %>
</td></tr>

<tr><td width="160" valign="top" align="left">

	<!-- List Available Picture Browse Modes -->
	<%@ include file="timeline.jsp" %>
	<%@ include file="my_albums_menu.jsp" %>
	<%@ include file="received_albums_menu.jsp" %>

</td><!-- end left column-->

<!-- center column -->
<td width="*" valign="top" align="left">
<div class="album_menu_container">
			<a href="sharemedia.jsp?albumID=<%=m_album.getID()%>">share this album</a><br>
			<a href="javascript:open_edit_window(escape('edit_album.jsp?albumID=<%=m_album.getID()%>'), 'album_edit');">update this album name</a><br>
			<a href="album.jsp?albumID=<%=m_album.getID()%>&removeAlbum=true">delete this album</a>
		</div>
<!-- This is the PHOTOGRID, where the pictures are located on the page -->
<%@ include file="include_photomain.jsp" %>    
<!-- end photo_grid -->
	
	
	<!-- COMMENTS!!!!! -->
	

	<!-- comments area, below image grid -->
	<div class="comment_container">
	<form name="comment" action="album.jsp" method="get">
	<input type="hidden" name="albumID" value="<%=m_album.getID()%>">
    	<%
    	if(m_comments.size() > 0){
		%>
      	<div style="border-bottom: solid black 1px;">There are <%=m_comments.size()%> Comments:</div>
      	<%
      	}else{
      	%>
		<div style="border-bottom: solid black 1px;">There are no comments.</div>
		<%
		}
		%>
      	
        <%
        Iterator comments = m_comments.iterator();
        if(comments != null){
	        while(comments.hasNext()){
	        	Comment c = (Comment)comments.next();
		%>        
				<div class="individual_comment_container">
					<div class="comment"><%=StringUtils.showSafeHTML(c.getComment() )%></div>
		       	<%
		       	if( c.getOwner().getID()==m_user.getID() || m_album.getOwner().getID()==m_user.getID() ){
		   		%>
					<div class="comment_owner">
					<%=c.getOwner()%> - <a href="album.jsp?albumID=<%=m_album.getID()%>&removeComment=<%=c.getID()%>">remove comment</a>
					</div>
		        	
		        <%
		        }else{
		        %>
					<div class="comment_owner"><%=c.getOwner()%></div>
				<%
				}
				%>
				</div><!-- end individual comment container -->
		<%
	        }
        }
        %>

		<div>Leave a Comment:</div>
		<div><textarea name="new_comment" cols="60" rows="7"></textarea></div>
		<div><input type="submit" value="Add Comment"></div>  
	</form>
	</div><!-- end comment container -->        
</td>
<!-- end right column -->
</tr>
</table>



</body>
</html>

