<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.rdf.PropertyDescriptor" %>
<%@ page import="gcr.rdf.AnnotationWrapper" %>
<%@ page import="gcr.rdf.RDFManipulator" %>
<%@ page import="java.util.*" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="gcr.mmm2.util.StringUtils" %>
<%@ page import="java.net.URLEncoder" %>

<%
	String mySessKey="annotate-";
	String username = request.getRemoteUser();
	IUser u = UserManager.getByUsername(username);	
	
	int photoID = -1;
	String annotationClassURI=request.getParameter("annotationClassURI");
	String temp = request.getParameter("photoID");
	try{
		photoID = Integer.parseInt(temp);
	}catch(NumberFormatException nfe){
		//photoID is set to -1, redirect will be called next
	}
	IPhoto m_photo = PhotoFactory.getPhotoByID(photoID);
	if(m_photo == null){
		response.sendRedirect("../index.jsp");
	}
	mySessKey=mySessKey+photoID+"-";
	String subjectURI=m_photo.getURI();
	//Iterator anotIter=RDFManipulator.listAnnotations(subjectURI).iterator();
	//Iterator anot2Iter=RDFManipulator.listAnnotationWrappers(subjectURI, false).iterator();
	Iterator anot2Iter=RDFManipulator.listAnnotationWrappers2(subjectURI, false).iterator();
	
%>
<html>

<head>
<title>Faceted Annotations</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../resources/styles/master.css" rel="stylesheet" type="text/css">
<link href="../resources/styles/faceted_annotation.css" rel="stylesheet" type="text/css">
<script type="text/javascript" language="JavaScript" src="../resources/scripts/open_edit_window.js"></script>
</head>

<body>
<!-- TODO: use the main header file, unless there is a reason to use annot_header.jsp -->
<%@ include file="annot_header.jsp" %>

<div class="annotation_menu_container">

	<div class="annotation_menu_photo">
		<a href="../photo_details.jsp?photoID=<%=m_photo.getID()%>">
			<img class="photo" src="<%=m_photo.getURL("../",null,200)%>">
		</a>
	</div>

<div class="annotation_menu_option_container">
	<div class="annotation_menu_header">Add new annotation:</div> 
	<%
		// null in listAnnotationClasses could be namespace (maybe user.getNamespace() or somthing)
		// null will return all annotation classes in all namespaces
		String namespace = u.getRDFNameSpace();
		if(namespace.equals("")) {
			namespace = null;
		} else {
			namespace = namespace+"#";
		}
		Iterator i=RDFManipulator.listAnnotationClasses(namespace).iterator();
		while (i.hasNext()) {
			String[] s=(String[])i.next();
			//System.out.println("annotate -- "+s[0]+"-"+s[1]+"-"+subjectURI);
			String createQry="subjectURI="+URLEncoder.encode(StringUtils.stripBaseURI(subjectURI))+
				"&classURI="+URLEncoder.encode( StringUtils.stripBaseURI(s[0]) )+
			 	"&parentURL="+URLEncoder.encode(request.getRequestURI()+"?"+request.getQueryString());
	%>
			<div class="annotation_menu_option">
				<a href="javascript:open_edit_window_scrollable(escape('./createinstance.jsp?<%= URLEncoder.encode(createQry) %>'),'CreateInstance',800,600);"><%= s[1] %></a>
			</div>
	<%
		} // end while 
	%>
</div><!-- end menu option container -->


<div style="clear:both;">
<div class="annotation_list_header">Existing Annotations</div>
<hr>
<div class="annotation_list_container">



<%
	String prevType="";

	while (anot2Iter.hasNext()) {
		AnnotationWrapper aw=(AnnotationWrapper)anot2Iter.next();
		if (aw.getHidden()) {
			continue;
		}
		
		//Links to edit, delete and view history for an annotation
		String editLink = "";
		String deleteLink = "";
		String historyLink = "";
		
		String annotType=aw.getClassLabel();
		
		//Build the edit link
		String createQry="subjectURI="+URLEncoder.encode(StringUtils.stripBaseURI(aw.getURI()))+
				"&classURI="+URLEncoder.encode( StringUtils.stripBaseURI(RDFManipulator.getInstanceClass(aw.getURI())) )+
			 	"&parentURL="+URLEncoder.encode(request.getRequestURI()+"?"+request.getQueryString());
		editLink = "[<a href=\"javascript:open_edit_window_scrollable(escape('./createinstance.jsp?"+createQry+"'),'CreateInstance',800,600);\">Edit</a>]";
		
		//Build the Delete Link if current user is the owner
		if (u.getURI().equals(aw.getCreatorURI())) {
			String deleteQry="subjectURI="+URLEncoder.encode(StringUtils.stripBaseURI(aw.getURI()))+
				"&parentURL="+URLEncoder.encode(request.getRequestURI()+"?"+request.getQueryString());
			deleteLink = "[<a href=\"./delete_annotation.jsp?"+deleteQry+"\">Delete</a>]";
		}
		
		//Build the History Link if necessary
		if (RDFManipulator.isAnnotationObject(aw.getEditSubjectURI())) {
			String historyQry="subjectURI="+URLEncoder.encode(StringUtils.stripBaseURI(aw.getURI()))+
				"&parentURL="+URLEncoder.encode(request.getRequestURI()+"?"+request.getQueryString());
			historyLink = "[<a href=\"javascript:open_edit_window_scrollable(escape('./annotation_history.jsp?"+historyQry+"'),'ViewHistory',640,600);\">View&nbsp;History</a>]";
		}
		
		
		// If this is a new type of annotation, redraw header
		if (!prevType.equals(annotType)) {
%>
			<h1><%= annotType %></h1>
<%
			
			Iterator pdIter=aw.getFullPropList().iterator();
			while (pdIter.hasNext()) {
				PropertyDescriptor pd = (PropertyDescriptor)pdIter.next();
%>
				<!--Possible annotation types listed here-->
<%
			} // end while
		} // end if
		prevType=annotType;

%>
	<%=editLink%> <%=deleteLink%> <%=historyLink%> Created By: <%=(String)aw.getPropMap().get("CREATED_BY")%><!-- on <%=aw.getTimestamp()%> -->
	<%=StringUtils.getMapAsIndentedHTML(aw.getPropMap(), false)%>
<%
	} // end while
%>
</div>
<!-- end annotation list container -->
</div>

</body>
</html>