<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.rdf.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.net.URLEncoder" %>

<%
	String username = request.getRemoteUser();
	IUser u = UserManager.getByUsername(username);	
	
	String parentURL=request.getParameter("parentURL");
	String sessPropName=request.getParameter("sessPropName");
	String rootClassURI=request.getParameter("rootURI");
	String leafClassURI=request.getParameter("leafURI");
//System.out.println("treebrowse.jsp:\n\t"+parentURL+"\n\t"+rootClassURI+"\n\t"+leafClassURI);
	if (rootClassURI==null) { // very bad
		response.sendRedirect("../index.jsp"); // but should handle it better than this
	}
	String submit=request.getParameter("submit");
	if ("done".equals(submit)) {
		// store current leaf in the session and redirect to parent
		session.setAttribute(sessPropName, leafClassURI);
		response.sendRedirect(parentURL);
	}
	if (leafClassURI==null) { // if no start specified...
		leafClassURI=rootClassURI; // start at root 
		//System.out.println("leaf="+leafClassURI);
	}
	List activeBC=RDFManipulator.getTaxonomyPath(rootClassURI, leafClassURI);
	List inactiveBC=RDFManipulator.getTaxonomyPath(rootClassURI);
	Iterator activeIter=activeBC.iterator();
	Iterator inactiveIter=inactiveBC.iterator();
%>
<html>
<head>
<title>Taxonomy Browser</title>
<link href="../resources/styles/master.css" rel="stylesheet" type="text/css">
<link href="../resources/styles/faceted_annotation.css" rel="stylesheet" type="text/css">
</head>
<body>

<div class="treebrowse_instructions">
Click "-&gt;" to navigate deeper down into hierarchy.<br>
Click hyperlinked breadcrumbs to navigate up/back.<br>
Click "done" to select highlighted item.<br>
</div>
<br>
<br>

<form method=GET>
<%	while (inactiveIter.hasNext()) {
		String[] s=(String[])inactiveIter.next();
%>
		<%= s[1] %>&nbsp;&gt;&nbsp;
<%	} // end while

	while (activeIter.hasNext()) {
		String[] s=(String[])activeIter.next();
		String breadCrumbQry="rootURI="+URLEncoder.encode(rootClassURI)+
			"&leafURI="+URLEncoder.encode(s[0])+
			"&parentURL="+URLEncoder.encode(parentURL)+
			"&sessPropName="+URLEncoder.encode(sessPropName);
%>
		<a href="./treebrowse.jsp?<%= breadCrumbQry %>"><%= s[1] %></a>&nbsp;&gt;&nbsp;
<%
	} // end while 
%>
	<!--finally gotta put current leaf node in bread crumbs (not hyerlinked)-->
	<%= RDFManipulator.getClassLabel(leafClassURI) %>

<input type=hidden name=rootURI value="<%= rootClassURI %>">
<input type=hidden name=sessPropName value="<%= sessPropName %>">
<input type=hidden name=parentURL value="<%= parentURL %>">

<%	if (RDFManipulator.hasTaxonomyChildren(leafClassURI)) {

		Iterator leafIter=RDFManipulator.getTaxonomyChildren(leafClassURI).iterator();
		String options="";
		int size=0;
		String selected="selected";
		while (leafIter.hasNext()) {
			String[] s=(String[])leafIter.next();
			options=options+"<option value='"+s[0]+"' "+selected+">"+s[1]+"</option>\n";
			size++;
			selected="";
		}
		if (size>10) {
			size=10;
		}
%>
		&nbsp;&gt;&nbsp;
		<select name=leafURI size=<%= size %> style="vertical-align:top;">
		<%= options %>
		</select>
		<input type=submit name="submit" value="->">
<%
	} else { // no children
%>
		<input type=hidden name=leafURI value="<%= leafClassURI %>">
<%
	} // end if hasTaxonomyChildren
%>
<br><br>
<input type=submit name="submit" value="done">
</form>
</body>
</html>