<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.util.StringUtils" %>
<%@ page import="java.util.*" %>

<%
	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);

	int m_photoID = -1;
	String temp = request.getParameter("photoID");
	try{
		m_photoID = Integer.parseInt(temp);
	}catch(NumberFormatException nfe){
		//TODO: close this window
		return;
	}
	
	IPhoto m_photo = PhotoFactory.getPhotoByID(m_photoID);
	if(m_photo==null){
		return;
	}
	
	if( m_photo.getOwner().getID() != m_user.getID() ){
		out.write("<div style='color: red'>You're not the owner of this picture!</div>");
		return;
	}
	
	IContext m_context = m_photo.getContext();
	if(m_context==null){
		m_context = ContextManager.createContext(new Date());//TODO: don't create new context from the current date.
		m_photo.setContext(m_context, m_user);
	}
	
	if(	(request.getParameter("location") != null) ){
		
			String location = StringUtils.showSafeHTML(request.getParameter("location") );
			String new_location = request.getParameter("new_location");
			if(new_location==null)
				new_location="";
			if(location.equals("0"))
				location = StringUtils.showSafeHTML(new_location);

			if(location != null){
				IContext cont = m_photo.getContext();
				if(cont != null)
					cont.setLocationLabel(location);
			}
			
			%>
			<html>
			<head>
			<script language="JavaScript" src="resources/scripts/open_edit_window.js"></script>
			</head>
			<body onload="reload_parent_and_close('photo_details.jsp?id=<%=m_photo.getID()%>')">
			</body>
			</html>
			<%
	}


%>
<html>
<head>
<title>Edit Photo</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
</head>

<body>
<%@ include file="popup_header.jsp" %>
<table border="0" >
<form method="get" action="edit_location_label.jsp" name="edit_location_label">
<input type="hidden" name="photoID" value="<%=m_photo.getID()%>">
	<tr>
		<td colspan="3" align="left"><h1>Edit Photo</h1></td>
	<tr>
		<td align="right" valign="top">Location</td>
		<td>&nbsp;&nbsp;&nbsp;</td>
		<td align="left">

		<select size="1" name="location">
		<option selected value="0">Choose location...</option>
		<% 
		IContext context = m_photo.getContext();
		Iterator labels = ContextManager.listLocationLabels(context.getNetwork(), context.getLac(), context.getCellId()).iterator();
		while(labels.hasNext()){
			String label = (String)labels.next();
			out.println("<option>"+StringUtils.showSafeHTML(label)+"</option>");
		}
		%>
		</select>
		<br><br>
		Or, create new location label:<br>
		<input type="text" name="new_location">	
		<br><br>
		<input type="submit" value="Update Photo">
	</td>		
	</tr>
</form>
</table>

</body>
</html>
