<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.rdb.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>


<%!
	final String PREFIX = "photo_";
	
	String checkPhoto(IPhoto p, int w, int h) {
		return "<table style=\"display : inline;\"><tr><td bgcolor='#666666' width='"+w+"' height='"+h+"'>" +
			"<a href=\"/photo_details.jsp?photoID=" + p.getID() + "\" target=\"_blank\">" +
		    "<img border=\"0\" width=\""+w+"\" height=\""+h+"\" src=\"/" + p.getURL(null, null, w, h) + "\">" +
		    "</a>" +
		    "<input name='"+PREFIX+p.getID()+"' type='checkbox'>"+
		    "</td></tr></table>";
	}
%>


<%
	
	final String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);

	final String location = request.getParameter("location");
	String minutes = request.getParameter("minutes");
	if(minutes==null) 
		minutes = "15";
	final boolean update = "true".equals(request.getParameter("update"));
	final boolean remove = "true".equals(request.getParameter("remove"));
	
		
	final String[] minuteOptions = {"5", "15", "30", "45", ""+(60*1),""+(60*2),""+(60*3),""+(60*12), "all"};
	
	
	if(update==true || remove==true) {
		// Save Changes
		out.println("<table><tr><td bgcolor=lightgreen>");
		Enumeration photos = request.getParameterNames();
		while(photos.hasMoreElements()) {
			String photoName = (String) photos.nextElement();
			if(photoName.indexOf(PREFIX)>-1) {
				photoName = photoName.substring(PREFIX.length());
				if(photoName!=null) {
					out.print("PhotoID "+photoName+":");
					try {
						IPhoto m_photo = PhotoFactory.getPhotoByID(Integer.parseInt(photoName));
						IContext cont = m_photo.getContext();
						if(cont != null) {
						
							if(update==true) {
								cont.setLocationLabel(location);
								System.out.println("LOG: Set context "+cont.getID()+" to '"+location+"'");
								out.print("(Set context "+cont.getID()+" to '"+location+"')");
							} else if(remove==true) {
								cont.setLocationLabel(null);
								System.out.println("LOG: Set context "+cont.getID()+" to null");
								out.print("(Set context "+cont.getID()+" to null)");							
							}
														
						} else {
							out.print("(missing context)");
							System.err.println("Missing context for photo id "+m_photo.getID());
						}
						
						out.println("; ");
					} catch(NumberFormatException nfe){
						out.println(nfe);
					}
				}
			}
		}
		out.println("</td></tr><table>");
	}
%>
<html>
<head>
<title>Edit Photo Location - Batch</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="/resources/styles/master.css" rel="stylesheet" type="text/css">
</head>

<body>
<%@ include file="../popup_header.jsp" %>

<table border="1" >
<form method="post" action="edit_location_label_batch.jsp" name="edit_location_label">
<tr>
	<td align="right" valign="top">Location</td>
	<td align="left">

	<select size="1" name="location">
<%
	ResultSetWrapper rsw = RDBConnection.executeQuery("select count(1),location_label from context group by location_label order by count desc");
	try {
	    ResultSet rs = rsw.getResultSet();
	    while (rs.next()) {
		    if(!"null".equalsIgnoreCase(rs.getString(2))) {
		    	out.print("<option");
		    	if(location!=null && location.equals(rs.getString(2)))
		    		out.print(" selected");
		    	out.println(" value=\""+rs.getString(2)+"\">"+rs.getString(2)+" ("+rs.getString(1)+")</option>");
		    }
	    }
	} catch (SQLException e) {
	    e.printStackTrace();
	} finally {
	    rsw.closeAll();
	}
%>
	</select>
	
	<select size="1" name="minutes">
<%
	for(int i=0; i<minuteOptions.length; i++) {
		out.print("<option");
		if(minuteOptions[i].equals(minutes))
	    	out.println(" selected");
		out.println(">"+minuteOptions[i]+"</option>");
	}
%>		
	</select>
	<input type="submit" value="Change Location Horizon">
	</td>		
</tr>
<tr>
<td></td>
<td>

<input type="radio" name="method" value="proximity" <%=(request.getParameter("method")==null||"proximity".equals(request.getParameter("method")))?"checked":""%>> Proximity &nbsp;&nbsp;&nbsp;&nbsp;
<input type="radio" name="method" value="cell"      <%=("cell".equals(request.getParameter("method")))?"checked":""%>> Cell
</td>
</tr>
</form>
</table>
<hr><hr>

<form method="post" action="edit_location_label_batch.jsp">
<input type="hidden" name="minutes" value="<%=minutes%>">
<input type="hidden" name="update" value="true">

<%
	if(location!=null) {
	
		String query;
		
		if("cell".equals(request.getParameter("method"))) {
			query = "select distinct p2.id as photo_id " +
			"from context c, context c2, photo p2 " +
			"where c.location_label = '"+location+"' " +
			"and c.cell_id = c2.cell_id " +
			"and c2.id = p2.context_id " +
			"and c2.location_label is null " +
			"and c.cell_id is not null ";
			if(!"all".equals(minutes)) {
				query += "and c2.sample_time > (c.sample_time - interval '"+minutes+" minutes') " +
				"and c2.sample_time < (c.sample_time + interval '"+minutes+" minutes') ";
			}
		} else {
			query = "select distinct p.id as photo_id "
		    // , u.id as user_id, cb.bt_mac, c2.location_label " 
			+ "from photo p, mmm_user u, person_bluetooth pb, " 
			+ "context c, context_bluetooth cb, context c2 " 
			+ "where p.created_by = u.id " 
			+ "and c2.id = p.context_id " 
			+ "and pb.person_id = u.id " 
			+ "and c.location_label = '"+location+"' " 
			+ "and cb.context_id = c.id " 
			+ "and cb.bt_mac = pb.bt_mac " 
			+ "and c2.location_label is null ";
			if(!"all".equals(minutes)) {
				query += "and p.capture_date > (c.sample_time - interval '"+minutes+" minutes') " 
				+ "and p.capture_date < (c.sample_time + interval '"+minutes+" minutes') " ;
			}
		    
			//+ "and c.cell_id = c2.cell_id"
		}
		
		
		rsw = RDBConnection.executeQuery(query);
	    ResultSet rs = rsw.getResultSet();
	    ArrayList photos = new ArrayList();
	    try {
	        while (rs.next()) {
	            int id = rs.getInt("photo_id");
	            IPhoto p = PhotoFactory.getPhotoByID(id);
	            if (p != null) {
	                photos.add(p);
	            }
	        }
	    } catch (SQLException e) {
	        e.printStackTrace();
	    } finally {
	        rsw.closeAll();
	    }
	    
	    
		for (int i = 0; i < photos.size(); i++) {
		    IPhoto p = (IPhoto) photos.get(i);
		    out.println(checkPhoto(p,150, 112));
		}
    }

	if(location!=null) {
		out.println("Will tag selected photos as this location:<br><br>");
		out.println("<select size='1' name='location'>");
		rsw = RDBConnection.executeQuery("select count(1),location_label from context group by location_label order by count desc");
		try {
	    	ResultSet rs = rsw.getResultSet();
	    	while (rs.next()) {
	    		out.print("<option");
	    		if(location!=null && location.equals(rs.getString(2)))
	    			out.print(" selected");
	    		out.println(">"+rs.getString(2)+"</option>");
	    	}
		} catch (SQLException e) {
	    	e.printStackTrace();
		} finally {
	    	rsw.closeAll();
		}
		out.println("</select><br>");
%>

Searched for Page Location: <%=location%>
<br>
<input type='submit' value='Update Checked Photo Locations'>
</form>
<hr>
<h2>Seed Data Set</h2>
<i>Check a picture to reset its Location</i>
<form method="post" action="edit_location_label_batch.jsp">
<input type="hidden" name="minutes" value="<%=minutes%>">
<input type="hidden" name="remove" value="true">
<%
		String query = "select distinct p.id as photo_id "
			+ "from photo p, context c " 
			+ "where c.id = p.context_id " 
			+ "and c.location_label = '"+location+"' ";
		rsw = RDBConnection.executeQuery(query);
	    ResultSet rs = rsw.getResultSet();
	    ArrayList photos = new ArrayList();
	    try {
	        while (rs.next()) {
	            int id = rs.getInt("photo_id");
	            IPhoto p = PhotoFactory.getPhotoByID(id);
	            if (p != null) {
	                photos.add(p);
	            }
	        }
	    } catch (SQLException e) {
	        e.printStackTrace();
	    } finally {
	        rsw.closeAll();
	    }
	    
		for (int i = 0; i < photos.size(); i++) {
		    IPhoto p = (IPhoto) photos.get(i);
		    out.println(checkPhoto(p,60,45));
		}		    
%>
<input type='submit' value='Reset Checked Photo Locations'>
</form>


<%
	} // location!=null
%>
</body>
</html>
