<%@ page language="java"%>
<%@ page import="gcr.mmm2.util.*"%>
<%@ page import="gcr.mmm2.rdb.*"%>
<%@ page import="gcr.mmm2.model.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.sql.*"%>
<%@ page import="java.awt.image.*"%>
<%@ page import="javax.imageio.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.regex.*"%>

<%!// Used once
	static final Pattern filenamePattern = Pattern
			.compile("^((\\d+)_)*((\\d+)[W|M].+\\.(jpg|amr|3gp)$)");

	static final String ORIG_IMAGE_DIR = MMM2Properties.getProperty("ORIG_IMAGE_DIR");

	%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Photo Integrity Check</title>

<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="expires" content="0">
</head>
<body>
<pre>
<%
		IPhoto photo = null;
		String filename;
		File file;
		BufferedImage bi;
		int good = 0, bad = 0;

		// get list of all photos
		String query = "SELECT id FROM photo ";
		if(request.getParameter("start")!=null) 
			query += " where id>"+Integer.parseInt(request.getParameter("start")) + " ";
		query += "order by id ";

		// populate the arraylist with photo objects
		final ResultSetWrapper rsw = RDBConnection.executeQuery(query);
		final ResultSet rs = rsw.getResultSet();

		final List m_photos = new ArrayList();
		try {
			while (rs.next()) {
				m_photos.add(new PhotoImpl(rs.getInt(1), true));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			rsw.closeAll();
		}

		for (int i = 0; i < m_photos.size(); i++) {
			try {
				photo = (IPhoto) m_photos.get(i);

				filename = photo.getJPEGFilename();

				Matcher m = filenamePattern.matcher(filename);
				if (!m.matches())
					throw new Exception("INVALID_FORMAT," + filename);

				int userID = Integer.parseInt(m.group(4));
				filename = ORIG_IMAGE_DIR + "/" + userID + "/" + filename;
				file = new File(filename);

				if (!file.canRead())
					throw new IOException("MISSING," + file.getAbsolutePath());
				if (file.length() < 1)
					throw new IOException("EMPTY," + file.getAbsolutePath());

				if ("true".equals(request.getParameter("images"))) {
					if (filename.endsWith("jpg")) {
						bi = ImageIO.read(file);

						if (bi == null)
							throw new NullPointerException("CORRUPT,"
									+ file.getAbsolutePath());

						if (bi.getHeight() < 1 || bi.getWidth() < 1) {
							throw new IOException("CORRUPT_SIZE,"
									+ file.getAbsolutePath());
						}

						bi = null;
					}
				}

				good++;
			} catch (Exception e) {
				out.println(photo.getID() + "," + photo.getOwner().getID()
						+ "," + e.getMessage());
				bad++;
			}
			out.flush();

		}

		%>

</pre>
<h1>Good, Bad</h1>
<%=good%>
,
<%=bad%>
</body>
</html>
