<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
    "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<%@ page language='java'%>
<%@ page import="gcr.mmm2.model.*"%>
<%@ page import="gcr.mmm2.tag.*"%>
<%@ page import="gcr.mmm2.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.awt.Rectangle"%>
<%@ page import="java.awt.Point"%>
<%!
	static final int IMG_WIDTH = 75;
	static final int IMG_HEIGHT = 75;
	static final int MAX = 600;
	
	String displayPhoto(IPhoto p, int rank) {
        StringBuffer buff = new StringBuffer();

        Point pt = rn.get(rank).getPhotoTopLeftCornerPoint();
        buff.append("<img src=\"/").append(p.getURL(null, null, rn.getPhotoSize().width, rn.getPhotoSize().height, true));
        buff.append("\" name=\"p"+p.getID()+"\" ");
        buff.append("width=\""+rn.getPhotoSize().width+"\" ");
        buff.append("height=\""+rn.getPhotoSize().height+"\" ");
        buff.append("style=\"position:absolute;left:").append(pt.x).append("px;top:").append(pt.y).append("px;\" ");
        //.append("px;width:").append(rn.getPhotoSize().width).append("px;height:").append(rn.getPhotoSize().height).append("px;\" ");
        buff.append("/>");

        return buff.toString();
    }

	
	String displayTags(int type, Taggable[] tm, HttpServletRequest request) {
	    StringBuffer buff = new StringBuffer();
		String[] values = Taggable.getTagValues(type, tm);
		for(int i=0; i<values.length; i++) {
		    buff.append("<a href=\"metadata_propagation.jsp?");
		    
		    for(int j=0; j<TaggableMedia.MEDIA_TYPES.length; j++) {
		        if(request.getParameter(""+TaggableMedia.MEDIA_TYPES[j])!=null) { 
		            buff.append(TaggableMedia.MEDIA_TYPES[j]).append("=").append(request.getParameter(""+TaggableMedia.MEDIA_TYPES[j]) +"&");
		        }
		    }
		    
		    
		    buff.append(type).append("=").append(values[i]).append("&");
		    buff.append("\" >");
		    buff.append(values[i]).append("</a><br/>\n");
		}
		return buff.toString();
	}
	
	//Point origin, Rectangle photoSize, int photoPadding, Rectangle screenSize)
	static final RankedNearness rn = new RankedNearness(new Point(0,0),
            new Rectangle(IMG_WIDTH,IMG_HEIGHT),5,new Rectangle(1024,2000));
%>


<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >
<head>
<meta http-equiv="Content-Type" content="application/xhtml+xml; charset=UTF-8" />
<title> Metadata Propagation</title>
<link href="/resources/styles/propagation.css" rel="stylesheet" type="text/css" />
</head>

<body>
<script type="text/javascript" src="../resources/scripts/wz_dragdrop.js"></script>
<form name="form" method="post" action="metadata_propagation.jsp">

<%
	

	final String username = request.getRemoteUser();
	final IUser m_user = UserManager.getByUsername(username);
	final List m_photos = PhotoFactory.listAllOwnedPhotos(m_user);
	Collections.reverse(m_photos);
	final IPhoto[] photos = (IPhoto[]) m_photos.toArray(new IPhoto[0]);
	
	String photoNames ="";
	int photoCount =0;
	
	final TaggableMedia tm[] = new TaggableMedia[Math.min(photos.length, MAX)];
	for(int i=0; i<tm.length; i++) {
	    tm[i] = TaggableMedia.getTaggablePhoto(photos[i]);
	    tm[i].cacheAll();
	    System.out.print(".");
	}
	
	Taggable[] filtered = tm;
	
	for(int i=0; i<TaggableMedia.MEDIA_TYPES.length; i++) {
	    if(request.getParameter(""+TaggableMedia.MEDIA_TYPES[i])!=null) { 
	        filtered = Taggable.filterOnTag(TaggableMedia.MEDIA_TYPES[i], request.getParameter(""+TaggableMedia.MEDIA_TYPES[i]), filtered);
	    }
	}
	
%>


<!-- ********* -->
<!-- SECTION 1 -->
<!-- ********* -->
<div class="hSec1">My Tags</div>
<div class="Sec1">
Fug Sunday<br/>
Yummy<br/>
Log</div>

<!-- ********* -->
<!-- SECTION 2 -->
<!-- ********* -->
<div class="hSec2">Time</div>
<div class="Sec2">
<table border="0" cellspacing="10">
<tr>
<td valign="top">
<%=displayTags(TaggableMedia.CONTEXT_TIME_YEAR, filtered, request)%>
</td>
<td valign="top">
<%=displayTags(TaggableMedia.CONTEXT_TIME_MONTH, filtered, request)%>
</td>
<td valign="top">
<%=displayTags(TaggableMedia.CONTEXT_TIME_DAYOFWEEK, filtered, request)%>
</td>
</tr></table>
</div>

<!-- ********* -->
<!-- SECTION 3 -->
<!-- ********* -->
<div class="hSec3">Location</div>
<div class="Sec3">
<%=displayTags(TaggableMedia.CONTENT_LOCATION, filtered, request)%>
</div>

<!-- ********* -->
<!-- SECTION 4 -->
<!-- ********* -->
<div class="hSec4">People</div>
<div class="Sec4">
<%=displayTags(TaggableMedia.CONTEXT_PEOPLE_NEARBY, filtered, request)%>
</div>

<!-- ********* -->
<!-- SECTION 5 -->
<!-- ********* -->
<div class="hSec5">x in set</div>
<div class="Sec5">
pretty pictures go here
</div>

<!-- ********* -->
<!-- SECTION 5 -->
<!-- ********* -->
<div class="hSec6">Your Photos where  
<%
for(int i=0; i<TaggableMedia.MEDIA_TYPES.length; i++) {
    if(request.getParameter(""+TaggableMedia.MEDIA_TYPES[i])!=null) { 
        out.println(TaggableMedia.getTagDescription(TaggableMedia.MEDIA_TYPES[i]) + "=" + request.getParameter(""+TaggableMedia.MEDIA_TYPES[i]) +", ");
    }
}
%>
</div>
<div class="Sec6">
<%
	
	for(int i=0; i<filtered.length; i++) {
	    TaggableMedia item = (TaggableMedia)filtered[i];
	    IPhoto p = item.getPhoto();
	    out.println(displayPhoto(p, i));
	    photoCount++;
	    photoNames += "\"p" + p.getID() + "\"";
	    if (i != filtered.length-1)
			photoNames += ","; 
	}
%>
</div>



</form>
<script type="text/javascript">
<!--
SET_DHTML(CURSOR_MOVE, TRANSPARENT, <%=photoNames%>);

// The following loop creates a copy for each of the two images,
// but hides that copy immediately while the page is still loading
for (var i = 0; i < <%=photoCount%>; i++)
{
    dd.elements[i].copy();
    dd.elements[i].copies[0].hide();
}

// The following two functions override their empty namesakes predefined in wz_dragdrop.js.
// They are automatically invoked from wz_dragdrop.js when a drag operation starts
// and ends, respectively.

// Here we make the non-transparent 'placeholder' copy of the dragged image visible
// and move it to the place where the drag operation starts
function my_PickFunc()
{
    dd.obj.copies[0].moveTo(dd.obj.x, dd.obj.y);
    dd.obj.copies[0].show();
}

//Hide the 'placeholder' again
function my_DropFunc()
{
    dd.obj.copies[0].hide();
    
    // Write the name and coordinates of the dropped item into form inputs:
    //document.myForm.NAME.value = dd.obj.name;
    //document.myForm.X.value = dd.obj.x;
    //document.myForm.Y.value = dd.obj.y;
}
//-->
</script>

</body>
</html>
