<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.util.StringUtils" %>
<%@ page import="gcr.mmm2.server.servlets.JpegRotator" %>
<%@ page import="gcr.mmm2.rdb.*" %>
<%@ page import="java.sql.ResultSet" %>
<%@ page import="java.sql.SQLException" %>

<%
	int i_max_columns = 3;
	int timeRange = MediaManager.ALL;
	//int ownerFilter = MediaManager.UNRESTRICTED_OWNED_PHOTOS;
	int ownerFilter = MediaManager.OWNED_PHOTOS;
	String pageTitle = "Pictures";

	
	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);
	
	if(request.getParameter("range") != null) {
		timeRange = Integer.parseInt(request.getParameter("range"));
	}
	
	if(request.getParameter("ownerFilter") != null) {
		ownerFilter = Integer.parseInt(request.getParameter("ownerFilter"));
	}
	
	switch(ownerFilter) {
		case(MediaManager.ALL_VISIBLE):
			pageTitle = "All ";
			break;
		case(MediaManager.OWNED_PHOTOS):
			pageTitle = "My ";
			break;
		case(MediaManager.RECEIVED_PHOTOS):
			pageTitle = "Received ";
			break;
		case(MediaManager.UNRESTRICTED_OWNED_PHOTOS):
			pageTitle = "My Unrestricted ";
			break;
		default:
			break;
	}
	
	switch(timeRange) {
		case(MediaManager.TODAY):
			pageTitle = pageTitle + "Pictures From Today";
			break;	
		case(MediaManager.PREV_7):
			pageTitle = pageTitle + "Pictures From The Previous 7 Days";
			break;
		case(MediaManager.PREV_14):
			pageTitle = pageTitle + "Pictures From The Previous 14 Days";
			break;
		case(MediaManager.THIS_MONTH):
			pageTitle = pageTitle + "Pictures From This Month";
			break;
		case(MediaManager.THIS_YEAR):
			pageTitle = pageTitle + "Pictures From This Year";
			break;
		case(MediaManager.SHOEBOX):
			pageTitle = "My Shoebox";
			break;
		case(MediaManager.NEWEST):
			pageTitle = "Newest Uploaded Photos";
			break;
		case(MediaManager.ALL):
			pageTitle = "Pictures From Forever";
			break;
		default:
			pageTitle = "All Pictures";
			break;
	}
	
	pageTitle="Face Annotation "+pageTitle;

	
	if( (request.getParameter("operation") != null ) && (request.getParameter("photoID") != null) ){
	    String photoID = request.getParameter("photoID");
		int pID = Integer.parseInt(photoID);
		
		IPhoto photo = PhotoFactory.getPhotoByID(pID);

	    String op = request.getParameter("operation");
	    if(op.equals("rotateR")){
			String filename=MediaManager.getRealPath(photo.getJPEGFilename());
			JpegRotator.rotateImage(filename, JpegRotator.ROTATE_90_RIGHT);
			photo.clearCachedImages();
	    }else if(op.equals("rotateL")){
			String filename=MediaManager.getRealPath(photo.getJPEGFilename());
			JpegRotator.rotateImage(filename, JpegRotator.ROTATE_90_LEFT);
			photo.clearCachedImages();
	    }else if(op.equals("delete")){
	        photo.delete(m_user);
	    }
	    if(session.getAttribute("actionRedirect") != null){
	    	response.sendRedirect((String)session.getAttribute("actionRedirect"));
	    }
	}
	
	List m_photos = new ArrayList();

	if(timeRange != MediaManager.NEWEST && timeRange != MediaManager.SHOEBOX){

	 	switch(ownerFilter) {
			case(MediaManager.ALL_VISIBLE):
				m_photos = PhotoFactory.listAllVisiblePhotosByTime(m_user, timeRange);
				break;
			case(MediaManager.OWNED_PHOTOS):
				m_photos = PhotoFactory.listAllOwnedPhotosByTime(m_user, timeRange);
				break;
			case(MediaManager.RECEIVED_PHOTOS):
				m_photos = PhotoFactory.listAllReceivedPhotosByTime(m_user, timeRange);
				break;
			case(MediaManager.UNRESTRICTED_OWNED_PHOTOS): 
				m_photos = MediaManager.listOwnedUnrestrictedPhotosByTime(m_user, timeRange);			
				break;
			default:
				m_photos = PhotoFactory.listAllVisiblePhotosByTime(m_user, timeRange);
				break;
		}          	 
	}else if(timeRange == MediaManager.SHOEBOX){
		m_photos = MediaManager.listUngroupedPhotos(m_user);
	}else{
		m_photos = MediaManager.listNewestOwnedPhotos(12, m_user);
	}
	
	// new stuff to get annotation count per photo
	String countQuery="select pip.photo_id, count(*) from photo p, person_in_photo pip where pip.photo_id=p.id and p.created_by="+m_user.getID()+" group by photo_id";
	ResultSetWrapper rsw = RDBConnection.executeQuery(countQuery);
	ResultSet rs = rsw.getResultSet();
	HashMap annotationCounts=new HashMap();
	try {
		while (rs.next()) {
			int id = rs.getInt(1);
			int count = rs.getInt(2);
			annotationCounts.put(new Integer(id), new Integer(count));
		}
	} catch (SQLException e) {
		e.printStackTrace();
	} finally {
		rsw.closeAll();
	}
	
	
	ArrayList currentCollection = new ArrayList();
	currentCollection.addAll(m_photos);
	ArrayList idArray = new ArrayList(currentCollection.size());
	for(int i = 0; i < currentCollection.size(); i++){
		IPhoto p = (IPhoto)currentCollection.get(i);
		idArray.add(new Integer(p.getID()));
	}
	
	session.setAttribute("collection", idArray);
	session.setAttribute("collectionTitle", pageTitle);
	session.setAttribute("actionRedirect", request.getRequestURL().toString()+"?"+request.getQueryString());

	// The Command Menu
	String commandMenu =  
	"<table>" + "\n" +
           "<tr>" + "\n" +
             "<td>select:&nbsp;<a class=\"collection_menu_item2\" href=\"javascript:select_all_photos(true)\">all</a>&nbsp;<a class=\"collection_menu_item2\" href=\"javascript:select_all_photos(false)\">none</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + "\n" +
	     "</td>" + "\n" +
	     "<td>" + "\n" +
	       "<select onChange=\"do_selected_action(this.options[this.selectedIndex].value)\" name=\"collection_actions\">" + "\n" +
		 "<option>-- choose action --</option>" + "\n" + 
		 "<option value=" + new Integer(MediaManager.SHARE).toString() + ">share selected</option>" + "\n" +
		 "<option value=" + new Integer(MediaManager.ADD).toString() + ">add to album</option>" + "\n" +
		 "<option value=" + new Integer(MediaManager.RESTRICT).toString() + ">set as restricted</option>" + "\n" +
		 "<option value=" + new Integer(MediaManager.UNRESTRICT).toString() + ">set as unrestricted</option>" + "\n" +
	       "</select>" + "\n" +	  
	     "</td>" + "\n" +
	     "</td>" + "\n" +
           "</tr>" + "\n" +
	 "</table>";
%>

<html>
<head>
<title><%=pageTitle%></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
<script type="text/javascript">
        var photoSelected = false;

	function set_notice(tf)
        {
	    if (tf == true) {
                photoSelected = true;
	    }
	    else {
                photoSelected = false;
	    }
        }

	function make_album_from_selected()
	{
		if(photoSelected){
			document.photogrid.action = "add_to_album.jsp";
			document.photogrid.submit();
		}else{
			alert("Please select an image (or a bushel of images) to place in an album.");
		}
	}
	
	function share_selected()
	{
		if(photoSelected){
			document.photogrid.action = "sharemedia.jsp";
			document.photogrid.submit();
		}else{
			alert("Please select an image (or two!) to share.");
		}
	}
	
	function select_all_photos(tf)
	{
		var checkboxes = document.photogrid.elements;
		for(i=0;i<checkboxes.length;i++){
			checkboxes[i].checked=tf;
		}
		if (checkboxes.length > 0) {
			photoSelected = tf;
		}
	}

	function set_restriction(tf)
	{
	  // need to send off selected pictures to another jsp page to process
          // tat jsp page will set the restriction information on the pics
	  if(photoSelected){
	      document.photogrid.action = "setrestriction.jsp";
	      document.photogrid.restriction.value = tf;
	      document.photogrid.submit();
	  }
        }

	function do_selected_action(opt)
	{
	  if (opt == <%=MediaManager.SHARE%>) {
            share_selected();
	  }
	  else if (opt == <%=MediaManager.ADD%>) {
            make_album_from_selected();
	  }
	  else if (opt == <%=MediaManager.RESTRICT%>) {
            set_restriction(<%=IPhoto.RESTRICTED_PRIVACY%>);
	  }
	  else if (opt == <%=MediaManager.UNRESTRICT%>) {
            set_restriction(<%=IPhoto.UNRESTRICTED_PRIVACY%>);
	  }
          var selects = document.photogrid.collection_actions;
          for (i = 0; i < selects.length; i++) {
              selects[i].selectedIndex = 0;
          }
	}
</script>
</head>

<body>
<%@ include file="header.jsp" %>

<!-- Center Column / (PhotoGrid) -->
<div class="center_column">
<form name="photogrid" method="get" action="">
        <input type="hidden" name="restriction" value=""/>
	<div class="collection_icon">
		<img src="resources/images/icons/PicturesIcon.gif" alt="Pictures">
	</div>
	<div class="collection_title_container">
		<div class="collection_title">
			<%=pageTitle%>
		</div>
		<div class="collection_count">
			<strong><%=m_photos.size()%> Images in this Set</strong>
		</div>
	</div>
	<div class="collection_menu"><%=commandMenu%></div>
	<div class="photo_grid">
	<%
	int i_cur_column = 0;
	Iterator i = m_photos.iterator();
	while (i.hasNext()) {
        IPhoto p = (IPhoto)i.next();
        if(p == null){continue;}
        
        Integer fc=(Integer)annotationCounts.get(new Integer(p.getID()));
        String faceCount="";
        if (fc==null) {
        	faceCount="0 face annotations";
        } else {
        	faceCount=fc.toString()+" face annotations";
        }
        
        if(i_cur_column == 0){
            out.write("<div class='photo_row'>\n");
        }
	%>
		<div class="thumbnail_container">
		    <%
			if(m_user.getID() == p.getOwner().getID()){
				out.write("<div class='thumbnail_photo_owned'>\n");
			}else{
				out.write("<div class='thumbnail_photo_borrowed'>\n");
			}
			%>
		    	<a href="photo_annotate.jsp?photoID=<%=p.getID()%>">
		    		<img class="photo" src="<%=p.getURL(null,null,200)%>">
		    	</a>
		    </div>
		    <div class="thumbnail_descriptor">
			    <div class="thumbnail_actions">
				    
				    <div class="thumbnail_checkbox">
				    	<input type="checkbox" onclick="set_notice(this.checked)" name="photoID" value="<%=p.getID()%>">
				    </div>
				    <% if( p.getOwner().getID() == m_user.getID() ){ //rotation can only be done by the photo owner%>
					 	<div class="thumbnail_rotation">
						    <div class="thumbnail_rotation_element">
						    <a href="./index.jsp?operation=rotateR&photoID=<%=p.getID()%>">
						    	<img src="/resources/images/buttons/right.gif">
						    </a>
						    </div>
						    <div class="thumbnail_rotation_element">
						    <a href="./index.jsp?operation=rotateL&photoID=<%=p.getID()%>">
						    	<img src="/resources/images/buttons/left.gif">
						    </a>
						    </div>
					    </div>
				    <% }//end if photo owner %>
	
					<div class="thumbnail_date">
				    	<%=StringUtils.formatThumbDateTime(p.getCaptureDate()) %>
						<br><%=faceCount%>
				    </div>
				   
				    <% if( p.getOwner().getID() == m_user.getID() ){ //deletion  and privacy can only be done by the photo owner%>
						<div class="thumbnail_privacy_level"><%=MediaManager.getPrivacyString(p.getPrivacyLevel(m_user))%></div> 
					    <div class="thumbnail_delete_button">
							<a href="./index.jsp?operation=delete&photoID=<%=p.getID()%>">
								<img src="resources/images/buttons/trash.gif" width="18">
							</a>
						</div>
					<% }//end if photo owner %>
				
				</div><!--end thumbnail actions -->
		    	
		    	<% if(!p.getCaption().equals("")){ %>
		    		<div class="thumbnail_caption"><%=p.getCaption()%></div>
		    	<% } %>
		    	
		    	<% if(p.getOwner().getID() != m_user.getID() ){ %>
		    		<div class="thumbnail_owner">Owner: <%=p.getOwner()%></div>
		    	<% } %>
		    	
		    </div><!--end thumbnail_descriptor -->
		</div><!--end thumbnail_container -->
	<%
		if( (i_cur_column == i_max_columns-1) || (!i.hasNext()) ){
	        i_cur_column=0;
	        out.write("</div><!--end photo_row -->\n");
	    }else{
	        i_cur_column++;
	    }
	}
	%>
	</div><!-- end photo_grid -->
	<%
	if(m_photos.size() > (i_max_columns*3) ){
	%>
	<div class="collection_menu"><%=commandMenu%></div>
	<%
	}
	%>
</form>
</div><!-- end center_column -->
	
<!-- right column -->
<div class="right_column"> 
&nbsp;
</div><!-- end right_column -->
	
</body>
</html>
