<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="gcr.mmm2.util.StringUtils" %>
<%@ page import="gcr.mmm2.server.servlets.JpegRotator" %>

<%
	//int timeRange = MediaManager.NEWEST;
	//int ownerFilter = MediaManager.ALL_VISIBLE;
	String pageTitle = "Pictures";
	UIState uiState = (UIState)session.getAttribute("uiState");

	
	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);
	
	if(m_user==null) {
		throw new ServletException("User was null:"+username + ","+m_user);
	}
	
	if(uiState==null) {
		throw new ServletException("UIState was null, please check XML file.");
	}
	
	
	
	if(request.getParameter("range") != null) {
		uiState.setTimeRange(Integer.parseInt(request.getParameter("range")));
		uiState.setPage(1);
	}
	
	if(request.getParameter("ownerFilter") != null) {
		uiState.setOwnerLimit(Integer.parseInt(request.getParameter("ownerFilter")));
		uiState.setPage(1);
	}
	
	int m_userFilter = -1;
	if(request.getParameter("userFilter") != null) {
		m_userFilter = Integer.parseInt(request.getParameter("userFilter"));
	}
	
	switch(uiState.getOwnerLimit()) {
		case(UIState.ALL_VISIBLE):
			pageTitle = "All ";
			break;
		case(UIState.OWNED_PHOTOS):
			pageTitle = "My ";
			break;
		case(UIState.RECEIVED_PHOTOS):
			pageTitle = "Received ";
			break;
		case(UIState.PUBLIC_PHOTOS):
			pageTitle = "Public ";
			break;
		default:
			break;
	}
	
	switch(uiState.getTimeRange()) {
		case(MediaManager.TODAY):
			pageTitle = pageTitle + "Photos From Today";
			break;	
		case(MediaManager.PREV_7):
			pageTitle = pageTitle + "Photos From The Previous 7 Days";
			break;
		case(MediaManager.PREV_14):
			pageTitle = pageTitle + "Photos From The Previous 14 Days";
			break;
		case(MediaManager.THIS_MONTH):
			pageTitle = pageTitle + "Photos From This Month";
			break;
		case(MediaManager.THIS_YEAR):
			pageTitle = pageTitle + "Photos From This Year";
			break;
		case(MediaManager.SHOEBOX):
			pageTitle = "My Shoebox";
			break;
		case(MediaManager.NEWEST):
			pageTitle = "Newest Uploaded Photos";
			break;
		default:
			if (uiState.getOwnerLimit() == UIState.PUBLIC_PHOTOS) {
				pageTitle = "All Public Photos";
			} else {
				pageTitle = "All Photos";
			}
			break;
	}
	
	List m_photos = new ArrayList();

	if(uiState.getTimeRange()!=MediaManager.NEWEST && 
			uiState.getTimeRange()!=MediaManager.SHOEBOX){

	 	switch(uiState.getOwnerLimit()) {
			case(MediaManager.ALL_VISIBLE):
				m_photos = PhotoFactory.listAllVisiblePhotosByTime(m_user, uiState.getTimeRange());
				break;
			case(MediaManager.OWNED_PHOTOS):
				m_photos = PhotoFactory.listAllOwnedPhotosByTime(m_user, uiState.getTimeRange());
				break;
			case(MediaManager.RECEIVED_PHOTOS):
				m_photos = PhotoFactory.listAllReceivedPhotosByTime(m_user, uiState.getTimeRange());
				break;
			case(MediaManager.PUBLIC_PHOTOS):
				if ((m_userFilter < 0)) { // unset state is -1
					// DOES NOT include user filter
					m_photos = PhotoFactory.listAllPublicPhotosByTime(uiState.getTimeRange());
				} else {
					// DOES include user filter
					m_photos = PhotoFactory.listAllPublicPhotosByTimeAndUser(uiState.getTimeRange(), m_userFilter);
					pageTitle = pageTitle + " (" + UserManager.getByID(m_userFilter) + ")";
				}
				break;
			default:
				m_photos = PhotoFactory.listAllVisiblePhotosByTime(m_user, uiState.getTimeRange());
				break;
		}          	 
	}else if(uiState.getTimeRange() == MediaManager.SHOEBOX){
		m_photos = MediaManager.listUngroupedPhotos(m_user);
	}else{
		m_photos = MediaManager.listNewestOwnedPhotos(12, m_user);
	}
	
	ArrayList currentCollection = new ArrayList();
	currentCollection.addAll(m_photos);
	Iterator id_it = currentCollection.iterator();
	ArrayList idArray = new ArrayList(currentCollection.size());
	for(int i = 0; i < currentCollection.size(); i++){
		IPhoto p = (IPhoto)currentCollection.get(i);
		idArray.add(new Integer(p.getID()));
	}
	
	session.setAttribute("collection", idArray);
	session.setAttribute("collectionTitle", pageTitle);
	session.setAttribute("actionRedirect", request.getRequestURL().toString()+"?"+request.getQueryString());
	
%>

<html>
<head>
<title><%=pageTitle%></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
<STYLE>
<!-- 
#pup {position:absolute; visibility:hidden; z-index:200; width:260; }
 --> 
</STYLE>

</head>

<body>

<!-- top area -->
<table border="0" width="100%"><tr><td colspan="2" valign="top" align="center">
<%@ include file="header.jsp" %>
</td></tr>
<!-- left column -->
<tr><td width="160" valign="top" align="left">
	<%@ include file="timeline.jsp" %>
	<%@ include file="my_albums_menu.jsp"%>
	<%@ include file="received_albums_menu.jsp"%>	
</td>
<!-- end left column -->
	
<!-- right column / (PhotoGrid) -->
<td width="*" valign="top" align="left">

<%@ include file="include_photomain.jsp" %>

</td>
<!-- end right column -->
</tr>
</table>

</body>
</html>
