<%@ taglib prefix='c' uri='http://java.sun.com/jstl/core' %>
<%@ page import="java.util.Map"%>
<%@ page import="java.net.*"%>
<%@ page import="java.io.OutputStreamWriter"%>
<%@ page import="gcr.mmm2.util.*"%>

<%
	boolean adminLogin = false;
	try {
		String loginDestination = session.getAttribute("com.caucho.servlet.login.path").toString();
		if( ("/admin/index.jsp").equals(loginDestination) ){
			adminLogin = true;
		}
	} catch (NullPointerException npe) {
		adminLogin = false;
	}
	
	// read POST fields and set cookies
	String username = request.getParameter("j_username");
	String password = request.getParameter("j_password");
	String remember = request.getParameter("j_remember");
	String loginerror = request.getParameter("login_error");
	String salt = new String("2600"); // for XOR password encryption

	// if users wanna be remembered, set the cookies for 2 weeks
	if (remember != null) {
		if ( (username != null) && (password != null) && (remember.equals("on") ) ){
			Cookie mmm_user = new Cookie("mmm_user", StringUtils.xorB64encodeString(username, salt) );
			Cookie mmm_pass = new Cookie("mmm_pass", StringUtils.xorB64encodeString(password, salt) );
			Cookie mmm_remb = new Cookie("mmm_remb", remember);
			mmm_user.setMaxAge(20160);
			mmm_pass.setMaxAge(20160);
			mmm_remb.setMaxAge(20160);
			response.addCookie(mmm_user);
			response.addCookie(mmm_pass);
			response.addCookie(mmm_remb);
		}
	}
	
	// if we aren't being redirected back here from a login error...	
	if (loginerror == null ) {	
		// if we have the necessary params from POSTs, try to auth now.
		String redirectString = new String();
		if ( (username != null) && (password != null) ) {
			// TODO: this makes the auth request a GET method request.
			//		 if auth fails, the attempted user/pass is left in the URL!
			redirectString = new String("j_security_check?j_username="+username+"&j_password="+password);
			response.sendRedirect(response.encodeRedirectURL(redirectString) );
		} else {	
			// else, read the cookies and authenticate if params are found
			Cookie[] mmmCookies = request.getCookies();
			int mmmCookieCount = 0; // keep track of how many mmm cookies we can find;
			if (mmmCookies != null) {
				for(int j = 0; j < mmmCookies.length; j++) {
					if(mmmCookies[j].getName().equals("mmm_user") ) {
						System.out.println(mmmCookies[j].getValue());
						username = StringUtils.xorB64decodeString(mmmCookies[j].getValue(), salt );
						mmmCookieCount++;
					}
					if(mmmCookies[j].getName().equals("mmm_pass") ) {
						password = StringUtils.xorB64decodeString(mmmCookies[j].getValue(), salt );
						mmmCookieCount++;
					}
					if(mmmCookies[j].getName().equals("mmm_remb") ) {
						remember = mmmCookies[j].getValue();
						mmmCookieCount++;
					}		
				}
				if ( (username != null) && (password != null) && (mmmCookieCount == 3) ) {
					redirectString = new String("j_security_check?j_username="+username+"&j_password="+password);
					System.out.println("from cookie: "+redirectString);
					response.sendRedirect(response.encodeRedirectURL(redirectString) );
				}
			}
		} // END: if ( (username != null) && (password != null) )
	} else { // END: if (!loginerror)
		// login failures always clear cookies.
		Cookie mmm_user = new Cookie("mmm_user", "");
		Cookie mmm_pass = new Cookie("mmm_pass", "");
		Cookie mmm_remb = new Cookie("mmm_remb", "");
		mmm_user.setMaxAge(0);
		mmm_pass.setMaxAge(0);
		mmm_remb.setMaxAge(0);
		response.addCookie(mmm_user);
		response.addCookie(mmm_pass);
		response.addCookie(mmm_remb);
	}
%>

<html>
  <head>
	<link href="<%=request.getContextPath()%>/resources/styles/master.css" rel="stylesheet" type="text/css">
	<title>Login</title>
  <body>
<%
	if(adminLogin){
%>
    <div align="center">
	    <h1 align="center">
	    <img src='<%=request.getContextPath()%>/resources/images/log_icon.png' width='200px'>
	    Let's LogInn!
	    <img src='<%=request.getContextPath()%>/resources/images/inn.gif' width='200px'>
	    </h1>
    </div>
<%
	}else{//regular "professional" login
%>
    <div align="center">
	<img src="/resources/images/ColorfulLogo.gif" alt="MMM2" /><br><br>
    </div>	
<%
	} //<c:url value='j_security_check'/>
%>
	
    <form action="login.jsp" name="loginForm" method="POST">
	    
  	<div style="margin-left:35%;width:300px;whitespace:nowrap;">
		<%-- 
	    	this form-login-page form is also used as the 
			form-error-page to ask for a login again.
	    --%>
	    <c:if test="${not empty param.login_error}">
	      <font color="red">
	        Your login attempt was not successful, try again.
	      </font>
	    </c:if>

		<div align="right"><label>Username <input type='text' name='j_username'></div>
		<div align="right"><label>Password <input type='password' name='j_password'></div><br>
		<div align="right"><input type='checkbox' name='j_remember' id='j_remember'> Keep me logged in on this computer</div><br>
		<div align="right"><input type="submit" value="Go"></div>
	</div>
	
	<%@ include file="announcements.jspf" %>
	
      <!--
        -  In case the user got here without a session, redirect
        -  successful requests to the home page for authenticated
        -  users.  (This is a non-standard, but useful field.)
        -->
	<input type='hidden' name='j_uri' value='./index.jsp'/>
    </form>
  </body>
</html>
