<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>

<%
	String username = request.getRemoteUser();
	IUser u = UserManager.getByUsername(username);
	
	int contact_list_id = 0;
	String contact_list_name = "";
	IContactList contact_list = null;
	String action = "";
	
	if(request.getParameter("contact_list_id") != null) {
		contact_list_id = Integer.parseInt(request.getParameter("contact_list_id"));
	}
	
	if(request.getParameter("action") != null) {
		action = request.getParameter("action");
	}
	
	contact_list = ContactManager.getContactListByID(contact_list_id);

	if(contact_list==null && action.equals("save")) {
		String groupName = request.getParameter("group_name");
		if( ("").equals(groupName) ){
			groupName = "Unnamed Group";
		}
		contact_list = ContactManager.createContactList(u, groupName);
		contact_list_id = contact_list.getID();
	} 
	
	if(contact_list!=null) {
		contact_list_name = contact_list.getName();
	}

	if(action.equals("save")) {
	
		//TODO: compare to current name to prevent unnecessary change
		String groupName = request.getParameter("group_name");
		if( ("").equals(groupName) ){
			groupName = "Unnamed Group";
		}
		
		contact_list.setName(groupName, u);
		
		String[] toAdd = request.getParameterValues("group_members");
		if(toAdd != null){
			for(int i = 0; i < toAdd.length; i++){
				try{
					int id = Integer.parseInt(toAdd[i]);
				
					IContact cur_contact = ContactManager.getContactByID(id);
					if(!contact_list.containsContact(cur_contact)) {
						contact_list.addContact(cur_contact, u);
					}
				}catch(NumberFormatException nfe){
					//do nothing
				}
			}
		}
		
		response.sendRedirect("address_book.jsp");
	}
	
	//TODO: use contactMap instead of building things within the page
	HashMap contactMap = new HashMap();
	
  	Iterator entries = ContactManager.listContacts(u).iterator(); 
  	while(entries.hasNext()){
  		IContact cur_contact = (IContact)entries.next();
  			
  		EmailAddress e = cur_contact.getPrimaryEmail();
  		String emailAddress = "no email";      			
  		if(e != null)
  			emailAddress = e.getAddress();
  				
  		StringBuffer formattedContact = new StringBuffer(
	  		cur_contact.getFirstName() + " " +
	  		cur_contact.getLastName() + ": " +
	  		emailAddress + ", " +
	  		cur_contact.getPhoneNumber()
	  	);
	  	contactMap.put(new Integer(cur_contact.getContactID()), formattedContact);
  	}
  	
  	if(action.equals("delete")){
		
		contact_list.delete(u);
		response.sendRedirect("address_book.jsp");

	}	
%>

<html>
<head>
<title>Address Book</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
<link href="resources/styles/address_book.css" rel="stylesheet" type="text/css">
<script language="JavaScript" src="resources/scripts/group_management.js"></script>
</head>

<body onload="initialize();">

<%@ include file="header.jsp" %>
<div style="clear:both">
<p>
<% if(contact_list_id==0) { %>
Create New Group
<% } else { %>
Edit Group
<% } %>
<p>
    
<form name="group_manager" method="get" action="manage_groups.jsp">  

<input type="hidden" name="contact_list_id" value="<%=contact_list_id%>">

<table width="100%" border="0">
  <tr>
    <tr>
      <td>Group Name:<input name="group_name" type="text" value="<%=contact_list_name%>" size="40" maxlength="40"></td>
    </tr>  
    <td valign="top" width="400">

 	<fieldset style="padding: 2">   
    <legend>Group Members:</legend>
      <table border="0">
        <tr> 
          <td>
          <select name="group_members" size="13" style="width: 400px;" class="address_book" multiple>
                    
          <% 	
				//TODO: replace with contactMap
				if(contact_list != null) {
					entries = contact_list.listContacts().iterator(); 
	          		while(entries.hasNext()){
	          			IContact cur_contact = (IContact)entries.next();
	          			
	          			EmailAddress e = cur_contact.getPrimaryEmail();
	          			String emailAddress = "no email";      			
	          			if(e != null)
	          				emailAddress = e.getAddress();
	          				
	          			out.write("<option value='"+cur_contact.getContactID()+"'>" + 
	          			cur_contact.getFirstName() + " " +
	          			cur_contact.getLastName() + ": " +
	          			emailAddress + "</option>");
	          			//emailAddress + ", " +
	          			//cur_contact.getPhoneNumber() + "</option>");
	          		}
				}
          %>
			</select>
          </td>
        </tr>
		<tr>
			<td align="right"><input type='button' onclick='remove_from_group();' name='remove' value='Remove From Group >>'></td>
        </tr>
        </tr>
      </table>
	</fieldset>
	
    </td>
    
    <td valign="top" width="400" align="left">

 	<fieldset style="padding: 2">   
    <legend>Contacts:</legend>       
	<table border="0">
        <tr>
          <td>&nbsp;</td>
        </tr>        
        <tr>
          <td>Search:<input name="search" type="text" value="" size="40" maxlength="40" onkeyup='address_search(this);' autocompletion='off'></td>
        </tr>
        <tr>
          <td><select name="addresses" size="10" style="width: 400px;" class="address_book">
          
          <% 	
				//TODO: replace with contactMap
          		entries = ContactManager.listContacts(u).iterator(); 
          		while(entries.hasNext()){
          			IContact cur_contact = (IContact)entries.next();
          			
          			EmailAddress e = cur_contact.getPrimaryEmail();
          			String emailAddress = "no email";      			
          			if(e != null)
          				emailAddress = e.getAddress();
          				
          			out.write("<option value='"+cur_contact.getContactID()+"'>" + 
          			cur_contact.getFirstName() + " " +
          			cur_contact.getLastName() + ": " +
          			emailAddress + "</option>");
          			//emailAddress + ", " +
          			//cur_contact.getPhoneNumber() + "</option>");
          		}

          %>
              </select>
          </td>
        </tr>
        <tr>
          <td align="left"><input type='button' onclick='add_to_group();' name='add' value='<< Add to Group'></td>
        </tr>
      </table>
     </fieldset>
      
      </td>
      <td>&nbsp;</td>
  </tr>
  <td>
  						
        <td align="right">
        		<input name="action" type="hidden" value="">
        		<% if(contact_list_id>0) { %>
					<input name="delete" type="button" value="Delete Group" onclick="confirmDelete();">
				<% } %>
        		<input name="save" type="button" value="Save Group" onclick="saveGroup();">
		</td>
</table>
</form>
</div>
</body>
</html>