<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.util.logging.*" %>

<%
	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);
	final Logger log = Logger.getLogger("contactActivity");
	
	//
	// Get all the photos and turn them into manageable objects
	//
	ArrayList photos = new ArrayList();
	String[] photoIDs = request.getParameterValues("photoID");
	if(photoIDs == null){
		out.write("no photos selected!");
		return;
	}
	
	for(int i = 0; i < photoIDs.length; i++){
		try{
			int photoID = Integer.parseInt(photoIDs[i]);
			IPhoto current = PhotoFactory.getPhotoByID(photoID);
			photos.add(current);
		}catch(NumberFormatException nfe){
			//ignore this
		}
	}

	//
	// Add the photos to an album, then redirect to another page.
	//
	String[] addToIDs = request.getParameterValues("albumID");
	if(addToIDs != null){
	
		for(int i = 0; i < addToIDs.length; i++){
			try{
				int albumID = Integer.parseInt(addToIDs[i]);
				
				//handle new albums
				if(albumID == -1){
					String newAlbumName = request.getParameter("new_album_title");
					if(newAlbumName != null){
						IAlbum newAlbum = AlbumFactory.createAlbum(newAlbumName, m_user);
						albumID = newAlbum.getID();
					}else{
						continue;
					}
				}
				
				IAlbum current = AlbumFactory.getAlbumByID(albumID);
				
				Iterator photo_it = photos.iterator();
				while(photo_it.hasNext()){
					IPhoto cur_photo = (IPhoto)photo_it.next();
					try{
						current.addPhoto(cur_photo, 0, m_user);
					}catch(PermissionException pe){/* do nothing */}
				}
				
			}catch(NumberFormatException nfe){
				log.info("Add to Album Mobile: format exception.");
			}
		}//end for
		%>
		<html>
		<head>
		<title>Added To Albums</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
		<link href="../resources/styles/mobile.css" rel="stylesheet" media="handheld" type="text/css">
		</head>
		<body>
		<div><a href="photo_list.jsp?mode=<%=MediaManager.RECEIVED_PHOTOS%>">View Received Photos</a></div>
		<div><a href="photo_list.jsp?mode=<%=MediaManager.OWNED_PHOTOS%>">View My Photos</a></div>
		</body>
		</html>		
		<%
		return;
	}//end addTo procedure
%>

<html>
<head>
<title>Add to Album</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../resources/styles/mobile.css" rel="stylesheet" media="handheld" type="text/css">
</head>
<body>
	<form name="add_to_album" method="get">
	<strong>Add to Album:</strong><br>
	<%
	for(int i = 0; i < photoIDs.length; i++){
		out.write("<input type='hidden' name='photoID' value='"+photoIDs[i]+"'>");
	}
	%>
	
	Iterator album_it = AlbumFactory.listAlbums(m_user).iterator();
	while(album_it.hasNext()){
		IAlbum cur_album = (IAlbum)album_it.next();
		out.write("<label><input type='checkbox' name='albumID' value="+cur_album.getID()+">"+cur_album.getTitle()+"</label><br>\n");
	}
	out.write("<input type='checkbox' name='albumID' value='-1'>&nbsp;<input type='text' name='new_album_title' value='New Album' style='width:75%'><br>\n");
	%>
	</form>

</body>
</html>