<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="java.net.URLEncoder" %>

<%	
	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);
	
	int photoID = -1;
	String temp = request.getParameter("photoID");
	try{
		photoID = Integer.parseInt(temp);
	}catch(NumberFormatException nfe){
		//photoID is set to -1, redirect will be called next
	}
	
	if(photoID == -1){
		response.sendRedirect("./index.jsp");
	}
	
	int mode = MediaManager.RECEIVED_PHOTOS;
	if(request.getParameter("mode") != null){
		mode = Integer.parseInt(request.getParameter("mode"));
	}
	
	IPhoto m_photo = PhotoFactory.getPhotoByID(photoID);
	
	StringBuffer sharer_sb = new StringBuffer();
	Iterator sharers = ShareManager.listUsersSharingMedia(m_photo, m_user).iterator();
	while(sharers.hasNext()){
		IUser u = (IUser)sharers.next();
		if(sharer_sb.length() > 0){sharer_sb.append(", ");}
		sharer_sb.append(u.toString());
	}
%>

<html>
<head>
<title>View-a-photo</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../resources/styles/mobile.css" rel="stylesheet" media="handheld" type="text/css">
</head>
<body>

	<%
	Iterator shares = ShareManager.listSharesContainingMedia(m_photo, m_user).iterator();
	while(shares.hasNext()){
		IShare share = (IShare)shares.next();
		if( (null != share.getMessage()) || ("").equals(share.getMessage()) ){
	%>
		<div>"<%=share.getMessage()%>" - <%=share.getOwner()%></div>
	<%
		}
	}
	%>

	<div class="photo_row_labels">
		<img  src="<%=m_photo.getURL("../","mobile",160)%>">
	</div>
	<% if(sharer_sb.length() > 0){ %>
	<div>Sent By: <%=sharer_sb.toString()%></div>
	<% } %>
	<div><em><%=m_photo.getCaption()%></em></div>
	<div><%=m_photo.getCaptureDate().toString()%></div>
	<div><a href="share_mobile.jsp?photoID=<%=m_photo.getID()%>">Share Photo</a></div>
	
	
	<%
	List comments = m_photo.listComments();
	if(comments.size() > 0){
		Iterator c_it = comments.iterator();
		%>
		<div>Comments</div>
		<%
		while(c_it.hasNext()){
			Comment cur_comment = (Comment)c_it.next();
		%>
		<div><%=URLDecoder.decode(cur_comment.getComment())%>%> - <%=cur_comment.getOwner()%></div>
		<%
		}
	}
	%>


	<% if(mode==MediaManager.RECEIVED_PHOTOS){ %>
	<div><a href="photo_list.jsp">Back to Received/Photos</a></div>
	<% }else{ %>
	<div><a href="photo_list.jsp">Back to Recent Photos</a></div>
	<% } %>
</body>
</html>