<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>

<%	

	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);
	
	int mode = MediaManager.RECEIVED_PHOTOS;
	String m_pageTitle = "Photo List";
	
	if(request.getParameter("mode") != null){
		mode = Integer.parseInt(request.getParameter("mode"));
	}
	
	List m_photos;
	switch(mode){
		case MediaManager.RECEIVED_PHOTOS:
			m_photos = ShareManager.listNewestReceivedPhotos(10, m_user);
			m_pageTitle = "Received Photos";
			break;

		case MediaManager.OWNED_PHOTOS:
			m_photos = MediaManager.listNewestOwnedPhotos(10, m_user);
			m_pageTitle = "My Photos";
			break;
		default:
			m_photos = new ArrayList();//Something we wrong!
			m_pageTitle = "No Photos";
	}
	
%>

<html>
<head>
<title><%=m_pageTitle%></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../resources/styles/mobile.css" rel="stylesheet" media="handheld" type="text/css">
<script type="text/javascript">
	function make_album_from_selected()
	{
		document.photolist.action = "add_to_album.jsp";
		document.photolist.submit();
	}
	
	function share_selected()
	{
		document.photolist.action = "share_mobile.jsp";
		document.photolist.submit();
	}
</script>
</head>
<body>


<form name="photolist" method="get" action="share_mobile.jsp">
<table width="100%" cellpadding="2" cellspacing="0">
<%
	Iterator photo_it = m_photos.iterator();
	while(photo_it.hasNext()){
		IPhoto cur_photo = (IPhoto)photo_it.next(); 
		
		StringBuffer sharer_sb = new StringBuffer();
		Iterator sharers = ShareManager.listUsersSharingMedia(cur_photo, m_user).iterator();
		while(sharers.hasNext()){
			IUser u = (IUser)sharers.next();
			if(sharer_sb.length() > 0){sharer_sb.append(", ");}
			sharer_sb.append(u.toString());
		}
%>
		<tr>
		<td valign="top" align="left" colspan="2" class="photo_row_labels">
			<label><input type='checkbox' name='photoID' value="<%=cur_photo.getID()%>">
			Sent By: <%=sharer_sb.toString()%></label>
		</td>
		</tr>
		
		<tr>
		<td valign="top" align="left class="photo_row_labels" width='50px'>
			<a href="./mobile_photo_details.jsp?photoID=<%=cur_photo.getID()%>&mode=<%=mode%>">
			<img  src="<%=cur_photo.getURL("../","mobile",50)%>">
			</a>
		</td>
		<td valign="top" align="left" class="photo_row_labels">
			<div><%=cur_photo.getCaptureDate().toString()%></div>
			<div><em><%=cur_photo.getCaption()%></em></div>
		</td>
		</tr>
<%
	}
%>
	</table>
	<hr>
	<div><a href="javascript:share_selected()">share selected</a></div>
	<div><a href="javascript:make_album_from_selected()">add selected to album</a></div>
</form>

<hr>

<%
if(mode!=MediaManager.RECEIVED_PHOTOS){%>
<div><a href="photo_list.jsp?mode=<%=MediaManager.RECEIVED_PHOTOS%>">Received Photos</a></div>
<% }else{ %>
<div><a href="photo_list.jsp?mode=<%=MediaManager.OWNED_PHOTOS%>">My Photos</a></div>
<% } %>

</body>
</html>