<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.util.logging.Logger" %>

<%	
	final Logger log = Logger.getLogger("sharingActivity");

	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);
	
	final String lprefix = "[MOBILE] SID="+request.getSession().getId()+" UID="+m_user.getID()+" ";
	
	boolean editMode = false;
	if(request.getParameter("edit") != null){
		editMode = true;
		log.info(lprefix+"- entering edit mode");
	}
		
	boolean commitShare = false;
	if(request.getParameter("commitShare") != null){
		editMode = true;
		commitShare = true;
		log.info(lprefix+"commit share");
	}
	
	HashMap sessionShareData = (HashMap)session.getAttribute("sessionShareData");
	if(sessionShareData == null){
		sessionShareData = new HashMap();
		session.setAttribute("sessionShareData", sessionShareData);
	}
	
	/*
	 * Get or Create HashSets for our query string data
	 */
	HashSet photos	= (HashSet)sessionShareData.get("photos");
	if(null==photos)// || editMode)
		photos = new HashSet();
		
	HashSet recipients = (HashSet)sessionShareData.get("recipients");
	if(null==recipients || editMode)
		recipients = new HashSet();
		
	HashSet contactLists = (HashSet)sessionShareData.get("contactLists");
	if(null==contactLists || editMode)
		contactLists = new HashSet();
		
	HashSet albums	= (HashSet)sessionShareData.get("albums");
	if(null==albums || editMode)
		albums = new HashSet();
		
	HashSet shareAlbums	 = (HashSet)sessionShareData.get("shareAlbums");
	if(null==shareAlbums)// || editMode)
		shareAlbums = new HashSet();
		
	HashSet blogs = (HashSet)sessionShareData.get("blogs");
	if(null==blogs || editMode)
		blogs = new HashSet();
	
	StringBuffer sb_sharedWith	= new StringBuffer();
	StringBuffer sb_albums		= new StringBuffer();
	StringBuffer sb_blogs		= new StringBuffer();
	
	String message = request.getParameter("message");
	if(message==null){
		message = (String)sessionShareData.get("message");
		if(message==null)
			message = "";
	}
	
	/*
	 * The Photo Section
	 */
	String[] photoIDs = request.getParameterValues("photoID");
	if(photoIDs != null){
		photos.clear();
		for(int i = 0; i < photoIDs.length; i++){
			IPhoto p = PhotoFactory.getPhotoByID(Integer.parseInt(photoIDs[i]));
			if(p != null){photos.add(p);}
		}
	}
	
	/*
	 * The Recipient Section
	 */
	String[] recipientIDs = request.getParameterValues("recipientID");
	if(recipientIDs != null){

		for(int i = 0; i < recipientIDs.length; i++){
			IPerson r = PersonManager.getByID(Integer.parseInt(recipientIDs[i]));
			if(r != null){recipients.add(r);}
		}
	}
	
	/*
	 * The RecipientList Section
	 */
	String[] contactListIDs = request.getParameterValues("contactListID");
	if(contactListIDs != null){

		for(int i = 0; i < contactListIDs.length; i++){
			IContactList cl = ContactManager.getContactListByID(Integer.parseInt(contactListIDs[i]));
			if(cl != null){contactLists.add(cl);}
		}
	}
	
	/*
	 * The Target Album Section
	 */
	String[] albumIDs = request.getParameterValues("albumID");
	if(albumIDs != null){
		
		for(int i = 0; i < albumIDs.length; i++){
			int albumID = Integer.parseInt(albumIDs[i]);
			IAlbum cur_album = null;
			if(albumID < 0){
				//create a new album
				String new_album_title = "New Album";
				if(request.getParameter("new_album_title") != null)
					new_album_title = request.getParameter("new_album_title");
				cur_album = AlbumFactory.createAlbum(new_album_title, m_user);
			}else{
				cur_album =AlbumFactory.getAlbumByID(albumID);
			}
			albums.add(cur_album);
		}//end for
	}
	
	/*
	 * The Share Album Section
	 * These albums are *shared*, but pictures are not placed in them (for future use)
	 */
	String[] shareAlbumIDs = request.getParameterValues("shareAlbumID");
	if(shareAlbumIDs != null){
		shareAlbums.clear();
		for(int i = 0; i < shareAlbumIDs.length; i++){
			IAlbum cur_album = AlbumFactory.getAlbumByID(Integer.parseInt(shareAlbumIDs[i]));
			shareAlbums.add(cur_album);
		}//end for
	}
	
	/*
	 * The Blog Section
	 */
	String[] blogIDs = request.getParameterValues("blogID");
	if(blogIDs != null){
	
		for(int i = 0; i < blogIDs.length; i++){
			Blog b = UserManager.getBlogByID(Integer.parseInt(blogIDs[i]));
			blogs.add(b);
		}//end for
	}

	if(commitShare){
	
		//add photos to albums
		Iterator a_it = albums.iterator();
		while(a_it.hasNext()){
			IAlbum a = (IAlbum)a_it.next();
			Iterator p_it = photos.iterator();
			while(p_it.hasNext()){
				IPhoto p = (IPhoto)p_it.next();
				try{a.addPhoto(p, 0, m_user);}
				catch(PermissionException pe){/*do nothing*/}
			}
			
			//Create output stringbuffer
			if(sb_albums.length() > 0){
				sb_albums.append(", ");
			}
			sb_albums.append(a.getTitle());
		}
		
		//create a share ref
		IShare share = null;
		
		//add photos to the share object
		Iterator p_it = photos.iterator();
		while(p_it.hasNext()){
			IPhoto p = (IPhoto)p_it.next();
			try{
				if(share==null){
					share = ShareManager.createShare(m_user);
					log.info(lprefix+"SHAREID="+share.getID()+" - share created by adding photo");
				}
				share.addPhoto(p, m_user);
				log.info(lprefix+"SHAREID="+share.getID()+" - add PHOTO_ID="+p.getID());
			}catch(PermissionException pe){/*do nothing*/}
		}
		
		//share with individuals
		Iterator r_it = recipients.iterator();
		while(r_it.hasNext()){
			IPerson r = (IPerson)r_it.next();
			try{
				if(share==null){
					share = ShareManager.createShare(m_user);
					log.info(lprefix+"SHAREID="+share.getID()+" - share created by adding individual recip");
				}
				share.addRecipient(r, m_user);
				log.info(lprefix+"SHAREID="+share.getID()+" - add PERSON_ID="+r.getID());
			}catch(PermissionException pe){/*do nothing*/}
			
			//Create output stringbuffer
			if(sb_sharedWith.length() > 0){
				sb_sharedWith.append(", ");
			}
			sb_sharedWith.append(r.toString());
		}
		
		//send to contactList
		Iterator cl_it = contactLists.iterator();
		while(cl_it.hasNext()){
			IContactList cl = (IContactList)cl_it.next();
			try{
				if(share==null){
					share = ShareManager.createShare(m_user);
					log.info(lprefix+"SHAREID="+share.getID()+" - share created by adding contact list");
				}
				share.addRecipient(cl, m_user);
				log.info(lprefix+"SHAREID="+share.getID()+" - add CONTACT_LIST_ID="+cl.getID());
			}catch(PermissionException pe){/*do nothing*/}
			
			//Create output stringbuffer
			if(sb_sharedWith.length() > 0){
				sb_sharedWith.append(", ");
			}
			sb_sharedWith.append(cl.toString());
		}
		
		try{
			if(share!=null){
				share.setMessage(message, m_user);
				log.info(lprefix+"SHAREID="+share.getID()+" MESSAGE='"+message+"'");
				}
			}
		catch(PermissionException pe){/*do nothing*/}
		
		//notify recipients
		boolean notifyMobile = true;
		if(share!=null){
			share.notifyRecipients(notifyMobile);
		}
		
		//posts to blog
		Iterator b_it = blogs.iterator();
		while(b_it.hasNext()){
			Blog b = (Blog)b_it.next();
			b.postEntry("mmm2 moblog", message, photos, m_user);
			
			//Create output stringbuffer
			if(sb_blogs.length() > 0){
				sb_blogs.append(", ");
			}
			sb_blogs.append(b.toString());
		}
		
		//Clean up our mess in the session
		sessionShareData.remove("photos");
		sessionShareData.remove("albums");
		sessionShareData.remove("shareAlbums");
		sessionShareData.remove("blogs");
		sessionShareData.remove("recipients");
		sessionShareData.remove("contactLists");
		sessionShareData.remove("message");
		
		session.removeAttribute("sessionShareData");
%>
<html>
<head>
<title>Share Completed</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../resources/styles/mobile.css" rel="stylesheet" media="handheld" type="text/css">
</head>
<body>
<%
		if(sb_sharedWith.length() > 0){
			out.write("You shared with: " + sb_sharedWith.toString()+"<br>");
		}
		if(sb_albums.length() > 0){
			out.write("Albums: " + sb_albums.toString()+"<br>");
		}
		if(sb_blogs.length() > 0){
			out.write("You blogged to: " + sb_blogs.toString()+"<br>");
		}
%>
	<br>
	<div><a href="photo_list.jsp?mode=<%=MediaManager.RECEIVED_PHOTOS%>">View Received Photos</a></div>
	<div><a href="photo_list.jsp?mode=<%=MediaManager.OWNED_PHOTOS%>">View My Photos</a></div>
	<div><a href="index.jsp?imsi=<%=m_user.getPhoneID()%>">MMM Bookmark</a></div>
</body>
</html>
<%
		return;
	}else{
		sessionShareData.put("photos", photos);
		sessionShareData.put("albums", albums);
		sessionShareData.put("shareAlbums", shareAlbums);
		sessionShareData.put("blogs", blogs);
		sessionShareData.put("recipients", recipients);
		sessionShareData.put("contactLists", contactLists);
		sessionShareData.put("message", message);
	}
	
	if( ("true").equals(request.getParameter("goingToContactList")) ){
		return;
	}
%>

<html>
<head>
<title>Share-a-photo</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../resources/styles/mobile.css" rel="stylesheet" media="handheld" type="text/css">
<script type="text/javascript">
	function submitAndGo(){
		document.share.goingToContactList.value = "true";
		document.share.submit();
		location.href = "list_contacts.jsp";
	}
</script>
</head>
<body>
<%

	IPhoto m_photo = (IPhoto)photos.iterator().next();

	IContext m_context = m_photo.getContext();
	if(m_context != null){
		String m_latitude = m_context.getGpsLatitude();
		String m_longitude = m_context.getGpsLongitude();
		if((m_latitude != null && m_longitude != null) && (!m_latitude.equals("0.0") && !m_longitude.equals("0.0")))
			out.println("Your coordinates:<br>Latitude: " + m_latitude + "<br>Longitude: " + m_longitude + "<br>");
	}
%>
	<form name="share" method="get">
<%
	Iterator pid_it = photos.iterator();
	while(pid_it.hasNext()){
		IPhoto p = (IPhoto)pid_it.next();
%>
	<input type="hidden" name="photoID" value="<%=p.getID()%>">
<%
	}
%>
	<strong>Suggested Recipients:</strong><br>
<%
	List suggestedRecips = ClairvoyanceManager.shareGuesser(m_photo, m_user, 10);
	Iterator contact_it = suggestedRecips.iterator();
	while(contact_it.hasNext()){
		IPerson cur_contact = (IPerson)contact_it.next();
		IPerson cur_person = PersonManager.getByID(cur_contact.getID()); //the contact may not be a person object
		log.info(lprefix+" - suggesting PERSON_ID="+cur_person.getID());
		String checked = "";
		if(recipients.contains(cur_person)){
			System.out.println("found person, checkboxing: " + cur_person.toString());
			checked = "checked";
			recipients.remove(cur_person);//NOTE!!  this removes people from the session, with the expectation that it will be rebuilt on submit
		}
		
		out.write("<label><input type='checkbox' name='recipientID' "+checked+" value="+cur_person.getID()+">"+cur_person.toString()+"</label><br>\n");
	}
%>
	<br>
	<input type="hidden" name="goingToContactList" value="false">
	<a href="javascript:submitAndGo();">All Contacts</a><br>
	<br>
<%
	if(recipients.size() > 0){
		out.write("<strong>Others:</strong><br>");
		Iterator otherRecips_it = recipients.iterator();
		while(otherRecips_it.hasNext()){
			IPerson cur_contact = (IPerson)otherRecips_it.next();
			log.info(lprefix+" - added from full contact list PERSON_ID="+cur_contact.getID());
			out.write("<label><input type='checkbox' name='recipientID' checked value="+cur_contact.getID()+">"+cur_contact.toString()+"</label><br>\n");
		}
	}
%>
	<br>
<%

	List grouplist = ContactManager.listContactLists(m_user);
	if(grouplist.size() > 0){
%>
		<strong>Send to List:</strong><br>
<%	
		Iterator list_it = grouplist.iterator();
		while(list_it.hasNext()){
			IContactList cur_list = (IContactList)list_it.next();
			
			String checked = "";
			if(contactLists.contains(cur_list)){
				System.out.println("found clist: " + cur_list.toString());
				checked = "checked";
			}
			
			out.write("<label><input type='checkbox' name='contactListID' "+checked+" value="+cur_list.getID()+">"+cur_list.getName()+"</label><br>\n");
		}
%>
		<br>
<%
	}//end if grouplist

	List bloglist = m_user.listBlogs();
	if(bloglist.size() > 0){
%>
		<strong>Post to Blog:</strong><br>
<%	
		Iterator blog_it = bloglist.iterator();
		while(blog_it.hasNext()){
			Blog cur_blog = (Blog)blog_it.next();
			
			String checked = "";
			if(blogs.contains(cur_blog)){
				System.out.println("found blog: " + cur_blog.toString());
				checked = "checked";
			}
			
			out.write("<label><input type='checkbox' name='blogID' "+checked+" value="+cur_blog.getID()+">"+cur_blog.getTitle()+"</label><br>\n");
		}
%>
		<br>
<%
	}
%>
	
	<strong>Add to Album:</strong><br>
<%
	Iterator album_it = AlbumFactory.listAlbums(m_user).iterator();
	while(album_it.hasNext()){
		IAlbum cur_album = (IAlbum)album_it.next();
		
		String checked = "";
		if(albums.contains(cur_album)){
			System.out.println("found album: " + cur_album.toString());
			checked = "checked";
		}
		
		out.write("<label><input type='checkbox' name='albumID' "+checked+" value="+cur_album.getID()+">"+cur_album.getTitle()+"</label><br>\n");
	}
	out.write("<input type='checkbox' name='albumID' value='-1'>&nbsp;<input type='text' name='new_album_title' value='New Album' style='width:75%'><br>\n");
%>
	<br>
	<strong>Message (for email or blog):</strong>
	<br>
	<input type="text" name="message" value="<%=message%>">
	<br><br>
	<input type="submit" name="commitShare" value="Share">
	</form>

</body>
</html>