<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.util.*" %>

<%
	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);	
	
	int photoID = -1;
	String temp = request.getParameter("photoID");
	try{
		photoID = Integer.parseInt(temp);
	}catch(NumberFormatException nfe){
		//photoID is set to -1, redirect will be called next
	}
	
	if(photoID == -1){
		response.sendRedirect("./index.jsp");
	}
	
	IPhoto m_photo = PhotoFactory.getPhotoByID(photoID);
	
	/*
	IContext context = m_photo.getContext();
	String location_label = "";
	ArrayList location_info = null;
	if(context!=null){
		location_label = context.getLocationLabel();
		location_info = (ArrayList)context.getGpsLocationInfo();
	}*/
	
	//GET PREVIOUS and NEXT image INDEXES
	//the album, collection, or set of photos is stored here
	ArrayList m_collection = (ArrayList)session.getAttribute("collection");
	int nextImage;
	int prevImage;
	
	//if no session collection is set...
	if(m_collection==null){
		m_collection = new ArrayList();
		m_collection.add(new Integer(m_photo.getID()));
	}else if(m_collection.size() == 0){
		m_collection.add(new Integer(m_photo.getID()));
	}
	
	int curIndex = m_collection.indexOf(new Integer(m_photo.getID()));
	if(curIndex < 0){
		return; //our image doesn't even show up in the list
		// TODO: Log this.
	}
	
	//get the PREVIOUS image index, -1 if none
	if(curIndex == 0)
		prevImage = -1;
	else
		prevImage = ((Integer)m_collection.get(curIndex-1)).intValue();
	
	//get the NEXT image index, -1 if none
	if(curIndex >= m_collection.size()-1)
		nextImage = -1;
	else
		nextImage = ((Integer)m_collection.get(curIndex+1)).intValue();

	session.setAttribute("actionRedirect", request.getRequestURL().toString()+"?"+request.getQueryString());
	
	//Creating String of all users.
	Iterator people = PersonManager.listAllPersons().iterator();
	
	IPerson person = (IPerson)people.next();
	String annotations = person.toString();
	while(people.hasNext()){
		person = (IPerson)people.next();
			annotations +=":"+ person.toString(); 
	}
	
	//Creating String of existing annotations.
	Iterator annotationsIter = PersonManager.listPhotoAnnotations(photoID).iterator();
	String existing = "";
	if (annotationsIter.hasNext() ) {
		AnnotationImpl annotation = (AnnotationImpl) annotationsIter.next();
		existing = annotation.toString();
		while(annotationsIter.hasNext()){
			annotation = (AnnotationImpl)annotationsIter.next();
			existing +=":"+ annotation.toString(); 
		}
	}
	

%>

<html>
<head>
<title>Photo Annotate</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
</head>
<body>

<%@ include file="header.jsp" %>

<div class="left_column">
<%@ include file="timeline.jsp" %>
</div><!-- end left column -->

<div class="details_center_column">

	<!-- THE PHOTO!!  THE MAIN ATTRACTION!! -->
	<div class="details_photo_container">
		<div class="details_photo"> 
			<APPLET CODE="gcr.mmm.ui.ImageAnnotate.class" ARCHIVE="ui/ImageAnnotate.jar"
			WIDTH="800" HEIGHT="600"
			 ALT="If you could run this applet, you'd see the image annotation screen.">
			<!--<PARAM NAME="annotations" VALUE="Benjamin Hill:Simon King:Homer Simpson"> -->
			<!--<<PARAM NAME="existing" VALUE="Im Abox,30,30,100,100:Benjamin Hill,200,200,50,50"> --> 
			<PARAM NAME="annotations" VALUE="<%=annotations%>"> 
			<PARAM NAME="existing" VALUE="<%=existing%>">
			<PARAM NAME="image" VALUE="<%=m_photo.getURL(null,null,0)%>">
			<PARAM NAME="photoID" VALUE="<%=photoID%>">
			<PARAM NAME="postURL" VALUE="photo_annotate_record.jsp">
				Your browser is completely ignoring the &lt;APPLET&gt; tag!
			</APPLET>
		</div>
	
	    <div class="details_operations">
	  		<!-- Display the "Previous" button -->
	  		<% if(prevImage >= 0){%>
	  		<a href="photo_annotate.jsp?photoID=<%=prevImage%>"><img src="resources/images/buttons/back.gif" align="middle" width="30"></a>&nbsp;
	  		<% } %>
	
			<!-- Display the Collection Count -->
	  		<%=curIndex+1%> of <%=m_collection.size()%>
	
			<!-- Display the "Next" button -->
			<% if(nextImage >= 0){ %>
				&nbsp;<a href="photo_annotate.jsp?photoID=<%=nextImage%>"><img src="resources/images/buttons/forward.gif" align="middle" width="30"></a>
			<% } %>
		</div> <!-- END DETAILS OPERATIONS -->
	</div> <!-- END DETAILS PHOTO CONTAINER -->
    
</div><!-- END CENTER COLUMN -->
    
</body>
</html>
