<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.util.MMM2Properties" %>
<%@ page import="gcr.mmm2.util.StringUtils" %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.server.servlets.JpegRotator" %>

<%
	String username = request.getRemoteUser();
	System.out.println("USERNAME (DETAILS): " + username);
	IUser m_user = UserManager.getByUsername(username);	
	
	int photoID = -1;
	String temp = request.getParameter("photoID");
	try{
		photoID = Integer.parseInt(temp);
	}catch(NumberFormatException nfe){
		//photoID is set to -1, redirect will be called next
		System.err.println("photo_details.jsp: NumberFormatException when parsing photoID");
	}
	
	if(photoID == -1){
		response.sendRedirect("./index.jsp");
	}
	
	IPhoto m_photo = PhotoFactory.getPhotoByID(photoID);
	
	IContext context = m_photo.getContext();
	String location_label = "";
	ArrayList location_info = null;
	if(context!=null){
		location_label = context.getLocationLabel();
		location_info = (ArrayList)context.getGpsLocationInfo();
	}
	
	//GET PREVIOUS and NEXT image INDEXES
	//the album, collection, or set of photos is stored here
	ArrayList m_collection = (ArrayList)session.getAttribute("collection");
	int nextImage;
	int prevImage;
	
	//if no session collection is set...
	if(m_collection==null){
		m_collection = new ArrayList();
		m_collection.add(new Integer(m_photo.getID()));
	}else if(m_collection.size() == 0){
		m_collection.add(new Integer(m_photo.getID()));
	}
	
	int curIndex = m_collection.indexOf(new Integer(m_photo.getID()));
	if(curIndex < 0){
		System.err.println("photo_details.jsp: our image doesn't even show up in the list");
		System.err.println("photo_details.jsp: "+new Integer(m_photo.getID()));
		System.err.println("photo_details.jsp: "+m_collection);
		return; //our image doesn't even show up in the list
		//TODO: Log this.
	}
	
	//get the PREVIOUS image index, -1 if none
	if(curIndex == 0)
		prevImage = -1;
	else
		prevImage = ((Integer)m_collection.get(curIndex-1)).intValue();
	
	//get the NEXT image index, -1 if none
	if(curIndex >= m_collection.size()-1)
		nextImage = -1;
	else
		nextImage = ((Integer)m_collection.get(curIndex+1)).intValue();
	
	
	//ROTATE AND DELETE
	if( (request.getParameter("operation") != null ) && (request.getParameter("photoID") != null) ){

	    String op = request.getParameter("operation");
	    if(op.equals("rotateR")){
	    	try{
				String filename=MediaManager.getRealPath(m_photo.getJPEGFilename());
				JpegRotator.rotateImage(filename, JpegRotator.ROTATE_90_RIGHT);
				m_photo.clearCachedImages();
			}catch(StringFormatException sfe){/*do nothing*/}
	    }else if(op.equals("rotateL")){
	    	try{
				String filename=MediaManager.getRealPath(m_photo.getJPEGFilename());
				JpegRotator.rotateImage(filename, JpegRotator.ROTATE_90_LEFT);
				m_photo.clearCachedImages();
			}catch(StringFormatException sfe){/*do nothing*/}
	    }else if(op.equals("delete")){
	        try{m_photo.delete(m_user);}
	        catch(PermissionException pe){/*do nothing*/}
	        //TODO: do some fancy things here with redirect
	        response.sendRedirect("./index.jsp");
	    }
	    if(session.getAttribute("actionRedirect") != null){
	    	response.sendRedirect((String)session.getAttribute("actionRedirect"));
	    }
    }
	    
	    
	//GET COMMENTS FOR THIS IMAGE
	if( request.getParameter("new_comment") != null){
		try{m_photo.addComment(request.getParameter("new_comment"), m_user);}
		catch(PermissionException pe){/*do nothing*/}
	}

	//Comment Operations
	if( request.getParameter("removeComment") != null ){
		int cId = Integer.parseInt(request.getParameter("removeComment"));
		try{m_photo.removeComment(cId, m_user);}
		catch(PermissionException pe){/*do nothing*/}
	}

	List m_comments = m_photo.listComments();
	session.setAttribute("actionRedirect", request.getRequestURL().toString()+"?"+request.getQueryString());

%>

<html>
<head>
<title>Photo Details</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
<script type="text/javascript" language="JavaScript" src="resources/scripts/open_edit_window.js"></script>
<script type="text/javascript" language="JavaScript" src="resources/scripts/full_size_image.js"></script>
<script type="text/javascript" language="JavaScript" src="resources/scripts/popup.js"></script>
</head>
<body>

<%@ include file="header.jsp" %>

<div class="left_column">
<%@ include file="timeline.jsp" %>
<%@ include file="my_albums_menu.jsp"  %>
<%@ include file="received_albums_menu.jsp"	 %>
</div><!-- end left column -->

<div class="details_center_column">

	<!-- THE PHOTO!!  THE MAIN ATTRACTION!! -->
	<div class="details_photo_container">
		<div class="details_photo">
		<%
			String fullUrl = m_photo.getURL(null,null,0);
			if(fullUrl.indexOf(".amr")>-1 || fullUrl.indexOf(".3gp")>-1) {
				%><EMBED WIDTH="320" HEIGHT="200" SRC="<%=fullUrl%>"><%
			} else {
				%><a href="<%=m_photo.getURL(null,null,0)%>" target="_blank" onClick="viewPic(this.href); scrollbars='yes'; return false;">
				<img class="photo" src="<%=m_photo.getURL(null,null,400)%>">
				</a><%
			}
		%> 
			
		</div>
		
		
		<div class="details_caption">
			<strong><em><%=StringUtils.showSafeHTML(m_photo.getCaption() )%></em></strong>
		</div>
	
	    <div class="details_operations">
			<% 
			if( m_photo.getOwner().getID()==m_user.getID() ){
			%>
				<!-- Rotation Buttons -->
				Rotate:
				<a href="./photo_details.jsp?photoID=<%=m_photo.getID()%>&operation=rotateL">(L)</a>          	
				&nbsp;/&nbsp;
				<a href="./photo_details.jsp?photoID=<%=m_photo.getID()%>&operation=rotateR">(R)</a>
				&nbsp;
				
				<!-- Delete the Photo button -->
				<a href="./photo_details.jsp?photoID=<%=m_photo.getID()%>&operation=delete">[delete]</a>
				&nbsp;&nbsp;&nbsp;
			<%
			}
			%>
	      
	      	<!-- The Blog-it Button --> 
	  		<a href="./blog.jsp?photoID=<%=m_photo.getID()%>">[blog-it]</a>
	  		&nbsp;&nbsp;
	  		
	  		<!-- The Full-Size Button -->
	  		<a href="<%=m_photo.getURL(null,null,0)%>" target="_blank" onClick="viewPic(this.href); scrollbars='yes'; return false;">[full size]</a>
	  		&nbsp;&nbsp;
	  		
	  		<!-- Display the "Previous" button -->
	  		<%
	  		if(prevImage >= 0){
	  		%>
	  		<a href="photo_details.jsp?photoID=<%=prevImage%>"><img src="resources/images/buttons/back.gif" align="middle" width="30"></a>&nbsp;
	  		<%
	  		}
	  		%>
	
			<!-- Display the Collection Count -->
	  		<%=curIndex+1%> of <%=m_collection.size()%>
	
			<!-- Display the "Next" button -->
			<%
			if(nextImage >= 0){
			%>
				&nbsp;<a href="photo_details.jsp?photoID=<%=nextImage%>"><img src="resources/images/buttons/forward.gif" align="middle" width="30"></a>
			<%
			}
			%>
		</div> <!-- END DETAILS OPERATIONS -->
	</div> <!-- END DETAILS PHOTO CONTAINER -->
    
    <div class="comment_container">
    <form name="comment" action="photo_details.jsp" method="get">
	<input type="hidden" name="photoID" value="<%=m_photo.getID()%>">
    	<%
    	if(m_comments.size() > 0){
    		if (m_comments.size() == 1) {
		%>
				<div style="border-bottom: solid black 1px;">There is <%=m_comments.size()%> comment:</div>
		<%
			} else {
		%>
      			<div style="border-bottom: solid black 1px;">There are <%=m_comments.size()%> comments:</div>
      	<%
      		}
      	}else{
      	%>
		<div style="border-bottom: solid black 1px;">There are no comments.</div>
		<%
		}
		%>
      	
        <%
        Iterator comments = m_comments.iterator();
        if(comments != null){
	        while(comments.hasNext()){
	        	Comment c = (Comment)comments.next();
		%>        
				<div class="individual_comment_container">
					<div class="comment"><%=StringUtils.showSafeHTML(c.getComment())%></div>
		       	<%
		       	if( c.getOwner().getID()==m_user.getID() || m_photo.getOwner().getID()==m_user.getID() ){
		   		%>
					<div class="comment_owner">
					<%=c.getOwner()%> - <a href="photo_details.jsp?photoID=<%=m_photo.getID()%>&removeComment=<%=c.getID()%>">remove comment</a>
					</div>
		        	
		        <%
		        }else{
		        %>
					<div class="comment_owner"><%=c.getOwner()%></div>
				<%
				}
				%>
				</div>
		<%
	        }
        }
        %>

		<div>Leave a Comment:</div>
		<div><textarea name="new_comment" cols="60" rows="7"></textarea></div>
		<div><input type="submit" value="Add Comment"></div>
 	</form>
	</div> <!-- end comment container -->
</div><!-- END CENTER COLUMN -->
    
    
<div class="details_right_column">
	<form action="photo_details.jsp" method="GET">
	<input type="hidden" name="photoID" value="<%=m_photo.getID()%>">

	<% // Show "Research Mode" title for Research users
	if (UserManager.isResearchUser(m_user)) { 
	%>
		<div class="metadata_container" align="center"><span class="research"><b>==== RESEARCH MODE ====</b></span></div>
	<% 	} // End Research %>
	
	<% // Show photo filename and ID for Research users
	if (UserManager.isResearchUser(m_user)) { 
	%>
		<div class="metadata_container"><span class="research">
			<div class="metadata_title">Photo Info: </div>
			<span class="metadata_value"><%=m_photo.getJPEGFilename()%> (<%=m_photo.getID()%>)</span>
		</span></div>
	<% 	} // End Research %>
	
	<div class="metadata_container">
		<span class="metadata_title">Date/Time:</span>
		<span class="metadata_value"><%=StringUtils.formatDetailsDate(m_photo.getCaptureDate())%> <%=StringUtils.formatDetailsTime(m_photo.getCaptureDate())%></span>
	</div>

<% 
    // At the moment, there are only two levels of privacy: restricted and unrestricted.
    // We need to change the GUI later to account for additional levels of privacy.
    // --jc
    // 20050720: Added a third "public" privacy level to support Public MMM
    // --mw
%>
<% if (m_user==m_photo.getOwner()) { %>
	<div class="metadata_container">
		<div><span class="metadata_title">Privacy: </span><span class="metadata_value"><%=MediaManager.getPrivacyString(m_photo.getPrivacyLevel(m_user))%></span></div>	
		<div>Change to: <%
		if (!(m_photo.getPrivacyLevel(m_user) == IPhoto.RESTRICTED_PRIVACY))
		{ 
			%><a href=setrestriction.jsp?photoID=<%=m_photo.getID()%>&restriction=<%=IPhoto.RESTRICTED_PRIVACY%>>[restricted]</a> <%
		}
		if (!(m_photo.getPrivacyLevel(m_user) == IPhoto.UNRESTRICTED_PRIVACY))
		{ 
			%><a href=setrestriction.jsp?photoID=<%=m_photo.getID()%>&restriction=<%=IPhoto.UNRESTRICTED_PRIVACY%>>[unrestricted]</a> <%
		}		
		if (!(m_photo.getPrivacyLevel(m_user) == IPhoto.PUBLIC_PRIVACY))
		{ 
			%><a href=setrestriction.jsp?photoID=<%=m_photo.getID()%>&restriction=<%=IPhoto.PUBLIC_PRIVACY%>>[public]</a> <%
		}%></div>
	</div>
<% } // end if user=owner %>
      
	<div class="metadata_container">
		<span class="metadata_title">Location:</span>
		<% if (location_label.equals("") ) { %>
			<span class="metadata_value">none</span>
		<% } else { %>
			<span class="metadata_value"><%= StringUtils.showSafeHTML(location_label) %></span>
		<% } %>
		<% if (m_user == m_photo.getOwner() ) { %>
			<div><a href="javascript:open_edit_window(escape('edit_location_label.jsp?photoID=<%=m_photo.getID()%>'), 'edit_loc_label');">Edit Location Label</a></div>
		<% } %>
		<% if(context!=null){ %>
			<div><a href="location.jsp?network=<%=StringUtils.URLEncode(context.getNetwork())%>&lac=<%=context.getLac()%>&cellID=<%=context.getCellId()%>">[Nearby Photos]</a></div>
		<% } %>
		
		<% // Show cell ID for Research users
		if (UserManager.isResearchUser(m_user)) { 
			if(context!=null){ %>
				<div class="research">Cell ID: <%=context.getCellId()%></a></div>
			<% } 
		} // End Research %>
		
	<% if(location_info != null) { 
		Iterator i = location_info.iterator();
		String gps_lat = (String)i.next();
		String gps_long = (String)i.next();
		String city = (String)i.next();
		String state = (String)i.next();
		String zip = (String)i.next();
	%>
		<% if((gps_lat!=null && gps_long!=null) && (!gps_lat.equals("0.0") && !gps_long.equals("0.0"))) { %>
			<span class="metadata_value">
			<br><br>
			<%= city %>, <%= state %> <%= zip %>
			<br>
			GPS: <%=gps_lat%>, <%=gps_long%>		
			<br><br>
			<a href="http://www.randmcnally.com/rmc/directions/dirGetMap.jsp?val=large&z=small&T=<%=gps_lat%>&N=<%=gps_long%>&h=false&CT=<%=gps_lat%>&CN=<%=gps_long%>&l=10" target="_">
			Street Map</a>
			/
			<a href="http://mapper.acme.com/?lat=<%=gps_lat%>&long=<%=gps_long%>&scale=10&theme=ColorImage&width=4&height=3&dot=Yes" target="_">
			Image Map
			</a>
			<br><br>
			Nearby: 
			<a href="http://maps.yahoo.com/maps_result?zoomin=yes&mag=7&resize=s&rezoom=1&cat=dine&BFKey=allres&zip=<%=zip%>" target="_">Restaurants</a>
			/
			<a href="http://maps.yahoo.com/maps_result?zoomin=yes&mag=7&resize=s&rezoom=1&cat=trav&BFKey=tos&zip=<%=zip%>" target="_">Points of Interest</a>
			/
			<a href="http://maps.yahoo.com/maps_result?zoomin=yes&mag=7&resize=s&rezoom=1&cat=trav&BFKey=Intel&zip=<%=zip%>" target="_">WiFi Hotspots</a>
		<% } %>
		</span>
	<% } %>
	</div>

	
	<div class="metadata_container">
		<span class="metadata_title">Caption:</span>
		<% if (m_photo.getCaption().equals("") ) { %>
			<span class="metadata_value">none</span>
		<% } else { %>
			<span class="metadata_value"><%=StringUtils.showSafeHTML(m_photo.getCaption() )%></span>
		<% } %>
		<% if (m_user == m_photo.getOwner() ) { %>
			<div><a href="javascript:open_edit_window(escape('edit_photo_metadata.jsp?photoID=<%=m_photo.getID()%>&showPhoto=true'), 'edit_caption');">Edit Caption</a></div>
		<% } %>
	</div>
	
	<div class="metadata_container">
		<span class="metadata_title">Owner:</span>
		<span class="metadata_value"><%=m_photo.getOwner()%></span>

		<% // Show User ID for Research users
			if (UserManager.isResearchUser(m_user)) { %>
				<span class="metadata_value"><span class="research">(<%=m_photo.getOwner().getID()%>)</span></span>
		<% 	} // End Research %>
		
	</div>
   	
	<% // Show owner's shared-with info for Research users
	if (UserManager.isResearchUser(m_user)) { 
		Iterator recipIterator = ShareManager.getPhotoRecipients(m_photo, m_photo.getOwner()).iterator();
		int recipSize = ShareManager.getPhotoRecipients(m_photo, m_photo.getOwner()).size();
	%>
		<div class="metadata_container"><span class="research">
			<div class="metadata_title">Owner Shared With (<%=recipSize%>) </div>
			<%
			while(recipIterator.hasNext()){
				IPerson recipient = (IPerson)recipIterator.next();
				out.write("<div class=\"metadata_value\">"+recipient.toString()+ " (" + recipient.getID() + ")</div>");
			}
			%>
		</span></div>
	<% 	} // End Research %>
	
	<div class="metadata_container">
		<div class="metadata_title">Shared With</div>
		<%
		Iterator recipients = ShareManager.getPhotoRecipients(m_photo, m_user).iterator();
		while(recipients.hasNext()){
			IPerson recipient = (IPerson)recipients.next();
			out.write("<div class=\"metadata_value\">"+recipient.toString()+"</div>");
		}
		%>
		<div><a href="sharemedia.jsp?photoID=<%=m_photo.getID()%>">[share]</a></div>
	</div>
	
	<div class="metadata_container">
		<div class="metadata_title">Albums</div>
		<% 
		Iterator albums = m_photo.listAlbums().iterator();
		while(albums.hasNext()){
			IAlbum album = (IAlbum)albums.next();
			if( album.getOwner().getID() == m_user.getID() ){
		%>
			<div class="metadata_value"><a href="album.jsp?albumID=<%=album.getID()%>"><%=StringUtils.showSafeHTML(album.getTitle() )%></a></div>
		<%
			}
	  	}
		%>
		<div><a href="add_to_album.jsp?photoID=<%=m_photo.getID()%>">[add to album]</a></div>
	</div><!-- end album container -->

    <div class="metadata_container">
        <div class="metadata_title">People Present (Bluetooth)
       	<% // Show total number of known Bluetooth for Research users
		if (UserManager.isResearchUser(m_user)) { 
        	if (context == null || context.listNearbyBluetoothPeople().isEmpty()) { %>
       		 	<span class="research">(0)</span>
			<% } else {
				int numBluetoothKnown = context.listNearbyBluetoothPeople().size(); 
				// Display total %>
				<span class="research">(<%=numBluetoothKnown%>)</span>
			<% } 
		} // End Research %>
        </div>
		<% if (context == null || context.listNearbyBluetoothPeopleWithMac().isEmpty() ) { %>
			<span class="metadata_value">none</span>
		<% } else {
			if(context != null){
				Iterator people = context.listNearbyBluetoothPeopleWithMac().iterator();
				int peopleSize = context.listNearbyBluetoothPeopleWithMac().size();			
				while(people.hasNext()){
					String[] person = (String[])people.next();
					out.write("<a href=\"bluetoothmac.jsp?&bt_mac="+person[1] +"\">" + "<div class=\"metadata_value\">"+ person[0] + "</div> </a>"); 
				}
			}
		}
		%>
	</div>
	<div class="metadata_container">
		<div class="metadata_title">Unknown BT Devices Present
		<% // Show total number of unknown Bluetooth for Research users
		if (UserManager.isResearchUser(m_user)) { 
        	if (context == null || context.listUnknownBluetoothDevices().isEmpty()) { %>
       		 	<span class="research">(0)</span>
			<% } else {
				int numBluetoothUnknown = context.listUnknownBluetoothDevices().size(); 
				// Display total %>
				<span class="research">(<%=numBluetoothUnknown%>)</span>
			<% } 
		} // End Research %>
		</div>
		<% if (context == null || context.listUnknownBluetoothDevices().isEmpty() ) { %>
			<span class="metadata_value">none</span>
		<% } else {
			if(context != null){        
	        	Iterator unknownDevices = context.listUnknownBluetoothDevices().iterator();
				while(unknownDevices.hasNext()){
					String[] device = (String[])unknownDevices.next();
					out.write("<a href=\"bluetoothmac.jsp?&bt_mac="+ device[0]+"\">" + "<div class=\"metadata_value\">"+ device[0] + "("+device[1]+") </div> </a>"); %>
					<a href="javascript:open_edit_window_sized(escape('associate_btdevice.jsp?photoID=<%=m_photo.getID()%>&btMAC=<%=device[0]%>&btAlias=<%=device[1]%>'), 'associate_bt_device', 400, 500);">Edit</a>
		<%
				}
			}
		}
		%>
    </div><!-- end md container -->
    <% if(MMM2Properties.getProperty("FACETED_ANNOTATION_ON") != null){%>
    <% // Turn off Faceted Annotation for now
    //<div class="metadata_container">
    //	<div><a href="./annotation/annotate.jsp?photoID=">Faceted Annotation</a></div>
    //</div>
    %>
    <% } %>
    <!-- end facted annotation -->
    
    <!-- start JPEG Metadata -->
    <div class="metadata_container">
    	<div class="metadata_title"><a href="javascript:popup('./jpeg_metadata.jsp?photoID=<%=m_photo.getID()%>','jpeg_metadata',400,550,'yes');">JPEG Metadata</a></div>
    </div>
    <!-- end JPEG Metadata -->
    
</div><!-- end right column -->
</body>
</html>