<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.util.StringUtils" %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.server.servlets.JpegRotator" %>

<%
	String username = request.getRemoteUser();
	System.out.println("USERNAME (DETAILS): " + username);
	IUser m_user = UserManager.getByUsername(username);	
	
	int photoID = -1;
	String temp = request.getParameter("photoID");
	try{
		photoID = Integer.parseInt(temp);
	}catch(NumberFormatException nfe){
		//photoID is set to -1, redirect will be called next
		System.err.println("photo_metadata.jsp: NumberFormatException when parsing photoID");
	}
	
	if(photoID == -1){
		response.sendRedirect("./index.jsp");
	}
	
	IPhoto m_photo = PhotoFactory.getPhotoByID(photoID);
	
	String pathAndFilename = MediaManager.ORIG_IMAGE_DIR + "/" + m_photo.getOwner().getID() + "/" + m_photo.getJPEGFilename();
	System.out.println("pathAndFilename: " + pathAndFilename);
	JpegMetadata jm = new JpegMetadata(pathAndFilename);
	Iterator tags = jm.getTagList().iterator();
%>

<html>
<head>
<title>JPEG Metadata</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
<script type="text/javascript" language="JavaScript" src="resources/scripts/open_edit_window.js"></script>
<script type="text/javascript" language="JavaScript" src="resources/scripts/full_size_image.js"></script>
</head>
<body>

	<div class="metadata_container" bgcolor="white">
		<div class="metadata_title">JPEG Metadata</div>
		<table border="0" cellpadding="2" cellspacing="2">
			<tr>
			<td class="metadata_title" bgcolor="#eeeeee">Type</td>
			<td class="metadata_title" bgcolor="#eeeeee">Name</td>
			<td class="metadata_title" bgcolor="#eeeeee">Value</td>
			</tr>
		<% 
		while(tags.hasNext()){
			JpegMetadataTag tag = (JpegMetadataTag)tags.next();
		%>
			<tr>
			<td class="metadata_value" bgcolor="#eeeeee" valign="top"><%=tag.getDirectory()%></td>
			<td class="metadata_value" bgcolor="#eeeeee" valign="top"><%=tag.getName()%></td>
			<td class="metadata_value" bgcolor="#eeeeee" valign="top"><%=tag.getDescription()%></td>
			</tr>
		<%
	  	}
		%>
		</table>
	</div>

</body>
</html>
