<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>

<%	
	String username = request.getRemoteUser();
	IUser u = UserManager.getByUsername(username);
	
	if(request.getParameter("removeMAC") !=null){
		try{
			u.removeBluetoothMAC(request.getParameter("removeMAC"), u);
		}catch(PermissionException pe){/* do nothing */}
	}
	
	if(request.getParameter("removeBlog") !=null){
		try{
			u.removeBlog(Integer.parseInt(request.getParameter("removeBlog")), u);
		}catch(PermissionException pe){/* do nothing */}
	}
	
	String passwordErrorString = "";
	if(request.getParameter("new_password") != null){
		if( (request.getParameter("new_password_verify") != null) && 
			request.getParameter("new_password").equals(request.getParameter("new_password_verify") ) ){
			//the passwords are ready to go!
			try{
				if(!u.changePassword(request.getParameter("old_password"), request.getParameter("new_password"), u)){
					passwordErrorString="Password set failed... old password was wrong-o!";
				}
			}catch(PermissionException pe){
				passwordErrorString="Permission denied.  Something has gone terribly wrong.";
			}
		}else{
			passwordErrorString="Password set failed... new password didn't match verification!";
		}
	}
	if(!"".equals(passwordErrorString)) {
	    System.err.println("PASSWORD ERROR:"+passwordErrorString);
	}
	
	List m_bluetoothMACs = u.listBluetoothDevices();
	List m_emails = u.listEmails();
	List m_blogs = u.listBlogs();
	String m_imsi = u.getPhoneID();
	String m_phoneNumber = u.getPhoneNumber();
	String m_mobileCarrier = u.getMobileCarrier();
	String m_primaryEmail = "";
	boolean m_smsNotify = u.getSmsNotify();
	boolean m_emailNotify = u.getEmailNotify();
	int m_ontology_ns = u.getRDFNameSpaceID();
	
	//get primary address
	EmailAddress ea = u.getPrimaryEmail();
	if(ea !=null)
		m_primaryEmail = ea.getAddress();
	
	String first_name = request.getParameter("first_name");
	String last_name = request.getParameter("last_name");
	String email = request.getParameter("email");
	String mobile_phone = request.getParameter("mobile_phone");
	String mobile_carrier = request.getParameter("mobile_carrier");
	String imsi_number = request.getParameter("imsi_number");
	String bluetooth_mac = request.getParameter("bluetooth_mac");
	boolean sms_notify = false;
	boolean email_notify = false;
	if(request.getParameter("sms_notify") != null && request.getParameter("sms_notify").equals("ON"))
		sms_notify = true;
	if(request.getParameter("email_notify") != null && request.getParameter("email_notify").equals("ON"))
		email_notify = true;
	if(request.getParameter("mobile_phone") == null) {
		sms_notify = m_smsNotify;
		email_notify = m_emailNotify;
	}
	int ontology_ns = 0;
	if(request.getParameter("ontology_ns") != null) {
		ontology_ns = Integer.parseInt(request.getParameter("ontology_ns"));
	}
	StringBuffer errorMessages = new StringBuffer();
	
	if(request.getParameter("submit") != null){
	
		//DO FIRST NAME
		if(first_name != null){
			if(!first_name.equals(u.getFirstName()))
				//errorMessages.append("changing first name doesn't work yet.  bug simon!<br>");
				u.setFirstName(first_name);
		}else{
			errorMessages.append("No first name!!  You need to put in a name, or stuff will break!<br>");
		}
		
		//DO LAST NAME
		if(last_name != null){
			if(!last_name.equals(u.getLastName()))
				//errorMessages.append("changing last name doesn't work yet.  bug simon!!!<br>");
				u.setLastName(last_name);
		}else{
			errorMessages.append("No last name!!  You need to put in a name, or stuff will break!<br>");
		}
		
		//DO EMAIL
		if(email != null){
		
			if(!email.equals(m_primaryEmail) && !email.equals("")){
				Iterator emIt = m_emails.iterator();
				while(emIt.hasNext()){
					EmailAddress addy = (EmailAddress)emIt.next();
					try{
						u.removeEmail(addy.getID(), u);
					}catch(PermissionException pe){/* do nothing */}
				}
				try{
					u.addEmail(email, u);
				}catch(PermissionException pe){/* do nothing */
				}catch(StringFormatException pe){/* do nothing */}
				m_primaryEmail = email;
			}else if(email.equals("")){
				errorMessages.append("No e-mail address!  You need to put in an address, or stuff will break!<br>");
			}
			
		}else{
			errorMessages.append("No e-mail address!  You need to put in an address, or stuff will break!<br>");
		}
		
		//DO BLUETOOTH ASSOCIATION
		if(bluetooth_mac != null){
			if(!bluetooth_mac.equals("") && !m_bluetoothMACs.contains(bluetooth_mac)){
				try{
					u.addBluetoothMAC(bluetooth_mac.toLowerCase(), u);
				}catch(PermissionException pe){/* do nothing */}
				m_bluetoothMACs.add(bluetooth_mac);
			}
		}
		
		//IMSI NUMBER
		if(imsi_number != null){
			if(!imsi_number.equals(m_imsi)){
				try{
					u.setPhoneID(imsi_number, u);
				}catch(PermissionException pe){/* do nothing */}
				m_imsi = imsi_number;
			}
		}
		
		if(mobile_phone != null){
			if(!mobile_phone.equals(m_phoneNumber)){
				try{
					u.setPhoneNumber(mobile_phone, u);
				}catch(PermissionException pe){/* do nothing */
				}catch(StringFormatException sfe){/* do nothing */}
				m_phoneNumber = mobile_phone;
			}
			if(!mobile_carrier.equals(m_mobileCarrier)){
				try{
					u.setMobileCarrier(mobile_carrier, u);
				}catch(PermissionException pe){/* do nothing */}
				m_mobileCarrier = mobile_carrier;
			}			
		}
		
		if(!(sms_notify == m_smsNotify)){
			u.setSmsNotify(sms_notify);
			m_smsNotify = sms_notify;
		}			
		
		if(!(email_notify == m_emailNotify)){
			u.setEmailNotify(email_notify);
			m_emailNotify = email_notify;
		}
		
		if(!(ontology_ns == m_ontology_ns)){
			u.setRDFNameSpaceID(ontology_ns, u);
			m_ontology_ns = ontology_ns;
		}
			
	}

%>

<html>
<head>
<title>Profile for: <%=u.getUsername()%></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
</head>

<body>
<%@ include file="header.jsp" %>

<div style="clear:both">
<div style="color:red"><%=errorMessages.toString()%>&nbsp;</div>
<form name="edit_profile" method="post" action="profile.jsp">
  <table width="50%" border="0">
    <tr valign="top"> 
      <td align="right"><strong>First Name*</strong></td>
      <td align="left"> <input name="first_name" type="text" maxlength="255" value="<%=u.getFirstName()%>"></td>
    </tr>
    <tr valign="top"> 
      <td align="right"><strong>Last Name*</strong></td>
      <td align="left"> <input name="last_name" type="text" maxlength="255" value="<%=u.getLastName()%>"></td>
    </tr>
    <tr valign="top">
      <td align="right"><strong>E-Mail*</strong></td>
      <td align="left">
      <input name="email" type="text" maxlength="255" value="<%=m_primaryEmail%>">
      </td>
    </tr>
    <tr valign="top">
      <td align="right"><strong>Mobile Phone Number</strong></td>
      <td align="left"> <input name="mobile_phone" type="text" maxlength="15" value="<%=u.getPhoneNumber()%>"></td>
    </tr>
    <tr valign="top">
      <td align="right"><strong>Ontology</strong></td>
      <td align="left">
      <select name="ontology_ns">
  		<option value="0"></option>
	 	<%
      	Iterator i =UserManager.listOntologies().iterator();
		while(i.hasNext()){
			String[] s = (String[])i.next();
			out.print("<option value='"+s[0]+"' ");
			if(Integer.parseInt(s[0]) == m_ontology_ns)
				out.print("selected");
			out.println(">"+s[1]+"</option>");
		}
		%>
        </select>
      
      </td>
    </tr>
    <tr valign="top">
      <td align="right"><strong>Mobile Carrier</strong></td>
      <td align="left">
      <select name="mobile_carrier">
  		<option value="0"></option>
	 	<%
      	i =ShareManager.getMobileCarriers().iterator();
		while(i.hasNext()){
			String[] s = (String[])i.next();
			out.print("<option value='"+s[0]+"' ");
			if(s[0].equals(m_mobileCarrier))
				out.print("selected");
			out.println(">"+s[1]+"</option>");
		}
		%>
        </select>
      
      </td>
    </tr>
	<tr valign="top">
      <td align="right"></td>
      <td align="left">Share notifications:<br>
      	SMS? <input name="sms_notify" type="checkbox" value="ON" <% if(m_smsNotify) { %>checked <% } %>> 
      	Email? <input name="email_notify" type="checkbox" value="ON" <% if(m_emailNotify) { %>checked <% } %>></td>
    </tr>
    <tr valign="top">
      <td align="right"><strong>IMSI</strong></td>
      <td align="left"> <input name="imsi_number" type="text" maxlength="15" value="<%=m_imsi%>">
        <em> (15 digits)</em></td>
    </tr>
    <tr valign="top">
      <td align="right"><strong>Bluetooth MAC</strong></td>
      <td align="left">
      <input name="bluetooth_mac" type="text" maxlength="12" value=""> (<em>12 chars)</em><br>
      <% 	Iterator btIt = m_bluetoothMACs.iterator();
      		while(btIt.hasNext()){
      			String mac = (String)btIt.next();
      			out.write("<tt>"+mac+"</tt>&nbsp;<a href='profile.jsp?removeMAC="+mac+"'>remove</a><br>");		
      		}
      %>
      </td>
    </tr>
    <tr valign="top"> 
      <td align="right"><strong>Blogs</strong></td>
      <td align="left">
      <a href="add_blog.jsp">Add New Blog</a><br>
      <% 	Iterator blogIt = m_blogs.iterator();
      		while(blogIt.hasNext()){
      			Blog cur_blog = (Blog)blogIt.next();
      			out.write(cur_blog.getTitle()+"&nbsp;<a href='profile.jsp?removeBlog="+cur_blog.getID()+"'>remove</a><br>");		
      		}
      %>
      </td>
    </tr>
    <tr valign="top"> 
      <td align="right">&nbsp;</td>
      <td align="left">&nbsp;</td>
    </tr>
    <tr>
    <td colspan="2" align="center"><strong>Change Password</strong></td>
    </tr>
    <tr valign="top"> 
      <td align="right"><strong>Old Password</strong></td>
      <td align="left"> <input name="old_password" type="password" maxlength="255"></td>
    </tr>
    <tr valign="top"> 
      <td align="right"><strong>New Password</strong></td>
      <td align="left"> <input name="new_password" type="password" maxlength="255"></td>
    </tr>
    <tr valign="top"> 
      <td align="right"><strong>Verify New Password</strong></td>
      <td align="left"> <input name="new_password_verify" type="password" maxlength="255"></td>
    </tr>
    <tr valign="top"> 
      <td align="right" colspan="2"><input type="submit" name="submit" value="Update Profile"></td>
    </tr>    
  </table>
</form>

<hr>

<a href ="download_archive.jsp">Download personal photo archive.</a><br>
<a href ="http://mmm.sims.berkeley.edu/context/all.SIS">Download Context Application for 7610</a> (requires Opera)

</div>
</body>
</html>
