// Address Search
// Author: Jeff Towle
// Filters a SELECT/OPTION set named "addresses"
// in a FORM named "address_book" from the INPUT (type text)
// passed in as a parameter to address_search()
//
// run initialize on page load to fill up the optionData variable
// with the full set of options

var optionData;

//run this when the page is loaded.  populates the optionData array with the values from
//the select menu via DOM
function initialize(){

	optionData = new Array();

	for(var i = 0; i < document.address_book.addresses.options.length; i++){
		var item = new Object();
		item.text = document.address_book.addresses.options[i].text;
		item.value = document.address_book.addresses.options[i].value;
		optionData[optionData.length] = item;
	}
}

//run this on key-press.  input is a text input element
function address_search (input) {
	
	//clear the form, but count backwards because indexes automatically shift
	//upon deletion
	for(var i = document.address_book.addresses.options.length-1; i >= 0; i--){
		document.address_book.addresses.options[i] = null;
	}
  
	for (var i = 0; i < optionData.length; i++){
	
		var lcAddressText = optionData[i].text.toLowerCase();
		var lcInputText = input.value.toLowerCase();
	
		if( lcAddressText.indexOf( lcInputText ) >= 0){
			//found.  include this item.
			
			//create new item in the DOM
			var newElem = document.createElement("OPTION");
			newElem.text = optionData[i].text;
			newElem.value = optionData[i].value;
			document.address_book.addresses.options.add(newElem);
		}
	}

}//function