// Address Search
// Author: Jeff Towle
// Filters a SELECT/OPTION set named "addresses"
// in a FORM named "group_manager" from the INPUT (type text)
// passed in as a parameter to address_search()
//
// run initialize on page load to fill up the optionData variable
// with the full set of options

var optionData;
var browserName=navigator.appName; 

//run this when the page is loaded.  populates the optionData array with the values from
//the select menu via DOM
function initialize(){

	optionData = new Array();

	for(var i = 0; i < document.group_manager.addresses.options.length; i++){
		var item = new Object();
		item.text = document.group_manager.addresses.options[i].text;
		item.value = document.group_manager.addresses.options[i].value;
		optionData[optionData.length] = item;
	}

}

//run this on key-press.  input is a text input element
function address_search (input) {
	
	//clear the form, but count backwards because indexes automatically shift
	//upon deletion
	for(var i = document.group_manager.addresses.options.length-1; i >= 0; i--){
		document.group_manager.addresses.options[i] = null;
	}
  
	for (var i = 0; i < optionData.length; i++){
	
		var lcAddressText = optionData[i].text.toLowerCase();
		var lcInputText = input.value.toLowerCase();
	
		if( lcAddressText.indexOf( lcInputText ) >= 0){
			//found.  include this item.
			
			//create new item in the DOM
			var newElem = document.createElement("OPTION");
			newElem.text = optionData[i].text;
			newElem.value = optionData[i].value;
			document.group_manager.addresses.options.add(newElem);
		}
	}

}//function

function add_to_group() {
	
	var selectedItem = document.group_manager.addresses.selectedIndex;
	
	//create new item in the DOM
	var newElem = document.createElement("OPTION");
	newElem.text = optionData[selectedItem].text;
	newElem.value = optionData[selectedItem].value;
	
	if (browserName == "Microsoft Internet Explorer")
		document.group_manager.group_members.options.add(newElem);
	else {
		arrLength = document.group_manager.group_members.options.length;
		document.group_manager.group_members.options[arrLength] = newElem;
	}

  
}//function

function remove_from_group() {

	var selectedItem = document.group_manager.group_members.selectedIndex;
	document.group_manager.group_members.options[selectedItem] = null;
  
}//function

function saveGroup () {
	
	for(var i=0; i < document.group_manager.group_members.options.length; i++){
		document.group_manager.group_members.options[i].selected = true;
	}
	
	document.group_manager.action.value = "save";
	document.group_manager.submit();
  
}//function

function confirmDelete() {
	
	if(confirm("Are you sure you want to delete this group?")) {
		document.group_manager.action.value = "delete";
		document.group_manager.submit();
	}
  
}//function