// Use these functions to enable photo region selection.
// Be sure to include the wz_jsgraphics.js library before you include this one.
//
// props to http://www.forum4designers.com/archive22-2004-4-75795.html
// for showing me how to track coordinates
//
// By: Joshua Chao

// 0 for first click, 1 for second click
var gcrmode = 0;
var jg_doc;
var gcrmodeoneX;
var gcrmodeoneY;
var gcrmodetwoX;
var gcrmodetwoY;
var gcrpiconeX;
var gcrpiconeY;
var gcrpictwoX;
var gcrpictwoY;


function resetMode() {
    gcrmode = 0;
}

function registerClick(evt) {
    if (gcrmode == 0) {
	gcrmode += 1;
	gcrmodeoneX = evt.pageX;
	gcrmodeoneY = evt.pageY;
	gcrpiconeX = getPicCoordX(evt);
	gcrpiconeY = getPicCoordY(evt);
	jg_doc.drawLine(evt.pageX-5, evt.pageY, evt.pageX+5, evt.pageY);
	jg_doc.drawLine(evt.pageX, evt.pageY-5, evt.pageX, evt.pageY+5);
	jg_doc.paint();
    }
    else if (gcrmode == 1) {
	gcrmode += 1;
	gcrmodetwoX = evt.pageX;
	gcrmodetwoY = evt.pageY;
	gcrpictwoX = getPicCoordX(evt);
	gcrpictwoY = getPicCoordY(evt);
	jg_doc.drawLine(evt.pageX-5, evt.pageY, evt.pageX+5, evt.pageY);
	jg_doc.drawLine(evt.pageX, evt.pageY-5, evt.pageX, evt.pageY+5);
	jg_doc.paint();
	jg_doc.drawRect(gcrmodeoneX,gcrmodeoneY, 
			gcrmodetwoX-gcrmodeoneX, gcrmodetwoY-gcrmodeoneY);
	jg_doc.paint();
	
	var alertString = "PointOne:" + gcrpiconeX + 
	    "," + gcrpiconeY + " PointTwo:" + gcrpictwoX + "," + gcrpictwoY;

	alert(alertString);
    }
    else {
	alert("Reset first!");
    }
}

// Set event listener
function init(img, canvas) {
    if (document.addEventListener) {
	// W3C model supported
	
	// Set event listeners
	document.getElementById(img)
	    .addEventListener("mousemove", TrackCoordinates, false);
	document.getElementById(img).
	    addEventListener("click", registerClick, false);

	// Initialize the canvas
	jg_doc = new jsGraphics(canvas);
	jg_doc.setColor("#ff0000");
    }
}

// Handle the mouseover event on item
function TrackCoordinates(evt) {
    var Coordinate_X_InImage = 0; 
    var Coordinate_Y_InImage = 0;

    if(window.event && !window.opera && typeof event.offsetX == "number") {
	// Windows
	Coordinate_X_InImage = event.offsetX;
	Coordinate_Y_InImage = event.offsetY;
    }
    else if(document.addEventListener && evt && typeof evt.pageX == "number") {
	// Mozilla
	Coordinate_X_InImage = getPicCoordX(evt);
	Coordinate_Y_InImage = getPicCoordY(evt);
    }
    // 
    window.status="X:" + Coordinate_X_InImage + " Y:" + Coordinate_Y_InImage;
}

function getPicCoordX(evt) {
    var Element = evt.target;
    var CalculatedTotalOffsetLeft = 0; 
    
    while (Element.offsetParent) {
	CalculatedTotalOffsetLeft += Element.offsetLeft;
	Element = Element.offsetParent;
    }
 
   return evt.pageX - CalculatedTotalOffsetLeft;
}

function getPicCoordY(evt) {
    var Element = evt.target;
    var CalculatedTotalOffsetTop = 0;
    
    while (Element.offsetParent) {
	CalculatedTotalOffsetTop += Element.offsetTop;
	Element = Element.offsetParent;
    }
        
    return evt.pageY - CalculatedTotalOffsetTop;
}
