// Address Search
// Author: Jeff Towle
// Filters a SELECT/OPTION set named "addresses"
// in a FORM named "group_manager" from the INPUT (type text)
// passed in as a parameter to address_search()
//
// run initialize on page load to fill up the optionData variable
// with the full set of options

var optionData;
var browserName=navigator.appName; 

//run this when the page is loaded.  populates the optionData array with the values from
//the select menu via DOM
function initialize(fname){

	var formName = fname;
	optionData = new Array();

	for(var i = 0; i < document.share_recipients.addresses.options.length; i++){
		var item = new Object();
		item.text = document.share_recipients.addresses.options[i].text;
		item.value = document.share_recipients.addresses.options[i].value;
		optionData[optionData.length] = item;
	}
	
}

//run this on key-press.  input is a text input element
function address_search(input) {
	
	//clear the form, but count backwards because indexes automatically shift
	//upon deletion
	for(var i = document.share_recipients.addresses.options.length-1; i >= 0; i--){
		document.share_recipients.addresses.options[i] = null;
	}
  
	for (var i = 0; i < optionData.length; i++){
	
		var lcAddressText = optionData[i].text.toLowerCase();
		var lcInputText = input.value.toLowerCase();
	
		if( lcAddressText.indexOf( lcInputText ) >= 0){
			//found.  include this item.
			
			//create new item in the DOM
			var newElem = document.createElement("OPTION");
			newElem.text = optionData[i].text;
			newElem.value = optionData[i].value;
			document.share_recipients.addresses.options.add(newElem);
		}
	}

}//function

function trim(s) {
  while (s.substring(0,1) == ' ') {
    s = s.substring(1,s.length);
  }
  while (s.substring(s.length-1,s.length) == ' ') {
    s = s.substring(0,s.length-1);
  }
  return s;
}//function

function addSuggestedRecipient() {
	
	var selectedItem = document.share_recipients.suggestedRecipients.selectedIndex;
	
	//create new item in the DOM
	var newElem = document.createElement("OPTION");
	newElem.text = document.share_recipients.suggestedRecipients[selectedItem].text;
	newElem.value = document.share_recipients.suggestedRecipients[selectedItem].value;
	
	if (browserName == "Microsoft Internet Explorer")
		document.share_recipients.recipients.options.add(newElem);	
	else {
		arrLength = document.share_recipients.recipients.options.length;
		document.share_recipients.recipients.options[arrLength] = newElem;
	}
  
}//function

function addAddressBookRecipient() {
	
	var selectedItem = document.share_recipients.addresses.selectedIndex;
	
	//create new item in the DOM
	var newElem = document.createElement("OPTION");
	newElem.text = document.share_recipients.addresses[selectedItem].text;
	newElem.value = document.share_recipients.addresses[selectedItem].value;
	
	if (browserName == "Microsoft Internet Explorer")
		document.share_recipients.recipients.options.add(newElem);	
	else {
		arrLength = document.share_recipients.recipients.options.length;
		document.share_recipients.recipients.options[arrLength] = newElem;
	}
  
  
}//function

function removeRecipient() {

	var selectedItem = document.share_recipients.recipients.selectedIndex;
	document.share_recipients.recipients.options[selectedItem] = null;
  
}//function

function removeAllRecipients(){
	//clear the form, but count backwards because indexes automatically shift
	//upon deletion
	for(var i = document.share_recipients.recipients.options.length-1; i >= 0; i--){
		document.share_recipients.recipients.options[i] = null;
	}
}//function

function submitRecipientList() {
	numRecipients = document.share_recipients.recipients.options.length;
	//Check that the user has selected at least one recipient before continuing
	if (numRecipients > 0) { //OK, submit
		for(var i=0; i < document.share_recipients.recipients.options.length; i++){
			document.share_recipients.recipients.options[i].selected = true;
		}
		document.share_recipients.submit();
	} else {//NOT OK, alert and do not submit
		alert("Please add at least one recipient before continuing.");
	}
}//function

// Show/hide address lists
function toggleLayer(toSwitchOn, toSwitchOff1, toSwitchOff2)
{
	if (document.getElementById)
	{
		// this is the way the standards work
		//var style2 = document.getElementById(whichLayer).style;
		//style2.display = style2.display? "":"none";
		var styleOn = document.getElementById(toSwitchOn).style;
		var styleOff1 = document.getElementById(toSwitchOff1).style;
		var styleOff2 = document.getElementById(toSwitchOff2).style;
		styleOn.display = "block";
		styleOff1.display = "none";
		styleOff2.display = "none";
	}
	else if (document.all)
	{
		// this is the way old msie versions work
		//var style2 = document.all[whichLayer].style;
		//style2.display = style2.display? "":"none";
	}
	else if (document.layers)
	{
		// this is the way nn4 works
		//var style2 = document.layers[whichLayer].style;
		//style2.display = style2.display? "":"none";
	}
}

function createNewAddress() {
	// check if required fields are full
	// validate e-mail and other fields
	firstName = trim(document.share_recipients.first.value);
	lastName = trim(document.share_recipients.last.value);
	emailAddress = trim(document.share_recipients.email.value);
	mobilePhone = trim(document.share_recipients.mobilephone.value);
	if (firstName == "" ||
		lastName == "" ||
		emailAddress == "" ) 
	{
		alert("Please fill in all required fields.");
		return;
	}
	if (!((emailAddress.indexOf(".") > 2) && 
		(emailAddress.indexOf("@") > 0)))
	{
		alert("Please enter a valid e-mail address.");
		return;
	}
	div = ":%"
	newRecipientID = "n." + firstName + div + lastName + div + emailAddress + div + mobilePhone;
	
	//create new item in the DOM
	var newElem = document.createElement("OPTION");
	newElem.text = firstName + " " + lastName;
	newElem.value = newRecipientID;
	
	if (browserName == "Microsoft Internet Explorer")
		document.share_recipients.recipients.options.add(newElem);	
	else {
		arrLength = document.share_recipients.recipients.options.length;
		document.share_recipients.recipients.options[arrLength] = newElem;
	}
  	
	
	//clear fields
	document.share_recipients.first.value = "";
	document.share_recipients.last.value = "";
	document.share_recipients.email.value = "";
	document.share_recipients.mobilephone.value = "";
}//function

function removeThumb(photoID) {
	numPhotos = document.share_recipients.numPhotos.value;
	//Check that there is more than one share photo before deleting
	if (numPhotos > 1) { //OK, delete
		numRecipients = document.share_recipients.recipients.options.length;
		for(var i=0; i < document.share_recipients.recipients.options.length; i++){
			document.share_recipients.recipients.options[i].selected = true;
		}
		document.share_recipients.stage.value = "delete";
		document.share_recipients.photoIDDelete.value = photoID;
		document.share_recipients.commitShare.value = "";
		document.share_recipients.submit();
	} else {
		alert("You must share at least one photo.");
	}
}//function

