<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.util.MMM2Properties" %>
<%@ page import="gcr.mmm2.util.StringUtils" %>
<%@ page import="java.util.*" %>
<%

int photoID = -1;
String temp = request.getParameter("photoID");
try{
	photoID = Integer.parseInt(temp);
}catch(NumberFormatException nfe){
	//photoID is set to -1, redirect will be called next
	System.err.println("photo_details.jsp: NumberFormatException when parsing photoID");
}

if(photoID == -1){
	response.sendRedirect("./index.jsp");
}

IPhoto m_photo = PhotoFactory.getPhotoByID(photoID);

if(!m_photo.isPublic()){
	response.sendRedirect("./index.jsp");
}
	
IContext context = m_photo.getContext();
String location_label = "";
ArrayList location_info = null;
if(context!=null){
	location_label = context.getLocationLabel();
	location_info = (ArrayList)context.getGpsLocationInfo();
}

String ownerName = m_photo.getOwner().getFirstName() + " " + m_photo.getOwner().getLastName();

%>
<html>
<head>
<title>MMM2 Public Photo</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
<script type="text/javascript" language="JavaScript" src="resources/scripts/full_size_image.js"></script>
</head>
<body>

	<!-- THE PHOTO -->
		<div class="details_photo">
		<%
			String fullUrl = m_photo.getURL(null,null,0);
			if(fullUrl.indexOf(".amr")>-1 || fullUrl.indexOf(".3gp")>-1) {
				%><EMBED WIDTH="320" HEIGHT="200" SRC="<%=fullUrl%>"><%
			} else {
				%><a href="<%=m_photo.getURL(null,null,0)%>" target="_blank" onClick="viewPic(this.href); scrollbars='yes'; return false;">
				<img class="photo" src="<%=m_photo.getURL(null,null,400)%>">
				</a><%
			}
		%> 
			
		</div>
		
		
		<div class="details_caption">
			<%=StringUtils.showSafeHTML(m_photo.getCaption() )%>	
		</div>
		
		<div class="details_caption">
			<em><%=ownerName%></em>
		</div>
	
	    <div class="details_operations">
	  		
	  		<!-- The Full-Size Button -->
	  		<a href="<%=m_photo.getURL(null,null,0)%>" target="_blank" onClick="viewPic(this.href); scrollbars='yes'; return false;">[full size]</a>
	  		&nbsp;&nbsp;<a href="<%=MMM2Properties.getProperty("MMM_URL")%>">[mmm2 home]</a>
	  		
		</div> <!-- END DETAILS OPERATIONS -->

</body>
</html>