<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.util.logging.Logger" %>

<%
	// Updated by Mike Wooldridge (mikew@sims.berkeley.edu) 7/6/2005

	final Logger log = Logger.getLogger("sharingActivity");

	final String SHARE		= "share";	// Choose recipients and type message
	final String CONFIRM	= "confirm";// Confirm share
	final String DELPHOTO	= "delphoto";	// Delete a photo
	final String NEW		= "new";	// Create a new address
	
	String stage = SHARE; // Default to initial share page
	if(request.getParameter("stage") != null){
		stage = request.getParameter("stage");
	}
	
	String username = request.getRemoteUser();
	IUser m_user = UserManager.getByUsername(username);

	final String lprefix = "[PC] SID="+request.getSession().getId()+" UID="+m_user.getID()+" ";
	
	
	boolean flushRecipients = false;
	if(request.getParameter("flushRecipients") != null){
		flushRecipients = true;
	}
	
	//edit mode means the page generated is intended to replace current
	//data.  a flushXXX flag will be set in the subsequent query string.
	boolean editMode = false;
	if(request.getParameter("edit") != null){
		editMode = true;
		log.info(lprefix+"entering edit mode");
	}
		
	HashMap sessionShareData = (HashMap)session.getAttribute("sessionShareData");
	if(sessionShareData == null){
		sessionShareData = new HashMap();
		session.setAttribute("sessionShareData", sessionShareData);
	}
	
	
	/*
	 * PHOTO SECTION
	 * Get photoID parameters passed in query. For each ID, put IPhoto object in photos HashSet
	 */
	HashSet photos	= (HashSet)sessionShareData.get("photos");
	if(null==photos)// || flushPhotos)
		photos = new HashSet();
		
	String[] photoIDs = request.getParameterValues("photoID");
	if(photoIDs != null){
		photos.clear();
		for(int i = 0; i < photoIDs.length; i++){
			IPhoto p = PhotoFactory.getPhotoByID(Integer.parseInt(photoIDs[i]));
			if(p != null){photos.add(p);}
		}
	}
	
	/*
	 * RECIPIENT SECTION
	 * Get recipients parameters passed in query. 
	 * For each recipient (code "p"), put IPerson object in recipients HashSet	 
	 * For each contact list (code "l"), put IContactList object in contactLists HashSet	 
	 * For each contact list (code "n"), DO SOMETHING	 
	 */
	HashSet recipients = (HashSet)sessionShareData.get("recipients");
	if(null==recipients || flushRecipients)
		recipients = new HashSet();
		
	HashSet contactLists = (HashSet)sessionShareData.get("contactLists");
	if(null==contactLists || flushRecipients)
		contactLists = new HashSet();
		
	HashSet newAddresses = (HashSet)sessionShareData.get("newAddresses");
	if(null==newAddresses || flushRecipients)
		newAddresses = new HashSet();
		
	String[] recipientIDs = request.getParameterValues("recipients");
	if(recipientIDs != null){

		for(int i = 0; i < recipientIDs.length; i++){
		
			String code = recipientIDs[i].substring(0,1);
			String id = recipientIDs[i].substring(2);
			
			if(code.equals("p")){ // recipient is a single person
				IPerson r = PersonManager.getByID(Integer.parseInt(id));
				if(r != null){recipients.add(r);}
			}else if(code.equals("l")){ // recipient is a contact list
				IContactList cl = ContactManager.getContactListByID(Integer.parseInt(id));
				if(cl != null){contactLists.add(cl);}
			}else if(code.equals("n")){ // recipient is a new address
				System.out.println("NEW ADDRESS:" + recipientIDs[i]);
				String[] idElements = id.split(":%");
				String firstName = idElements[0];
				String lastName = idElements[1];
				String emailAddress = idElements[2];
				String mobileNumber = "";
				if (idElements.length > 3)
				{
					mobileNumber = idElements[3];
				}
				System.out.println("OUT OF IF");
				IPerson newPerson = null;
				IContact newContact = null;		
				Iterator personEntries = PersonManager.listPersons(firstName, lastName).iterator(); 
				//if there is a person instance that is also a user, 
				//use that as the person for this new contact.
				//TODO: Breaks if multiple people have the same name.
				while(personEntries.hasNext()){
	    	    	newPerson = (IPerson)personEntries.next();
					System.out.println("CHECKING ADDRESS: " + newPerson.getFirstName() + ":" + newPerson.getLastName());
					if(UserManager.isUser(newPerson)) {
						System.out.println("FOUND!");
						break;
					}
	    	   	}
				
				//create a new person if there is no matching existing person instance
				if(newPerson == null) {
					newPerson = PersonManager.createPerson(firstName, lastName, m_user);
					newContact = ContactManager.createContact(newPerson, m_user);
					System.out.println("CREATED NEW CONTACT");
					if(emailAddress != null){
						try{
							newContact.addEmail(emailAddress, m_user);
						}catch(StringFormatException sfe){
							//TODO: print out an error message or something
						}
					}
					if(mobileNumber != null){
						try{
							newContact.setPhoneNumber(mobileNumber, m_user);
						}catch(StringFormatException sfe){
							//TODO: print out an error message or something
						}
					}
				} else {
					System.out.println("CREATED NEW CONTACT USING FOUND INSTANCE");
					newContact = ContactManager.createContact(newPerson, m_user);
				}
				if(newPerson != null){recipients.add(newPerson);}
			}
		}
	}
	
	/*
	 * SHARE ALBUM SECTION
	 * These albums are *shared*, but pictures are not placed in them (for future use)
	 * Get albumID parameters passed in query. For each ID, put IAlbum object in shareAlbums HashSet
	 */
	HashSet shareAlbums	 = (HashSet)sessionShareData.get("shareAlbums");
	if(null==shareAlbums)// || flushAlbums)
		shareAlbums = new HashSet();
	
	String[] shareAlbumIDs = request.getParameterValues("albumID");
	if(shareAlbumIDs != null){
		shareAlbums.clear();
		for(int i = 0; i < shareAlbumIDs.length; i++){
			IAlbum cur_album = AlbumFactory.getAlbumByID(Integer.parseInt(shareAlbumIDs[i]));
			shareAlbums.add(cur_album);
		}//end for
	}
	
	/*
	 * MESSAGE SECTION
	 */
	String message = request.getParameter("message");
	if(message==null){ // if null, replace with session-stored message
		message = (String)sessionShareData.get("message");
		if(message==null) // if still null, set to empty string
			message = "";
	}
	
	/*
	 * PHOTO DELETE SECTION
	 */
	 
	if (stage.equals(DELPHOTO) && 
		request.getParameter("photoIDDelete") != null && 
		Integer.parseInt(request.getParameter("numPhotos")) > 1) 
		{
		int int_photoIDDelete = Integer.parseInt(request.getParameter("photoIDDelete"));
		IPhoto p = PhotoFactory.getPhotoByID(int_photoIDDelete);
		if (photos.contains(p)){
			System.out.println("FOUND");
			photos.remove(p);
		}
	}
	
	/*
	 * ADD NEW ADDRESS SECTION
	 * If user is adding a new address to share with, add this to the address book
	 * Code taken from address_book.jsp and modified.
	 */
	 
	IPerson newPerson = null;
	IContact newContact = null;
 	if (stage.equals(NEW) && 
 		request.getParameter("addNewAddress") != "" &&
 		request.getParameter("addNewAddress") != null)
	{
		String firstName = request.getParameter("first");
		String lastName = request.getParameter("last");
		if(firstName == null || firstName.equals("")){
			out.write("NEW: No first name");
			return;
		}
		if(lastName == null || lastName.equals("")){
			out.write("NEW: No last name");
			return;
		}
		System.out.println("NEW ADDRESS: " + firstName + ":" + lastName);
		
		newPerson = null;
		Iterator personEntries = PersonManager.listPersons(firstName, lastName).iterator(); 
		System.out.println("1");
		//if there is a person instance that is also a user, 
		//use that as the person for this new contact.
		//TODO: will break if multiple people have the same name.
		while(personEntries.hasNext()){
        	newPerson = (IPerson)personEntries.next();
			System.out.println("CHECKING ADDRESS: " + newPerson.getFirstName() + ":" + newPerson.getLastName());
			if(UserManager.isUser(newPerson)) {
				System.out.println("FOUND!");
				break;
			}
       	}
		System.out.println("2");
		//create a new person if there is no matching existing person instance
		if(newPerson == null) {
			newPerson = PersonManager.createPerson(firstName, lastName, m_user);
			newContact = ContactManager.createContact(newPerson, m_user);
			System.out.println("CREATED NEW CONTACT");
			String emailAddress = request.getParameter("email");
			if(emailAddress != null){
				try{
					newContact.addEmail(emailAddress, m_user);
				}catch(StringFormatException sfe){
					//TODO: print out an error message or something
				}
			}
			String mobileNumber = request.getParameter("mobilephone");
			if(mobileNumber != null){
				try{
					newContact.setPhoneNumber(mobileNumber, m_user);
				}catch(StringFormatException sfe){
					//TODO: print out an error message or something
				}
			}
		} else {
			System.out.println("CREATED NEW CONTACT USING FOUND INSTANCE");
			newContact = ContactManager.createContact(newPerson, m_user);
		}
	}

	/*
	 * COMMIT SHARE SECTION
	 */
	if(request.getParameter("commitShare") != null && stage.equals(CONFIRM)){ // Set by the share submit button
	
		// stage = CONFIRM;
		log.info(lprefix+"commit share");
	
		//create a share object
		IShare share = ShareManager.createShare(m_user);
		log.info(lprefix+"SHAREID="+share.getID()+" - share created");
		
		//add photos to the share object
		Iterator p_it = photos.iterator();
		while(p_it.hasNext()){
			IPhoto p = (IPhoto)p_it.next();
			try{
				share.addPhoto(p, m_user);
				log.info(lprefix+"SHAREID="+share.getID()+" - add PHOTO_ID="+p.getID());
			}catch(PermissionException pe){/*do nothing*/}
		}
		
		//add albums to share object
		Iterator a_it = shareAlbums.iterator();
		while(a_it.hasNext()){
			IAlbum a = (IAlbum)a_it.next();
			try{
				share.addAlbum(a, m_user);
				log.info(lprefix+"SHAREID="+share.getID()+" - add ALBUM_ID="+a.getID());
			}catch(PermissionException pe){/*do nothing*/}
		}
		
		StringBuffer sb_sharedWith	= new StringBuffer();
		
		//share with individuals
		Iterator r_it = recipients.iterator();
		while(r_it.hasNext()){
			IPerson r = (IPerson)r_it.next();
			try{
				share.addRecipient(r, m_user);
				log.info(lprefix+"SHAREID="+share.getID()+" - add PERSON_ID="+r.getID());
			}
			catch(PermissionException pe){/*do nothing*/}
			
			//Create output stringbuffer
			if(sb_sharedWith.length() > 0){
				sb_sharedWith.append(", ");
			}
			sb_sharedWith.append(r.toString());
		}
		
		//send to contactList
		Iterator cl_it = contactLists.iterator();
		while(cl_it.hasNext()){
			IContactList cl = (IContactList)cl_it.next();
			try{
				share.addRecipient(cl, m_user);
				log.info(lprefix+"SHAREID="+share.getID()+" - add CONTACT_LIST_ID="+cl.getID());
			}catch(PermissionException pe){/*do nothing*/}
			
			//Create output stringbuffer
			if(sb_sharedWith.length() > 0){
				sb_sharedWith.append(", ");
			}
			sb_sharedWith.append(cl.toString());
		}
		
		try{share.setMessage(message, m_user);}
		catch(PermissionException pe){/*do nothing*/}
		
		share.notifyRecipients(false);//commit and tell everyone!
		
		
		//Clean up our mess in the session
		sessionShareData.remove("photos");
		sessionShareData.remove("shareAlbums");
		sessionShareData.remove("recipients");
		sessionShareData.remove("contactLists");
		sessionShareData.remove("newAddresses");
		sessionShareData.remove("message");

		//clean up our mess in the session
		session.removeAttribute("sessionShareData");
		
	} 
	
	// Otherwise, do not commit share
	else 
	{
		sessionShareData.put("photos", photos);
		sessionShareData.put("shareAlbums", shareAlbums);
		sessionShareData.put("recipients", recipients);
		sessionShareData.put("contactLists", contactLists);
		sessionShareData.put("newAddresses", newAddresses);
		sessionShareData.put("message", message);
	}
	
	/*
	 * PHOTO PREPARATION SECTION
	 * Prep all the photos for viewing, or use in guessing;
	 */
	HashSet photosIncludingAlbums = new HashSet();
	
	// Add individual photos
	photosIncludingAlbums.addAll(photos);
	
	// Add photos from albums
	Iterator a_it = shareAlbums.iterator();
	while(a_it.hasNext()){
		IAlbum a = (IAlbum)a_it.next();
		if(a != null){
			//System.out.println("sharemedia.jsp, album a: "+a.getID());
			photosIncludingAlbums.addAll(a.listPhotos());
		}
		
	}
	
%>

<html>
<head>
<title>Share Media</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
<link href="resources/styles/my_pictures.css" rel="stylesheet" type="text/css">
<script language="JavaScript" src="resources/scripts/share_recipients.js"></script>
</head>

<body onload="initialize(document.share_recipients);">
<%@ include file="header.jsp" %>

<%
if(stage.equals(SHARE) || stage.equals(DELPHOTO) || stage.equals(NEW)){
%>

<br><br><br><br>
<h2 style="clear:both;">Share Photos</h2>
<form name="share_recipients" method="get">

    <div class="sharing_left_column">
    <table width="100%" height="100%" border="0" cellspacing="0" cellpadding="5" bgcolor="#eeeeee">
        <tr>
          <td valign="top"><p><b>Addresses:</b></p>
            <p> 
              <input type="radio" name="addressType" value="suggested" onClick="javascript:toggleLayer('suggestedAddresses', 'allAddresses', 'newAddress');" CHECKED>
              Suggested &nbsp;&nbsp;
              <input type="radio" name="addressType" value="all" onClick="javascript:toggleLayer('allAddresses', 'suggestedAddresses', 'newAddress');">
              Address Book &nbsp;&nbsp;
              <input type="radio" name="addressType" value="all" onClick="javascript:toggleLayer('newAddress', 'allAddresses', 'suggestedAddresses');">
              New
              </p>

				<div id="allAddresses">
				<!-- ALL ADDRESSES FROM ADDRESS BOOK -->
				<select name="addresses" size="15" style="width:100%;">
				<% 	
	      		Iterator c_it2 = ContactManager.listContacts(m_user).iterator(); 
	      		while(c_it2.hasNext()){
	      			IContact c = (IContact)c_it2.next();
	      			
	      			EmailAddress e = c.getPrimaryEmail();
	      			String emailAddress = "no email";      			
	      			if(e != null)
	      				emailAddress = e.getAddress();
	      				
	      			out.write("<option value='p."+c.getID()+"'>" + 
	      			c.getFirstName() + " " +
	      			c.getLastName() + ": " +
	      			emailAddress + "</option>");
	      		}
	      		
				Iterator cl_it2 = ContactManager.listContactLists(m_user).iterator();
		        while(cl_it2.hasNext()){
		            IContactList cur_clist = (IContactList)cl_it2.next();
		            if(cur_clist == null){continue;}
		            %>
		            <option value="l.<%=cur_clist.getID()%>"><%=cur_clist.getName() + " (List)"%></option>
		            <%
		        }
				%>
				</select>
				<div class='addButton'><input type='button' onclick='addAddressBookRecipient();' name='addRecipient' value='Add As Recipient'></div>
				</div>
				
				<div id="suggestedAddresses">
				<!-- SUGGESTED RECIPIENTS -->
				<select name="suggestedRecipients" size="15" style="width:100%;">
				<%
				IPhoto photo2 = (IPhoto)photosIncludingAlbums.iterator().next();
	      		Iterator guess_it2 = ClairvoyanceManager.shareGuesser(photo2,m_user, 10).iterator(); 
	      		while(guess_it2.hasNext()){
	      			IPerson p = (IPerson)guess_it2.next();
	      			log.info(lprefix+" - suggesting PERSON_ID="+p.getID());
	      			out.write("<option value='p."+p.getID()+"'>" + 
	      			p.getFirstName() + " " +
	      			p.getLastName() + "</option>");
	      		}
				%>
				</select>
				<div class='addButton'><input type='button' onclick='addSuggestedRecipient();' name='addSuggested' value='Add As Recipient'></div>
				</div>
				
				<div id="newAddress">
				<!-- ADD NEW ADDRESS -->
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
				<tr><td>&nbsp;</td><td align="right"><font color="#CC0000" size="-1">* Required</font></td></tr>
				<tr><td>First Name<font color="#CC0000">*</font>:</td><td align="right"><input name="first" type="text" value="" size="28" maxlength="100"></td></tr>
				<tr><td>Last Name<font color="#CC0000">*</font>:</td><td align="right"><input name="last" type="text" value="" size="28" maxlength="100"></td></tr>
				<tr><td>E-Mail Address<font color="#CC0000">*</font>:</td><td align="right"><input name="email" type="text" value="" size="28" maxlength="100"></td></tr>
				<tr><td>Mobile Phone:</td><td align="right"><input name="mobilephone" type="text" value="" size="28" maxlength="100"></td></tr>
				</table><br>
				<div style='width:100%;text-align:right;'><input type='button' onclick='createNewAddress();' name='addNewAddress' value='Add As Recipient'></div>
				</div>				
		</td>
        </tr>
      </table>
      </div>
          
    <div class="sharing_right_column">
    <table width="100%" border="0" cellspacing="0" cellpadding="5" bgcolor="#eeeeee">
        <tr>
          <td><p><b>Recipient(s):</b></p>
            <p> 
            
        <select style="width:100%;" name="recipients" size="6" multiple>
  		<%
 	    Iterator recipient_it2 = recipients.iterator();
        while(recipient_it2.hasNext()){
           IPerson r = (IPerson)recipient_it2.next();
           if(r != null){
      			out.write("<option value='p."+r.getID()+"'>" + 
      			r.getFirstName() + " " +
      			r.getLastName()+ "</option>");
			}
        }
	    Iterator cl_it3 = contactLists.iterator();
        while(cl_it3.hasNext()){
            IContactList cur_clist = (IContactList)cl_it3.next();
            if(cur_clist != null){
        %>
        	<option value="l.<%=cur_clist.getID()%>"><%=cur_clist.getName() + " (List)"%></option>
        <%
            }
        }
 		if (stage.equals(NEW)) 
		{
			if (newContact != null)  // New address is stored in newContact
			{
		%>
			<option value="l.<%=newContact.getID()%>"><%=newContact.getFirstName() + " " + newContact.getLastName()%></option>
		<%	
			}
		}
        %>
		</select>
		<div style="font-size:8pt;"><a href="javascript:removeRecipient();">Remove Selected</a> | <a href="javascript:removeAllRecipients();">Remove All</a></div>
            </p>
      </td>
        </tr>
        <tr>
          <td><p><b>Message:</b></p>
            <p> 
              <textarea name="message" cols="47" rows="6" wrap="soft"><%=message%></textarea>
            </p>
      </td>
        </tr>
        <tr>
          <td align="right">
          <input type="hidden" name="stage" value="confirm">
          <input type="hidden" name="photoIDDelete" value="">
		  <input type="hidden" name="commitShare" value="Share">
		  <input type="hidden" name="numPhotos" value="<%=photosIncludingAlbums.size()%>">
		  <input type='button' onclick='submitRecipientList();' name='sendRecipients' value='Share'>
          </td>
        </tr>
        <tr>
          <td>

		<!-- photogrid -->
		<%
		if(photosIncludingAlbums != null){
			Iterator i2 = photosIncludingAlbums.iterator();
			while (i2.hasNext()) {
				IPhoto p = (IPhoto)i2.next();
				if(p == null){continue;}
		%><table border="0" border="0" cellspacing="0" cellpadding="5" style="float:left;">
        <tr><td><img class="photo" src="<%=p.getURL(null,null,100)%>"><br>
        <!-- <div class="sharingRemoveThumb"><a href="javascript:removeThumb(<%=p.getID()%>);">Remove</a></div> -->
		</td></tr></table><%   

			}// end while
		}//end if photos
		%>
		<!-- photogrid -->

          </td>
        </tr>
      </table>
      </div>
</form>

<%
}
%>
<br><br><br><br>
<div class="sharing_single_column">
		
		<%
		if(stage.equals(CONFIRM)){
		%>
			<strong>Congratulations! You've shared.</strong><br>
			<br>
			<strong>Shared with:</strong><br>
			
			<% //Display names of recipients shared with
			Iterator r_it2 = recipients.iterator();
			while(r_it2.hasNext()){
				IPerson r = (IPerson)r_it2.next();
				String recipName = r.getFirstName() + " " + r.getLastName();
				%>
				<%=recipName%><br>
			<% } %>
			
			<%
			if(session.getAttribute("actionRedirect") != null){
			%>
		    	<br><a href="<%=(String)session.getAttribute("actionRedirect")%>">Go Back</a><br>
			<%
		    }
    		%>
 			<div><!-- photogrid or list -->
			<%
			if(photosIncludingAlbums != null){
				Iterator i = photosIncludingAlbums.iterator();
				while (i.hasNext()) {
					IPhoto p = (IPhoto)i.next();
					if(p == null){continue;}
			%>
				    <div class="thumbConfirm">
				    <img class="photo" src="<%=p.getURL(null,null,200)%>"><br>
				    <%=p.getCaption()%>
				    </div>
			<%

				}// end while
			}//end if photos
			%>
			</div><!-- photogrid or list -->

		<%
		}//end if 
		%>        
		
</div>

</body>
</html>
