<%@ page language='java' %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="java.util.*" %>
<%

String title = "";
String query = "";
int cols;
ArrayList statsItems = new ArrayList();

title = "List Username And Number Of Photos";
query = "select u.username, count(*) from photo p, mmm_user u where u.id = p.created_by and p.date_inactive is null group by u.username order by 2 desc";
cols = 2;
StatsItem si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Days And Number Of Photos Taken";
query = "select substring(p.date_added for 10), count(*) from photo p group by 1 order by 1 asc";
cols = 2;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Months And Number Of Photos Taken";
query = "select substring(p.date_added for 7), count(*) from photo p group by 1 order by 1 asc";
cols = 2;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Total Number Of Photos";
query = "select count(*) from photo p";
cols = 1;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Total Number Of Active Photos";
query = "select count(*) from photo p where date_inactive is null";
cols = 1;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Photos With Captions";
query = "select created_by, id, caption from photo p where caption not like ''";
cols = 3;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Number Photos With Captions";
query = "select count(*) from photo p where caption not like ''";
cols = 1;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Active Photos With Captions";
query = "select created_by, id, caption from photo p where caption not like '' and date_inactive is null";
cols = 3;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Number Of Active Photos With Captions";
query = "select count(*) from photo p where caption not like '' and date_inactive is null";
cols = 1;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Number Of Shared Photos";
query = "select count(*) from share_photo";
cols = 1;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Number Of Shared Active Photos";
query = "select count(*) from share_photo where date_inactive is null";
cols = 1;
si = new StatsItem(title, query, cols);
statsItems.add(si);

//CHECK IF THESE DISTINGUISH PHOTOS SENT TO MULTIPLE PEOPLE
query = "select substring(date_added for 7), count(*) from share_photo where date_inactive is null group by 1 order by 1 asc";
cols = 2;
si = new StatsItem(title, query, cols);
statsItems.add(si);

title = "List Number Of Photo Takers Per Month";
query = "select DISTINCT substring(date_added for 7), created_by, count(*) from photo where date_inactive is null group by 1,2";
cols = 3;
si = new StatsItem(title, query, cols);
statsItems.add(si);

	
%>

<html>
<h2>MMM2 Stats</h2>

<%
Iterator statsItemsIter = statsItems.iterator();
while(statsItemsIter.hasNext()) {
	StatsItem item = (StatsItem) statsItemsIter.next();
	String link = 	"statsResult.jsp?title=" + item.getTitle() + 
					"&query=" + item.getQuery() +
					"&cols=" + item.getCols(); %>
	<a href="<%=link%>"><%=item.getTitle()%></a><br>
<% } %>
</html>