<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<%@ page language='java'%>
<%@ page import="java.util.*"%>
<%@ page import="gcr.mmm2.model.*"%>
<%@ page import="gcr.mmm2.util.*"%>
<%@ page import="gcr.mmm2.rdb.*"%>
<%@ page import="java.sql.*"%>

<%
		IUser m_user = UserManager.getByUsername(request.getRemoteUser());
		List m_photos = PhotoFactory.listAllVisiblePhotos(m_user);
		Collections.reverse(m_photos);

		%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<script
	src="http://maps.google.com/maps?file=api&v=1&key=ABQIAAAAUXlbYKX_0PwJ-9ZO5JY_9hT3tPGexbVLAdoXQf_P4ESpj2s0rRRE97qtVaTun1dVPIzrtAPa59zvwg"
	type="text/javascript"></script>
<title>MMM GPS Tagged Photos</title>
<link href="resources/styles/master.css" rel="stylesheet"
	type="text/css" />
</head>
<body>
<div id="map" style="width: 1024px; height: 768px"></div>
<script type="text/javascript">
    //<![CDATA[
    
    var map = new GMap(document.getElementById("map"));
    map.addControl(new GSmallMapControl());
    map.centerAndZoom(new GPoint(-122.258300, 37.871960), 4);

	function createMarker(point, html) {
	  var marker = new GMarker(point);
	  GEvent.addListener(marker, "click", function() {
	    marker.openInfoWindowHtml(html);
	  });
	  return marker;
	}
<%  
    Iterator itr = m_photos.iterator();
    int totalCount = 0;
    int gpsCount = 0;
    int hiddenCount = 0;
    
    MultiValueDictionary mvd = new MultiValueDictionary();
    
    while (itr.hasNext()) {
    	totalCount++;
        IPhoto p = (IPhoto) itr.next();
        IContext c = p.getContext();
  
        if(c!=null && !c.getGpsLatitude().equals("0.0")) {
	    	gpsCount++;
	    	double lat = Double.parseDouble(c.getGpsLatitude());
	    	double lng = Double.parseDouble(c.getGpsLongitude());

	    	lat = (Math.round(lat*1000.0))/1000.0;
	    	lng = (Math.round(lng*1000.0))/1000.0;

	    	mvd.put(""+lng+","+lat, p);
	    } else if(c!=null && c.getCellId()!=null) {
	    	String cell = c.getCellId();
	    	ResultSetWrapper rsw = RDBConnection.executeQuery("select * from cell_coverage where cell_id = '"+cell+"'");
        	ResultSet rs = rsw.getResultSet();
        	try {
            	if(rs.next()) {
            		mvd.put(rs.getString("centroid_long")+","+rs.getString("centroid_lat"), p);
            	} else {
            		hiddenCount++;
            	}
	        } catch (SQLException e) {
	            e.printStackTrace();
	        } finally {
	            rsw.closeAll();
	        }
	    }
	}
    
    Enumeration keys = mvd.keys();
    while(keys.hasMoreElements()) {
    	String key = (String)keys.nextElement();
    	out.println("    var point = new GPoint("+key+")");
    	Vector photos = (Vector)mvd.get(key);
    	String html = "";
    	for(int i=0; i<photos.size(); i++) {
    		IPhoto p = (IPhoto)photos.get(i);
    		html += "<img border=\"0\" src=\"" + p.getURL(null,null,100,75) + "\">";
    		if(i!=0 && i%5==0) {
    			html += "<br>";
    		}
    	}
    	out.println("    var marker = new createMarker(point, '"+html+"')");
    	out.println("    map.addOverlay(marker)");
    }
%>

    //]]>
    </script>

Total/GPS/Hidden:
<%=totalCount%>
/
<%=gpsCount%>
/
<%=hiddenCount%>
</body>
</html>

