<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.util.*" %>
<%@ page import="java.util.Hashtable" %>
<%@ page import="java.util.ArrayList" %>
<%
	IUser m_user = UserManager.getByUsername(request.getRemoteUser());
	List m_photos = PhotoFactory.listAllVisiblePhotosByTime(m_user, MediaManager.ALL);
	Collections.reverse(m_photos);
%>
<html>
<head>
<title>Time vs. Location</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
</head>
<body>
  
  	<%@ include file="include_viz_header.jsp" %>

<table border="1" cellpadding="1" cellspacing="0">

<%

	// Table cell background colors
	String emptyCellColor = "#ffffff";
	String fullCellColor = "#ffff99";
	String weekendCellColor = "#dddddd";
	String labelCellColor = "#efefef";
	String tempColor = "";
	

	// Get photos and store them in Iterator object
 	Iterator i = m_photos.iterator();
	Hashtable ht = new Hashtable();
	ArrayList captureDateList = new ArrayList();
	ArrayList cellIdList = new ArrayList();
	
	// Iterate through photos and build hashtable
	//   Key: CAPTUREDATE::CELLID
	//   Value: Number of photos for that CAPTUREDATE::CELLID
	while (i.hasNext()) {
		IPhoto tempPhoto = (IPhoto)i.next();
		Date d = tempPhoto.getCaptureDate();
        if(d.getTime()>startDate && d.getTime()<endDate) {

			IContext tempContext = (IContext)tempPhoto.getContext();
	
			if (tempContext != null) { // if null, no cell ID available -- skip image
				String captureDate = StringUtils.formatMiniDate(tempPhoto.getCaptureDate());
				String cellId = tempContext.getCellId();
				String key = captureDate + "::" + cellId;
				
				// Build unique ArrayLists of Dates and Cell IDs, for axes labels
				if (!captureDateList.contains(captureDate)) captureDateList.add(captureDate);
				if (!cellIdList.contains(cellId)) cellIdList.add(cellId);
				
				// If CAPTUREDATE::CELLID does not exist, it is new, so set as 1
				if (!ht.containsKey(key)) {
					Integer value = new Integer(1);
					ht.put(key, value);
				// If CAPTUREDATE::CELLID does exist, increment
				} else {
					Integer value = (Integer)ht.get(key);
					int valueTemp = value.intValue();
					valueTemp++;
					Integer valueNew = new Integer(valueTemp);
					ht.put(key, valueNew);
				}
			}
		}
	} 
	
 	// Cycle through Cell IDs, one per row
     for (int j=0; j<cellIdList.size(); j++) {
     	String tempCellId = (String)cellIdList.get(j);
     	out.print("<tr><td bgcolor=" + labelCellColor + " style=\"font-size:12px\">" + tempCellId + "</td>");
     	 
     	 // Cycle through Dates, one per column
	     // for (int k=0; k<captureDateList.size(); k++) {
	     //	String tempCaptureDate = (String)captureDateList.get(k);
	     for (long k=startDate;k<endDate;k += 86400000) {
	     	String tempCaptureDate = StringUtils.formatMiniDate(new Date(k));
	     	String key = tempCaptureDate + "::" + tempCellId;
	     	// Use different color for empty cells if weekend
	     	if (tempCaptureDate.substring(12,15).equals("Sat") || tempCaptureDate.substring(12,15).equals("Sun")) {
	     		tempColor = weekendCellColor;
	     	} else {
	     		tempColor = emptyCellColor;
	     	}
	     	if (ht.containsKey(key)) {
	     		Integer value = (Integer)ht.get(key);
 	        	out.println("<td align=center bgcolor=" + fullCellColor + " style=\"font-size:12px\">" + value.intValue() + "</td>");
 	        } else {
 	        	out.println("<td bgcolor=" + tempColor + ">&nbsp;</td>");
 	        }
 	    }  // end for
 	   out.print("</tr>");
     }
     
     // Display Dates across bottom
     out.print("<tr><td bgcolor=" + labelCellColor + ">&nbsp;</td>");
     
	 for (long m=startDate;m<endDate;m += 86400000) {
		 String tempCaptureDate = StringUtils.formatMiniDate(new Date(m));
	     // String tempCaptureDate = (String)captureDateList.get(m);
	     if (tempCaptureDate.substring(12,15).equals("Sat") || tempCaptureDate.substring(12,15).equals("Sun")) {
	     	tempColor = weekendCellColor;
	     } else {
	     	tempColor = labelCellColor;
	     }
	     out.println("<td bgcolor=" + tempColor + " style=\"font-size:11px\">" + 
	     tempCaptureDate.substring(0,5)+tempCaptureDate.substring(8)+
	     "</td>");
		}
		
	 out.print("</tr>");
	
%>
</table>
</body>
</html>