<%@ page language='java' %>
<%@ page import="java.util.*" %>
<%@ page import="gcr.mmm2.model.*" %>
<%@ page import="gcr.mmm2.util.*" %>
<%
	IUser m_user = UserManager.getByUsername(request.getRemoteUser());
	List m_photos = PhotoFactory.listAllOwnedPhotosByTime(m_user, MediaManager.NON_MEDIA);
	// List m_photos = PhotoFactory.listAllVisiblePhotosByTime(m_user, MediaManager.ALL);
	Collections.reverse(m_photos);
%>
<html>
<head>
<title>Photo Capture Volume</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="resources/styles/master.css" rel="stylesheet" type="text/css">
</head>
<body>
<a name="top"></a>
  	<%@ include file="include_viz_header.jsp" %>

<%
	long firstTime = startDate;
	long lastTime = endDate;
    MultiValueDictionary mvd = new MultiValueDictionary();
    
    // Table cell background colors
	String weekdayCellColor = "#ffffff";
	String weekendCellColor = "#dddddd";
	String tempColor = "";


	// ******************************************
	// Photos Taken
	// ******************************************

    Iterator itr = m_photos.iterator();
    while (itr.hasNext()) {
        IPhoto p = (IPhoto) itr.next();
        Date d = p.getCaptureDate();
        if(d.getTime()>startDate && d.getTime()<endDate) {
        
        	// Photos Taken
	        String miniDate = StringUtils.formatMiniDate(d);
	        mvd.put(miniDate, p);
	        firstTime = Math.min(firstTime, d.getTime());
	        lastTime = Math.max(lastTime, d.getTime()); 
        }
    }
%>
<p><a href="#taken">Photos Taken</a><br>
<a href="#shared">Photos Shared</a><br>
<a href="#notShared">Photos Not Shared</a><br>
<a href="#sharedWithMe">Photos Shared with Me</a><br>
</P>

<H3><A name="taken">Photos Taken</a></H3>
<table border="0" cellpadding="0" cellspacing="0"><tr>
<%
    for(long time = firstTime; time<lastTime; time+=(24*60*60*1000)) {
        out.println("<td align=center valign=bottom>");
        String key = StringUtils.formatMiniDate(new Date(time));
        Vector photos = mvd.get(key);
        if(photos!=null) {
	        for (int i = 0; i < photos.size(); i++) {
	            IPhoto p = (IPhoto) photos.get(i);
	            out.println("<img src=\"resources/images/graphics/black.gif\" width=\"2\" height=\"2\"><br>");
	        }
        }
        out.println("<img src=\"resources/images/graphics/black.gif\" width=\"1\" height=\"1\"><br>");
        out.println("</td>");
    }
%>
</tr></table>
<p>


<table border="1" cellpadding="1" cellspacing="0"><tr>
<%
    for(long time = firstTime; time<lastTime; time+=(24*60*60*1000)) {
        String key = StringUtils.formatMiniDate(new Date(time));
   		// Use different color for empty cells if weekend
	    if (key.substring(12,15).equals("Sat") || key.substring(12,15).equals("Sun")) {
	    	tempColor = weekendCellColor;
		} else {
			tempColor = weekdayCellColor;
		}
        out.println("<td align=center valign=bottom width=\"" + thumbSize + "px\" bgcolor=\"" + tempColor + "\"><font size=\"1\">");
        out.println("<img src=\"resources/images/placeholder/shim.gif\" width=\""+ thumbSize +"\" height=\"1\">");
        Vector photos = mvd.get(key);
        if(photos!=null) {
	        out.println("(" + photos.size() + ")<br>");
	        for (int i = 0; i < photos.size(); i++) {
	            IPhoto p = (IPhoto) photos.get(i);
	            out.print("<a href=\"photo_details.jsp?photoID=" + p.getID() + 
	            	"\" target=\"_blank\">");
	            out.print("<img border=\"0\" width=\"" + thumbSize + "\" height=\"" + thumbSize
	            	+ "\" src=\"" + p.getURL(null, null, thumbSize) + "\">");
	            out.print("</a><br>");
	            out.print("<img src=\"resources/images/graphics/black.gif\" width=\"1\" height=\"2\"><br>");
	        }
        }
        out.println(key.substring(0,5)+key.substring(8));
        out.println("</font></td>");
    }
%>
</tr></table>

<a href="#top">[Top of Page]</a>
<!-- *********************
     Photos Shared
     *********************
-->

<%
	m_photos = PhotoFactory.listAllOwnedPhotosByTime(m_user, MediaManager.NON_MEDIA);
	// ******************************************
	// Photos Shared
	// ******************************************

    itr = m_photos.iterator();
    mvd.clear();
    while (itr.hasNext()) {
        IPhoto p = (IPhoto) itr.next();
        Date d = p.getCaptureDate();
        if(d.getTime()>startDate && d.getTime()<endDate && 
        	ShareManager.getPhotoRecipients(p, m_user).size()>0) {
        
        	// Photos shared
	        String miniDate = StringUtils.formatMiniDate(d);
	        mvd.put(miniDate, p);
	        firstTime = Math.min(firstTime, d.getTime());
	        lastTime = Math.max(lastTime, d.getTime());  
        }
    }
%>

<br><br><H3><A name="shared">Photos Shared</a></H3>
<table border="0" cellpadding="0" cellspacing="0"><tr>
<%
    for(long time = firstTime; time<lastTime; time+=(24*60*60*1000)) {
        out.println("<td align=center valign=bottom>");
        String key = StringUtils.formatMiniDate(new Date(time));
        Vector photos = mvd.get(key);
        if(photos!=null) {
	        for (int i = 0; i < photos.size(); i++) {
	            IPhoto p = (IPhoto) photos.get(i);
	            out.println("<img src=\"resources/images/graphics/black.gif\" width=\"2\" height=\"2\"><br>");
	        }
        }
        out.println("<img src=\"resources/images/graphics/black.gif\" width=\"1\" height=\"1\"><br>");
        out.println("</td>");
    }
%>
</tr></table>
<p>


<table border="1" cellpadding="1" cellspacing="0"><tr>
<%
    for(long time = firstTime; time<lastTime; time+=(24*60*60*1000)) {
        String key = StringUtils.formatMiniDate(new Date(time));
   		// Use different color for empty cells if weekend
	    if (key.substring(12,15).equals("Sat") || key.substring(12,15).equals("Sun")) {
	    	tempColor = weekendCellColor;
		} else {
			tempColor = weekdayCellColor;
		}
        out.println("<td align=center valign=bottom width=\"25\" bgcolor=\"" + tempColor + "\"><font size=\"1\">");
        out.println("<img src=\"resources/images/placeholder/shim.gif\" width=\""+ thumbSize +"\" height=\"1\">");
        Vector photos = mvd.get(key);
        if(photos!=null) {
	        out.println("(" + photos.size() + ")<br>");
	        for (int i = 0; i < photos.size(); i++) {
	            IPhoto p = (IPhoto) photos.get(i);
	            out.print("<a href=\"photo_details.jsp?photoID=" + p.getID() + 
	            	"\" target=\"_blank\">");
	            out.print("<img border=\"0\" width=\"" + thumbSize + "\" height=\"" + thumbSize
	            	+ "\" src=\"" + p.getURL(null, null, thumbSize) + "\">");
	            out.print("</a><br>");
	            out.print("<img src=\"resources/images/graphics/black.gif\" width=\"1\" height=\"2\"><br>");
	        }
        }
        out.println(key.substring(0,5)+key.substring(8));
        out.println("</font></td>");
    }
%>
</tr></table>
<a href="#top">[Top of Page]</a>

<!-- *********************
     Photos NOT Shared
     *********************
-->

<%
	m_photos = PhotoFactory.listAllOwnedPhotosByTime(m_user, MediaManager.NON_MEDIA);
	// ******************************************
	// Photos NOT Shared
	// ******************************************

    itr = m_photos.iterator();
    mvd.clear();
    while (itr.hasNext()) {
        IPhoto p = (IPhoto) itr.next();
        Date d = p.getCaptureDate();
        if(d.getTime()>startDate && d.getTime()<endDate && 
        	ShareManager.getPhotoRecipients(p, m_user).size()<1) {
        
        	// Photos shared
	        String miniDate = StringUtils.formatMiniDate(d);
	        mvd.put(miniDate, p);
	        firstTime = Math.min(firstTime, d.getTime());
	        lastTime = Math.max(lastTime, d.getTime());  
        }
    }
%>

<br><br><H3><A name="notShared">Photos Not Shared</a></H3>
<table border="0" cellpadding="0" cellspacing="0"><tr>
<%
    for(long time = firstTime; time<lastTime; time+=(24*60*60*1000)) {
        out.println("<td align=center valign=bottom>");
        String key = StringUtils.formatMiniDate(new Date(time));
        Vector photos = mvd.get(key);
        if(photos!=null) {
	        for (int i = 0; i < photos.size(); i++) {
	            IPhoto p = (IPhoto) photos.get(i);
	            out.println("<img src=\"resources/images/graphics/black.gif\" width=\"2\" height=\"2\"><br>");
	        }
        }
        out.println("<img src=\"resources/images/graphics/black.gif\" width=\"1\" height=\"1\"><br>");
        out.println("</td>");
    }
%>
</tr></table>
<p>


<table border="1" cellpadding="1" cellspacing="0"><tr>
<%
    for(long time = firstTime; time<lastTime; time+=(24*60*60*1000)) {
        String key = StringUtils.formatMiniDate(new Date(time));
   		// Use different color for empty cells if weekend
	    if (key.substring(12,15).equals("Sat") || key.substring(12,15).equals("Sun")) {
	    	tempColor = weekendCellColor;
		} else {
			tempColor = weekdayCellColor;
		}
        out.println("<td align=center valign=bottom width=\"25\" bgcolor=\"" + tempColor + "\"><font size=\"1\">");
        out.println("<img src=\"resources/images/placeholder/shim.gif\" width=\""+ thumbSize +"\" height=\"1\">");
        Vector photos = mvd.get(key);
        if(photos!=null) {
	        out.println("(" + photos.size() + ")<br>");
	        for (int i = 0; i < photos.size(); i++) {
	            IPhoto p = (IPhoto) photos.get(i);
	            out.print("<a href=\"photo_details.jsp?photoID=" + p.getID() + 
	            	"\" target=\"_blank\">");
	            out.print("<img border=\"0\" width=\"" + thumbSize + "\" height=\"" + thumbSize
	            	+ "\" src=\"" + p.getURL(null, null, thumbSize) + "\">");
	            out.print("</a><br>");
	            out.print("<img src=\"resources/images/graphics/black.gif\" width=\"1\" height=\"2\"><br>");
	        }
        }
        out.println(key.substring(0,5)+key.substring(8));
        out.println("</font></td>");
    }
%>
</tr></table>

<!-- *********************
     Photos Shared with me
     *********************
-->
<a href="#top">[Top of Page]</a>

<%
	m_photos = PhotoFactory.listAllVisiblePhotosByTime(m_user, MediaManager.NON_MEDIA);

    itr = m_photos.iterator();
    mvd.clear();
    while (itr.hasNext()) {
        IPhoto p = (IPhoto) itr.next();
        Date d = p.getCaptureDate();
        if(d.getTime()>startDate && d.getTime()<endDate && 
        	p.getOwner().getID() != m_user.getID() ) {
        
        	// Photos shared
	        String miniDate = StringUtils.formatMiniDate(d);
	        mvd.put(miniDate, p);
	        firstTime = Math.min(firstTime, d.getTime());
	        lastTime = Math.max(lastTime, d.getTime());  
        }
    }
%>

<br><br><H3><A name="sharedWithMe">Photos Shared with Me</a></H3>
<table border="0" cellpadding="0" cellspacing="0"><tr>
<%
    for(long time = firstTime; time<lastTime; time+=(24*60*60*1000)) {
        out.println("<td align=center valign=bottom>");
        String key = StringUtils.formatMiniDate(new Date(time));
        Vector photos = mvd.get(key);
        if(photos!=null) {
	        for (int i = 0; i < photos.size(); i++) {
	            IPhoto p = (IPhoto) photos.get(i);
	            out.println("<img src=\"resources/images/graphics/black.gif\" width=\"2\" height=\"2\"><br>");
	        }
        }
        out.println("<img src=\"resources/images/graphics/black.gif\" width=\"1\" height=\"1\"><br>");
        out.println("</td>");
    }
%>
</tr></table>
<p>


<table border="1" cellpadding="1" cellspacing="0"><tr>
<%
    for(long time = firstTime; time<lastTime; time+=(24*60*60*1000)) {
        String key = StringUtils.formatMiniDate(new Date(time));
   		// Use different color for empty cells if weekend
	    if (key.substring(12,15).equals("Sat") || key.substring(12,15).equals("Sun")) {
	    	tempColor = weekendCellColor;
		} else {
			tempColor = weekdayCellColor;
		}
        out.println("<td align=center valign=bottom width=\"25\" bgcolor=\"" + tempColor + "\"><font size=\"1\">");
        out.println("<img src=\"resources/images/placeholder/shim.gif\" width=\""+ thumbSize +"\" height=\"1\">");
        Vector photos = mvd.get(key);
        if(photos!=null) {
	        out.println("(" + photos.size() + ")<br>");
	        for (int i = 0; i < photos.size(); i++) {
	            IPhoto p = (IPhoto) photos.get(i);
	            out.print("<a href=\"photo_details.jsp?photoID=" + p.getID() + 
	            	"\" target=\"_blank\">");
	            out.print("<img border=\"0\" width=\"" + thumbSize + "\" height=\"" + thumbSize
	            	+ "\" src=\"" + p.getURL(null, null, thumbSize) + "\">");
	            out.print("</a><br>");
	            out.print("<img src=\"resources/images/graphics/black.gif\" width=\"1\" height=\"2\"><br>");
	        }
        }
        out.println(key.substring(0,5)+key.substring(8));
        out.println("</font></td>");
    }
%>
</tr></table>
<a href="#top">[Top of Page]</a>
</body>
</html>